//
// Copyright (c) 2003, 2019, Oracle and/or its affiliates. All rights reserved.
// Copyright (c) 2014, 2019, Red Hat Inc.
// All rights reserved.
// DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
//
// This code is free software; you can redistribute it and/or modify it
// under the terms of the GNU General Public License version 2 only, as
// published by the Free Software Foundation.
//
// This code is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
// FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
// version 2 for more details (a copy is included in the LICENSE file that
// accompanied this code).
//
// You should have received a copy of the GNU General Public License version
// 2 along with this work; if not, write to the Free Software Foundation,
// Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
//
// Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
// or visit www.oracle.com if you need additional information or have any
// questions.
//
//

// Machine Generated File.  Do Not Edit!

#include "precompiled.hpp"
#include "adfiles/ad_aarch64.hpp"
#include "opto/cfgnode.hpp"
#include "opto/matcher.hpp"
#include "opto/opcodes.hpp"

//------------------------- Source -----------------------------------------

//------------------------- Attributes -------------------------------------

// AttributeForm 
static const int op_cost = 1;

// AttributeForm 
static const int ins_cost = INSN_COST;

// AttributeForm 
static const int ins_size = 32;

// AttributeForm 
static const int ins_short_branch = 0;

// AttributeForm 
static const int ins_alignment = 4;

//------------------------- Macros -----------------------------------------
#define DFA_PRODUCTION(result, rule, cost)\
  _cost[ (result) ] = cost; _rule[ (result) ] = rule;

#define DFA_PRODUCTION__SET_VALID(result, rule, cost)\
  DFA_PRODUCTION( (result), (rule), (cost) ); STATE__SET_VALID( (result) );

//------------------------- DFA --------------------------------------------
// DFA is a large switch with case statements for each ideal opcode encountered
// in any match rule in the ad file.  Each case has a series of if's to handle
// the match or fail decisions.  The matches test the cost function of that
// rule, and prune any cases which are higher cost for the same reduction.
// In order to generate the DFA we walk the table of ideal opcode/MatchList
// pairs generated by the ADLC front end to build the contents of the case
// statements (a series of if statements).


void  State::_sub_Op_RegN(const Node *n){
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IREGNNOSP, iRegNNoSp_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGN, iRegN_rule, c)
    }
    {
      unsigned int c = 0;
    }
}
void  State::_sub_Op_RegI(const Node *n){
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IREGIHEAPBASE, iRegIHeapbase_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IREGI_R4, iRegI_R4_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IREGI_R3, iRegI_R3_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IREGI_R2, iRegI_R2_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IREGI_R0, iRegI_R0_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IREGINOSP, iRegINoSp_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
    }
    {
      unsigned int c = 0;
    }
}
void  State::_sub_Op_RegP(const Node *n){
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IREGP_FP, iRegP_FP_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IREGP_R10, iRegP_R10_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IREGP_R5, iRegP_R5_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IREGP_R4, iRegP_R4_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IREGP_R3, iRegP_R3_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IREGP_R2, iRegP_R2_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IREGP_R1, iRegP_R1_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IREGP_R0, iRegP_R0_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP, iRegP_rule, c)
        DFA_PRODUCTION__SET_VALID(INLINE_CACHE_REGP, inline_cache_RegP_rule, c)
        DFA_PRODUCTION__SET_VALID(INTERPRETER_METHOD_OOP_REGP, interpreter_method_oop_RegP_rule, c)
        DFA_PRODUCTION__SET_VALID(THREAD_REGP, thread_RegP_rule, c)
        DFA_PRODUCTION__SET_VALID(LR_REGP, lr_RegP_rule, c)
        DFA_PRODUCTION__SET_VALID(INDIRECT, indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(VMEM4, indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(VMEM8, indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(VMEM16, indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IREGPNOSP, iRegPNoSp_rule, c)
    }
    {
      unsigned int c = 0;
    }
}
void  State::_sub_Op_RegF(const Node *n){
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(VREGF, vRegF_rule, c)
    }
}
void  State::_sub_Op_RegD(const Node *n){
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(VREGD_V3, vRegD_V3_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(VREGD_V2, vRegD_V2_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(VREGD_V1, vRegD_V1_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(VREGD_V0, vRegD_V0_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(VREGD, vRegD_rule, c)
    }
}
void  State::_sub_Op_RegL(const Node *n){
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IREGL_R11, iRegL_R11_rule, c)
    }
    {
      unsigned int c = 1;
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, iRegLNoSp_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL, iRegL_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION(IREGL, iRegL_rule, c)	  // overwrites higher cost rule
    }
}
void  State::_sub_Op_RegFlags(const Node *n){
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(RFLAGSREGU, rFlagsRegU_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(RFLAGSREG, rFlagsReg_rule, c)
    }
}
void  State::_sub_Op_VecD(const Node *n){
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(VECD, vecD_rule, c)
    }
}
void  State::_sub_Op_VecX(const Node *n){
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(VECX, vecX_rule, c)
    }
}
void  State::_sub_Op_AbsD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VREGD) ) {
      unsigned int c = _kids[0]->_cost[VREGD]+INSN_COST * 3;
        DFA_PRODUCTION__SET_VALID(VREGD, absD_reg_rule, c)
    }
}
void  State::_sub_Op_AbsF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VREGF) ) {
      unsigned int c = _kids[0]->_cost[VREGF]+INSN_COST * 3;
        DFA_PRODUCTION__SET_VALID(VREGF, absF_reg_rule, c)
    }
}
void  State::_sub_Op_AddD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VREGD) && STATE__VALID_CHILD(_kids[1], VREGD) ) {
      unsigned int c = _kids[0]->_cost[VREGD]+_kids[1]->_cost[VREGD]+INSN_COST * 5;
        DFA_PRODUCTION__SET_VALID(VREGD, addD_reg_reg_rule, c)
    }
}
void  State::_sub_Op_AddF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VREGF) && STATE__VALID_CHILD(_kids[1], VREGF) ) {
      unsigned int c = _kids[0]->_cost[VREGF]+_kids[1]->_cost[VREGF]+INSN_COST * 5;
        DFA_PRODUCTION__SET_VALID(VREGF, addF_reg_reg_rule, c)
    }
}
void  State::_sub_Op_AddI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _ANDI_IREGIORL2I_IMMI_65535) && STATE__VALID_CHILD(_kids[1], IREGIORL2I) ) {
      unsigned int c = _kids[0]->_cost[_ANDI_IREGIORL2I_IMMI_65535]+_kids[1]->_cost[IREGIORL2I] + INSN_COST;
        DFA_PRODUCTION__SET_VALID(IREGINOSP, AddExtI_uxth_and_0_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI, AddExtI_uxth_and_0_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R0, AddExtI_uxth_and_0_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R2, AddExtI_uxth_and_0_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R3, AddExtI_uxth_and_0_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R4, AddExtI_uxth_and_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) && STATE__VALID_CHILD(_kids[1], _ANDI_IREGIORL2I_IMMI_65535) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I]+_kids[1]->_cost[_ANDI_IREGIORL2I_IMMI_65535] + INSN_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, AddExtI_uxth_and_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, AddExtI_uxth_and_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R0) || _cost[IREGI_R0] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R0, AddExtI_uxth_and_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R2) || _cost[IREGI_R2] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R2, AddExtI_uxth_and_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R3) || _cost[IREGI_R3] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R3, AddExtI_uxth_and_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R4) || _cost[IREGI_R4] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R4, AddExtI_uxth_and_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _ANDI_IREGIORL2I_IMMI_255) && STATE__VALID_CHILD(_kids[1], IREGIORL2I) ) {
      unsigned int c = _kids[0]->_cost[_ANDI_IREGIORL2I_IMMI_255]+_kids[1]->_cost[IREGIORL2I] + INSN_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, AddExtI_uxtb_and_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, AddExtI_uxtb_and_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R0) || _cost[IREGI_R0] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R0, AddExtI_uxtb_and_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R2) || _cost[IREGI_R2] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R2, AddExtI_uxtb_and_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R3) || _cost[IREGI_R3] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R3, AddExtI_uxtb_and_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R4) || _cost[IREGI_R4] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R4, AddExtI_uxtb_and_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) && STATE__VALID_CHILD(_kids[1], _ANDI_IREGIORL2I_IMMI_255) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I]+_kids[1]->_cost[_ANDI_IREGIORL2I_IMMI_255] + INSN_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, AddExtI_uxtb_and_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, AddExtI_uxtb_and_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R0) || _cost[IREGI_R0] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R0, AddExtI_uxtb_and_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R2) || _cost[IREGI_R2] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R2, AddExtI_uxtb_and_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R3) || _cost[IREGI_R3] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R3, AddExtI_uxtb_and_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R4) || _cost[IREGI_R4] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R4, AddExtI_uxtb_and_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _URSHIFTI__LSHIFTI_IREGIORL2I_IMMI_24_IMMI_24) && STATE__VALID_CHILD(_kids[1], IREGIORL2I) ) {
      unsigned int c = _kids[0]->_cost[_URSHIFTI__LSHIFTI_IREGIORL2I_IMMI_24_IMMI_24]+_kids[1]->_cost[IREGIORL2I] + INSN_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, AddExtI_uxtb_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, AddExtI_uxtb_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R0) || _cost[IREGI_R0] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R0, AddExtI_uxtb_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R2) || _cost[IREGI_R2] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R2, AddExtI_uxtb_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R3) || _cost[IREGI_R3] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R3, AddExtI_uxtb_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R4) || _cost[IREGI_R4] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R4, AddExtI_uxtb_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) && STATE__VALID_CHILD(_kids[1], _URSHIFTI__LSHIFTI_IREGIORL2I_IMMI_24_IMMI_24) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I]+_kids[1]->_cost[_URSHIFTI__LSHIFTI_IREGIORL2I_IMMI_24_IMMI_24] + INSN_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, AddExtI_uxtb_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, AddExtI_uxtb_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R0) || _cost[IREGI_R0] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R0, AddExtI_uxtb_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R2) || _cost[IREGI_R2] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R2, AddExtI_uxtb_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R3) || _cost[IREGI_R3] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R3, AddExtI_uxtb_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R4) || _cost[IREGI_R4] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R4, AddExtI_uxtb_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _RSHIFTI__LSHIFTI_IREGIORL2I_IMMI_24_IMMI_24) && STATE__VALID_CHILD(_kids[1], IREGIORL2I) ) {
      unsigned int c = _kids[0]->_cost[_RSHIFTI__LSHIFTI_IREGIORL2I_IMMI_24_IMMI_24]+_kids[1]->_cost[IREGIORL2I] + INSN_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, AddExtI_sxtb_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, AddExtI_sxtb_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R0) || _cost[IREGI_R0] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R0, AddExtI_sxtb_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R2) || _cost[IREGI_R2] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R2, AddExtI_sxtb_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R3) || _cost[IREGI_R3] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R3, AddExtI_sxtb_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R4) || _cost[IREGI_R4] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R4, AddExtI_sxtb_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) && STATE__VALID_CHILD(_kids[1], _RSHIFTI__LSHIFTI_IREGIORL2I_IMMI_24_IMMI_24) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I]+_kids[1]->_cost[_RSHIFTI__LSHIFTI_IREGIORL2I_IMMI_24_IMMI_24] + INSN_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, AddExtI_sxtb_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, AddExtI_sxtb_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R0) || _cost[IREGI_R0] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R0, AddExtI_sxtb_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R2) || _cost[IREGI_R2] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R2, AddExtI_sxtb_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R3) || _cost[IREGI_R3] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R3, AddExtI_sxtb_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R4) || _cost[IREGI_R4] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R4, AddExtI_sxtb_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _RSHIFTI__LSHIFTI_IREGIORL2I_IMMI_16_IMMI_16) && STATE__VALID_CHILD(_kids[1], IREGIORL2I) ) {
      unsigned int c = _kids[0]->_cost[_RSHIFTI__LSHIFTI_IREGIORL2I_IMMI_16_IMMI_16]+_kids[1]->_cost[IREGIORL2I] + INSN_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, AddExtI_sxth_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, AddExtI_sxth_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R0) || _cost[IREGI_R0] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R0, AddExtI_sxth_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R2) || _cost[IREGI_R2] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R2, AddExtI_sxth_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R3) || _cost[IREGI_R3] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R3, AddExtI_sxth_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R4) || _cost[IREGI_R4] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R4, AddExtI_sxth_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) && STATE__VALID_CHILD(_kids[1], _RSHIFTI__LSHIFTI_IREGIORL2I_IMMI_16_IMMI_16) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I]+_kids[1]->_cost[_RSHIFTI__LSHIFTI_IREGIORL2I_IMMI_16_IMMI_16] + INSN_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, AddExtI_sxth_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, AddExtI_sxth_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R0) || _cost[IREGI_R0] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R0, AddExtI_sxth_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R2) || _cost[IREGI_R2] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R2, AddExtI_sxth_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R3) || _cost[IREGI_R3] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R3, AddExtI_sxth_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R4) || _cost[IREGI_R4] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R4, AddExtI_sxth_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _URSHIFTI_IREGIORL2I_IMMI) && STATE__VALID_CHILD(_kids[1], _LSHIFTI_IREGIORL2I_IMMI) &&
        (
#line 11012 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
0 == ((n->in(1)->in(2)->get_int() + n->in(2)->in(2)->get_int()) & 31)
#line 484 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_URSHIFTI_IREGIORL2I_IMMI]+_kids[1]->_cost[_LSHIFTI_IREGIORL2I_IMMI] + INSN_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, extrAddI_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, extrAddI_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R0) || _cost[IREGI_R0] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R0, extrAddI_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R2) || _cost[IREGI_R2] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R2, extrAddI_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R3) || _cost[IREGI_R3] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R3, extrAddI_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R4) || _cost[IREGI_R4] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R4, extrAddI_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LSHIFTI_IREGIORL2I_IMMI) && STATE__VALID_CHILD(_kids[1], _URSHIFTI_IREGIORL2I_IMMI) &&
        (
#line 11012 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
0 == ((n->in(1)->in(2)->get_int() + n->in(2)->in(2)->get_int()) & 31)
#line 513 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LSHIFTI_IREGIORL2I_IMMI]+_kids[1]->_cost[_URSHIFTI_IREGIORL2I_IMMI] + INSN_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, extrAddI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, extrAddI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R0) || _cost[IREGI_R0] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R0, extrAddI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R2) || _cost[IREGI_R2] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R2, extrAddI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R3) || _cost[IREGI_R3] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R3, extrAddI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R4) || _cost[IREGI_R4] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R4, extrAddI_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LSHIFTI_IREGIORL2I_IMMI) && STATE__VALID_CHILD(_kids[1], IREGIORL2I) ) {
      unsigned int c = _kids[0]->_cost[_LSHIFTI_IREGIORL2I_IMMI]+_kids[1]->_cost[IREGIORL2I]+1.9 * INSN_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, AddI_reg_LShift_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, AddI_reg_LShift_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R0) || _cost[IREGI_R0] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R0, AddI_reg_LShift_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R2) || _cost[IREGI_R2] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R2, AddI_reg_LShift_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R3) || _cost[IREGI_R3] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R3, AddI_reg_LShift_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R4) || _cost[IREGI_R4] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R4, AddI_reg_LShift_reg_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) && STATE__VALID_CHILD(_kids[1], _LSHIFTI_IREGIORL2I_IMMI) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I]+_kids[1]->_cost[_LSHIFTI_IREGIORL2I_IMMI]+1.9 * INSN_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, AddI_reg_LShift_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, AddI_reg_LShift_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R0) || _cost[IREGI_R0] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R0, AddI_reg_LShift_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R2) || _cost[IREGI_R2] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R2, AddI_reg_LShift_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R3) || _cost[IREGI_R3] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R3, AddI_reg_LShift_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R4) || _cost[IREGI_R4] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R4, AddI_reg_LShift_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _RSHIFTI_IREGIORL2I_IMMI) && STATE__VALID_CHILD(_kids[1], IREGIORL2I) ) {
      unsigned int c = _kids[0]->_cost[_RSHIFTI_IREGIORL2I_IMMI]+_kids[1]->_cost[IREGIORL2I]+1.9 * INSN_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, AddI_reg_RShift_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, AddI_reg_RShift_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R0) || _cost[IREGI_R0] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R0, AddI_reg_RShift_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R2) || _cost[IREGI_R2] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R2, AddI_reg_RShift_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R3) || _cost[IREGI_R3] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R3, AddI_reg_RShift_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R4) || _cost[IREGI_R4] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R4, AddI_reg_RShift_reg_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) && STATE__VALID_CHILD(_kids[1], _RSHIFTI_IREGIORL2I_IMMI) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I]+_kids[1]->_cost[_RSHIFTI_IREGIORL2I_IMMI]+1.9 * INSN_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, AddI_reg_RShift_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, AddI_reg_RShift_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R0) || _cost[IREGI_R0] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R0, AddI_reg_RShift_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R2) || _cost[IREGI_R2] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R2, AddI_reg_RShift_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R3) || _cost[IREGI_R3] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R3, AddI_reg_RShift_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R4) || _cost[IREGI_R4] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R4, AddI_reg_RShift_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _URSHIFTI_IREGIORL2I_IMMI) && STATE__VALID_CHILD(_kids[1], IREGIORL2I) ) {
      unsigned int c = _kids[0]->_cost[_URSHIFTI_IREGIORL2I_IMMI]+_kids[1]->_cost[IREGIORL2I]+1.9 * INSN_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, AddI_reg_URShift_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, AddI_reg_URShift_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R0) || _cost[IREGI_R0] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R0, AddI_reg_URShift_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R2) || _cost[IREGI_R2] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R2, AddI_reg_URShift_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R3) || _cost[IREGI_R3] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R3, AddI_reg_URShift_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R4) || _cost[IREGI_R4] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R4, AddI_reg_URShift_reg_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) && STATE__VALID_CHILD(_kids[1], _URSHIFTI_IREGIORL2I_IMMI) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I]+_kids[1]->_cost[_URSHIFTI_IREGIORL2I_IMMI]+1.9 * INSN_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, AddI_reg_URShift_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, AddI_reg_URShift_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R0) || _cost[IREGI_R0] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R0, AddI_reg_URShift_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R2) || _cost[IREGI_R2] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R2, AddI_reg_URShift_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R3) || _cost[IREGI_R3] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R3, AddI_reg_URShift_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R4) || _cost[IREGI_R4] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R4, AddI_reg_URShift_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _URSHIFTI__RSHIFTI_IREGIORL2I_IMMI_31_IMMI_31) && STATE__VALID_CHILD(_kids[1], IREGIORL2I) &&
        /*src*/(_kids[0]->_kids[0]->_kids[0]->_leaf == _kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_URSHIFTI__RSHIFTI_IREGIORL2I_IMMI_31_IMMI_31]+_kids[1]->_cost[IREGIORL2I] + INSN_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, div2Round_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, div2Round_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R0) || _cost[IREGI_R0] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R0, div2Round_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R2) || _cost[IREGI_R2] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R2, div2Round_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R3) || _cost[IREGI_R3] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R3, div2Round_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R4) || _cost[IREGI_R4] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R4, div2Round_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) && STATE__VALID_CHILD(_kids[1], _URSHIFTI__RSHIFTI_IREGIORL2I_IMMI_31_IMMI_31) &&
        /*src*/(_kids[0]->_leaf == _kids[1]->_kids[0]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I]+_kids[1]->_cost[_URSHIFTI__RSHIFTI_IREGIORL2I_IMMI_31_IMMI_31] + INSN_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, div2Round_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, div2Round_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R0) || _cost[IREGI_R0] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R0, div2Round_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R2) || _cost[IREGI_R2] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R2, div2Round_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R3) || _cost[IREGI_R3] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R3, div2Round_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R4) || _cost[IREGI_R4] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R4, div2Round_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _MULI_IREGIORL2I_IREGIORL2I) && STATE__VALID_CHILD(_kids[1], IREGIORL2I) ) {
      unsigned int c = _kids[0]->_cost[_MULI_IREGIORL2I_IREGIORL2I]+_kids[1]->_cost[IREGIORL2I]+INSN_COST * 3;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, maddI_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, maddI_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R0) || _cost[IREGI_R0] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R0, maddI_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R2) || _cost[IREGI_R2] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R2, maddI_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R3) || _cost[IREGI_R3] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R3, maddI_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R4) || _cost[IREGI_R4] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R4, maddI_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) && STATE__VALID_CHILD(_kids[1], _MULI_IREGIORL2I_IREGIORL2I) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I]+_kids[1]->_cost[_MULI_IREGIORL2I_IREGIORL2I]+INSN_COST * 3;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, maddI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, maddI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R0) || _cost[IREGI_R0] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R0, maddI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R2) || _cost[IREGI_R2] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R2, maddI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R3) || _cost[IREGI_R3] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R3, maddI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R4) || _cost[IREGI_R4] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R4, maddI_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _CONVL2I_IREGL_) && STATE__VALID_CHILD(_kids[1], IMMIADDSUB) ) {
      unsigned int c = _kids[0]->_cost[_CONVL2I_IREGL_]+_kids[1]->_cost[IMMIADDSUB] + INSN_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, addI_reg_imm_i2l_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, addI_reg_imm_i2l_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R0) || _cost[IREGI_R0] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R0, addI_reg_imm_i2l_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R2) || _cost[IREGI_R2] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R2, addI_reg_imm_i2l_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R3) || _cost[IREGI_R3] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R3, addI_reg_imm_i2l_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R4) || _cost[IREGI_R4] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R4, addI_reg_imm_i2l_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) && STATE__VALID_CHILD(_kids[1], IMMIADDSUB) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I]+_kids[1]->_cost[IMMIADDSUB] + INSN_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, addI_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, addI_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R0) || _cost[IREGI_R0] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R0, addI_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R2) || _cost[IREGI_R2] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R2, addI_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R3) || _cost[IREGI_R3] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R3, addI_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R4) || _cost[IREGI_R4] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R4, addI_reg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) && STATE__VALID_CHILD(_kids[1], IREGIORL2I) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I]+_kids[1]->_cost[IREGIORL2I] + INSN_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, addI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, addI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R0) || _cost[IREGI_R0] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R0, addI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R2) || _cost[IREGI_R2] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R2, addI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R3) || _cost[IREGI_R3] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R3, addI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R4) || _cost[IREGI_R4] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R4, addI_reg_reg_rule, c)
      }
    }
}
void  State::_sub_Op_AddL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _ANDL_IREGL_IMML_4294967295) && STATE__VALID_CHILD(_kids[1], IREGL) ) {
      unsigned int c = _kids[0]->_cost[_ANDL_IREGL_IMML_4294967295]+_kids[1]->_cost[IREGL] + INSN_COST;
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, AddExtL_uxtw_and_0_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL, AddExtL_uxtw_and_0_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL_R11, AddExtL_uxtw_and_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], _ANDL_IREGL_IMML_4294967295) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[_ANDL_IREGL_IMML_4294967295] + INSN_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, AddExtL_uxtw_and_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, AddExtL_uxtw_and_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R11) || _cost[IREGL_R11] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R11, AddExtL_uxtw_and_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _ANDL_IREGL_IMML_65535) && STATE__VALID_CHILD(_kids[1], IREGL) ) {
      unsigned int c = _kids[0]->_cost[_ANDL_IREGL_IMML_65535]+_kids[1]->_cost[IREGL] + INSN_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, AddExtL_uxth_and_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, AddExtL_uxth_and_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R11) || _cost[IREGL_R11] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R11, AddExtL_uxth_and_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], _ANDL_IREGL_IMML_65535) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[_ANDL_IREGL_IMML_65535] + INSN_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, AddExtL_uxth_and_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, AddExtL_uxth_and_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R11) || _cost[IREGL_R11] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R11, AddExtL_uxth_and_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _ANDL_IREGL_IMML_255) && STATE__VALID_CHILD(_kids[1], IREGL) ) {
      unsigned int c = _kids[0]->_cost[_ANDL_IREGL_IMML_255]+_kids[1]->_cost[IREGL] + INSN_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, AddExtL_uxtb_and_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, AddExtL_uxtb_and_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R11) || _cost[IREGL_R11] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R11, AddExtL_uxtb_and_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], _ANDL_IREGL_IMML_255) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[_ANDL_IREGL_IMML_255] + INSN_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, AddExtL_uxtb_and_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, AddExtL_uxtb_and_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R11) || _cost[IREGL_R11] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R11, AddExtL_uxtb_and_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _URSHIFTL__LSHIFTL_IREGL_IMMI_56_IMMI_56) && STATE__VALID_CHILD(_kids[1], IREGL) ) {
      unsigned int c = _kids[0]->_cost[_URSHIFTL__LSHIFTL_IREGL_IMMI_56_IMMI_56]+_kids[1]->_cost[IREGL] + INSN_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, AddExtL_uxtb_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, AddExtL_uxtb_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R11) || _cost[IREGL_R11] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R11, AddExtL_uxtb_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], _URSHIFTL__LSHIFTL_IREGL_IMMI_56_IMMI_56) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[_URSHIFTL__LSHIFTL_IREGL_IMMI_56_IMMI_56] + INSN_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, AddExtL_uxtb_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, AddExtL_uxtb_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R11) || _cost[IREGL_R11] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R11, AddExtL_uxtb_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _RSHIFTL__LSHIFTL_IREGL_IMMI_56_IMMI_56) && STATE__VALID_CHILD(_kids[1], IREGL) ) {
      unsigned int c = _kids[0]->_cost[_RSHIFTL__LSHIFTL_IREGL_IMMI_56_IMMI_56]+_kids[1]->_cost[IREGL] + INSN_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, AddExtL_sxtb_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, AddExtL_sxtb_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R11) || _cost[IREGL_R11] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R11, AddExtL_sxtb_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], _RSHIFTL__LSHIFTL_IREGL_IMMI_56_IMMI_56) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[_RSHIFTL__LSHIFTL_IREGL_IMMI_56_IMMI_56] + INSN_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, AddExtL_sxtb_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, AddExtL_sxtb_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R11) || _cost[IREGL_R11] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R11, AddExtL_sxtb_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _RSHIFTL__LSHIFTL_IREGL_IMMI_32_IMMI_32) && STATE__VALID_CHILD(_kids[1], IREGL) ) {
      unsigned int c = _kids[0]->_cost[_RSHIFTL__LSHIFTL_IREGL_IMMI_32_IMMI_32]+_kids[1]->_cost[IREGL] + INSN_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, AddExtL_sxtw_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, AddExtL_sxtw_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R11) || _cost[IREGL_R11] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R11, AddExtL_sxtw_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], _RSHIFTL__LSHIFTL_IREGL_IMMI_32_IMMI_32) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[_RSHIFTL__LSHIFTL_IREGL_IMMI_32_IMMI_32] + INSN_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, AddExtL_sxtw_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, AddExtL_sxtw_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R11) || _cost[IREGL_R11] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R11, AddExtL_sxtw_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _RSHIFTL__LSHIFTL_IREGL_IMMI_48_IMMI_48) && STATE__VALID_CHILD(_kids[1], IREGL) ) {
      unsigned int c = _kids[0]->_cost[_RSHIFTL__LSHIFTL_IREGL_IMMI_48_IMMI_48]+_kids[1]->_cost[IREGL] + INSN_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, AddExtL_sxth_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, AddExtL_sxth_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R11) || _cost[IREGL_R11] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R11, AddExtL_sxth_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], _RSHIFTL__LSHIFTL_IREGL_IMMI_48_IMMI_48) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[_RSHIFTL__LSHIFTL_IREGL_IMMI_48_IMMI_48] + INSN_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, AddExtL_sxth_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, AddExtL_sxth_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R11) || _cost[IREGL_R11] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R11, AddExtL_sxth_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _CONVI2L_IREGIORL2I_) && STATE__VALID_CHILD(_kids[1], IREGL) ) {
      unsigned int c = _kids[0]->_cost[_CONVI2L_IREGIORL2I_]+_kids[1]->_cost[IREGL] + INSN_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, AddExtI_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, AddExtI_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R11) || _cost[IREGL_R11] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R11, AddExtI_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], _CONVI2L_IREGIORL2I_) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[_CONVI2L_IREGIORL2I_] + INSN_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, AddExtI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, AddExtI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R11) || _cost[IREGL_R11] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R11, AddExtI_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _URSHIFTL_IREGL_IMMI) && STATE__VALID_CHILD(_kids[1], _LSHIFTL_IREGL_IMMI) &&
        (
#line 10997 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
0 == ((n->in(1)->in(2)->get_int() + n->in(2)->in(2)->get_int()) & 63)
#line 1044 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_URSHIFTL_IREGL_IMMI]+_kids[1]->_cost[_LSHIFTL_IREGL_IMMI] + INSN_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, extrAddL_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, extrAddL_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R11) || _cost[IREGL_R11] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R11, extrAddL_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LSHIFTL_IREGL_IMMI) && STATE__VALID_CHILD(_kids[1], _URSHIFTL_IREGL_IMMI) &&
        (
#line 10997 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
0 == ((n->in(1)->in(2)->get_int() + n->in(2)->in(2)->get_int()) & 63)
#line 1061 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LSHIFTL_IREGL_IMMI]+_kids[1]->_cost[_URSHIFTL_IREGL_IMMI] + INSN_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, extrAddL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, extrAddL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R11) || _cost[IREGL_R11] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R11, extrAddL_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LSHIFTL_IREGL_IMMI) && STATE__VALID_CHILD(_kids[1], IREGL) ) {
      unsigned int c = _kids[0]->_cost[_LSHIFTL_IREGL_IMMI]+_kids[1]->_cost[IREGL]+1.9 * INSN_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, AddL_reg_LShift_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, AddL_reg_LShift_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R11) || _cost[IREGL_R11] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R11, AddL_reg_LShift_reg_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], _LSHIFTL_IREGL_IMMI) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[_LSHIFTL_IREGL_IMMI]+1.9 * INSN_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, AddL_reg_LShift_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, AddL_reg_LShift_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R11) || _cost[IREGL_R11] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R11, AddL_reg_LShift_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _RSHIFTL_IREGL_IMMI) && STATE__VALID_CHILD(_kids[1], IREGL) ) {
      unsigned int c = _kids[0]->_cost[_RSHIFTL_IREGL_IMMI]+_kids[1]->_cost[IREGL]+1.9 * INSN_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, AddL_reg_RShift_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, AddL_reg_RShift_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R11) || _cost[IREGL_R11] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R11, AddL_reg_RShift_reg_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], _RSHIFTL_IREGL_IMMI) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[_RSHIFTL_IREGL_IMMI]+1.9 * INSN_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, AddL_reg_RShift_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, AddL_reg_RShift_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R11) || _cost[IREGL_R11] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R11, AddL_reg_RShift_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _URSHIFTL_IREGL_IMMI) && STATE__VALID_CHILD(_kids[1], IREGL) ) {
      unsigned int c = _kids[0]->_cost[_URSHIFTL_IREGL_IMMI]+_kids[1]->_cost[IREGL]+1.9 * INSN_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, AddL_reg_URShift_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, AddL_reg_URShift_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R11) || _cost[IREGL_R11] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R11, AddL_reg_URShift_reg_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], _URSHIFTL_IREGL_IMMI) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[_URSHIFTL_IREGL_IMMI]+1.9 * INSN_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, AddL_reg_URShift_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, AddL_reg_URShift_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R11) || _cost[IREGL_R11] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R11, AddL_reg_URShift_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _URSHIFTL__RSHIFTL_IREGL_IMML_63_IMML_63) && STATE__VALID_CHILD(_kids[1], IREGL) &&
        /*src*/(_kids[0]->_kids[0]->_kids[0]->_leaf == _kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_URSHIFTL__RSHIFTL_IREGL_IMML_63_IMML_63]+_kids[1]->_cost[IREGL] + INSN_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, div2RoundL_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, div2RoundL_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R11) || _cost[IREGL_R11] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R11, div2RoundL_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], _URSHIFTL__RSHIFTL_IREGL_IMML_63_IMML_63) &&
        /*src*/(_kids[0]->_leaf == _kids[1]->_kids[0]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[_URSHIFTL__RSHIFTL_IREGL_IMML_63_IMML_63] + INSN_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, div2RoundL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, div2RoundL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R11) || _cost[IREGL_R11] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R11, div2RoundL_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _MULL_IREGL_IREGL) && STATE__VALID_CHILD(_kids[1], IREGL) ) {
      unsigned int c = _kids[0]->_cost[_MULL_IREGL_IREGL]+_kids[1]->_cost[IREGL]+INSN_COST * 5;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, maddL_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, maddL_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R11) || _cost[IREGL_R11] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R11, maddL_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], _MULL_IREGL_IREGL) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[_MULL_IREGL_IREGL]+INSN_COST * 5;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, maddL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, maddL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R11) || _cost[IREGL_R11] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R11, maddL_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IMMLADDSUB) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IMMLADDSUB] + INSN_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, addL_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, addL_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R11) || _cost[IREGL_R11] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R11, addL_reg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IREGL) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IREGL] + INSN_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, addL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, addL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R11) || _cost[IREGL_R11] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R11, addL_reg_reg_rule, c)
      }
    }
}
void  State::_sub_Op_AddP(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGP) && STATE__VALID_CHILD(_kids[1], IMMLADDSUB) ) {
      unsigned int c = _kids[0]->_cost[IREGP]+_kids[1]->_cost[IMMLADDSUB] + INSN_COST;
        DFA_PRODUCTION__SET_VALID(IREGPNOSP, addP_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP, addP_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(INLINE_CACHE_REGP, addP_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(INTERPRETER_METHOD_OOP_REGP, addP_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(THREAD_REGP, addP_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(LR_REGP, addP_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(INDIRECT, addP_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(VMEM4, indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(VMEM8, indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(VMEM16, indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R0, addP_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R1, addP_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R2, addP_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R3, addP_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R4, addP_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R5, addP_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R10, addP_reg_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGP) && STATE__VALID_CHILD(_kids[1], _LSHIFTL__CONVI2L_IREGIORL2I__IMMISCALE) ) {
      unsigned int c = _kids[0]->_cost[IREGP]+_kids[1]->_cost[_LSHIFTL__CONVI2L_IREGIORL2I__IMMISCALE]+1.9 * INSN_COST;
      if (STATE__NOT_YET_VALID(IREGPNOSP) || _cost[IREGPNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGPNOSP, addP_reg_reg_ext_shift_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP) || _cost[IREGP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGP, addP_reg_reg_ext_shift_rule, c)
      }
      if (STATE__NOT_YET_VALID(INLINE_CACHE_REGP) || _cost[INLINE_CACHE_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(INLINE_CACHE_REGP, addP_reg_reg_ext_shift_rule, c)
      }
      if (STATE__NOT_YET_VALID(INTERPRETER_METHOD_OOP_REGP) || _cost[INTERPRETER_METHOD_OOP_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(INTERPRETER_METHOD_OOP_REGP, addP_reg_reg_ext_shift_rule, c)
      }
      if (STATE__NOT_YET_VALID(THREAD_REGP) || _cost[THREAD_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(THREAD_REGP, addP_reg_reg_ext_shift_rule, c)
      }
      if (STATE__NOT_YET_VALID(LR_REGP) || _cost[LR_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(LR_REGP, addP_reg_reg_ext_shift_rule, c)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c) {
        DFA_PRODUCTION__SET_VALID(INDIRECT, addP_reg_reg_ext_shift_rule, c)
      }
      if (STATE__NOT_YET_VALID(VMEM4) || _cost[VMEM4] > c) {
        DFA_PRODUCTION__SET_VALID(VMEM4, indirect_rule, c)
      }
      if (STATE__NOT_YET_VALID(VMEM8) || _cost[VMEM8] > c) {
        DFA_PRODUCTION__SET_VALID(VMEM8, indirect_rule, c)
      }
      if (STATE__NOT_YET_VALID(VMEM16) || _cost[VMEM16] > c) {
        DFA_PRODUCTION__SET_VALID(VMEM16, indirect_rule, c)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R0) || _cost[IREGP_R0] > c) {
        DFA_PRODUCTION__SET_VALID(IREGP_R0, addP_reg_reg_ext_shift_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R1) || _cost[IREGP_R1] > c) {
        DFA_PRODUCTION__SET_VALID(IREGP_R1, addP_reg_reg_ext_shift_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R2) || _cost[IREGP_R2] > c) {
        DFA_PRODUCTION__SET_VALID(IREGP_R2, addP_reg_reg_ext_shift_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R3) || _cost[IREGP_R3] > c) {
        DFA_PRODUCTION__SET_VALID(IREGP_R3, addP_reg_reg_ext_shift_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R4) || _cost[IREGP_R4] > c) {
        DFA_PRODUCTION__SET_VALID(IREGP_R4, addP_reg_reg_ext_shift_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R5) || _cost[IREGP_R5] > c) {
        DFA_PRODUCTION__SET_VALID(IREGP_R5, addP_reg_reg_ext_shift_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R10) || _cost[IREGP_R10] > c) {
        DFA_PRODUCTION__SET_VALID(IREGP_R10, addP_reg_reg_ext_shift_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGP) && STATE__VALID_CHILD(_kids[1], _LSHIFTL_IREGL_IMMISCALE) ) {
      unsigned int c = _kids[0]->_cost[IREGP]+_kids[1]->_cost[_LSHIFTL_IREGL_IMMISCALE]+1.9 * INSN_COST;
      if (STATE__NOT_YET_VALID(IREGPNOSP) || _cost[IREGPNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGPNOSP, addP_reg_reg_lsl_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP) || _cost[IREGP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGP, addP_reg_reg_lsl_rule, c)
      }
      if (STATE__NOT_YET_VALID(INLINE_CACHE_REGP) || _cost[INLINE_CACHE_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(INLINE_CACHE_REGP, addP_reg_reg_lsl_rule, c)
      }
      if (STATE__NOT_YET_VALID(INTERPRETER_METHOD_OOP_REGP) || _cost[INTERPRETER_METHOD_OOP_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(INTERPRETER_METHOD_OOP_REGP, addP_reg_reg_lsl_rule, c)
      }
      if (STATE__NOT_YET_VALID(THREAD_REGP) || _cost[THREAD_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(THREAD_REGP, addP_reg_reg_lsl_rule, c)
      }
      if (STATE__NOT_YET_VALID(LR_REGP) || _cost[LR_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(LR_REGP, addP_reg_reg_lsl_rule, c)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c) {
        DFA_PRODUCTION__SET_VALID(INDIRECT, addP_reg_reg_lsl_rule, c)
      }
      if (STATE__NOT_YET_VALID(VMEM4) || _cost[VMEM4] > c) {
        DFA_PRODUCTION__SET_VALID(VMEM4, indirect_rule, c)
      }
      if (STATE__NOT_YET_VALID(VMEM8) || _cost[VMEM8] > c) {
        DFA_PRODUCTION__SET_VALID(VMEM8, indirect_rule, c)
      }
      if (STATE__NOT_YET_VALID(VMEM16) || _cost[VMEM16] > c) {
        DFA_PRODUCTION__SET_VALID(VMEM16, indirect_rule, c)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R0) || _cost[IREGP_R0] > c) {
        DFA_PRODUCTION__SET_VALID(IREGP_R0, addP_reg_reg_lsl_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R1) || _cost[IREGP_R1] > c) {
        DFA_PRODUCTION__SET_VALID(IREGP_R1, addP_reg_reg_lsl_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R2) || _cost[IREGP_R2] > c) {
        DFA_PRODUCTION__SET_VALID(IREGP_R2, addP_reg_reg_lsl_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R3) || _cost[IREGP_R3] > c) {
        DFA_PRODUCTION__SET_VALID(IREGP_R3, addP_reg_reg_lsl_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R4) || _cost[IREGP_R4] > c) {
        DFA_PRODUCTION__SET_VALID(IREGP_R4, addP_reg_reg_lsl_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R5) || _cost[IREGP_R5] > c) {
        DFA_PRODUCTION__SET_VALID(IREGP_R5, addP_reg_reg_lsl_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R10) || _cost[IREGP_R10] > c) {
        DFA_PRODUCTION__SET_VALID(IREGP_R10, addP_reg_reg_lsl_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGP) && STATE__VALID_CHILD(_kids[1], _CONVI2L_IREGIORL2I_) ) {
      unsigned int c = _kids[0]->_cost[IREGP]+_kids[1]->_cost[_CONVI2L_IREGIORL2I_]+1.9 * INSN_COST;
      if (STATE__NOT_YET_VALID(IREGPNOSP) || _cost[IREGPNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGPNOSP, addP_reg_reg_ext_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP) || _cost[IREGP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGP, addP_reg_reg_ext_rule, c)
      }
      if (STATE__NOT_YET_VALID(INLINE_CACHE_REGP) || _cost[INLINE_CACHE_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(INLINE_CACHE_REGP, addP_reg_reg_ext_rule, c)
      }
      if (STATE__NOT_YET_VALID(INTERPRETER_METHOD_OOP_REGP) || _cost[INTERPRETER_METHOD_OOP_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(INTERPRETER_METHOD_OOP_REGP, addP_reg_reg_ext_rule, c)
      }
      if (STATE__NOT_YET_VALID(THREAD_REGP) || _cost[THREAD_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(THREAD_REGP, addP_reg_reg_ext_rule, c)
      }
      if (STATE__NOT_YET_VALID(LR_REGP) || _cost[LR_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(LR_REGP, addP_reg_reg_ext_rule, c)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c) {
        DFA_PRODUCTION__SET_VALID(INDIRECT, addP_reg_reg_ext_rule, c)
      }
      if (STATE__NOT_YET_VALID(VMEM4) || _cost[VMEM4] > c) {
        DFA_PRODUCTION__SET_VALID(VMEM4, indirect_rule, c)
      }
      if (STATE__NOT_YET_VALID(VMEM8) || _cost[VMEM8] > c) {
        DFA_PRODUCTION__SET_VALID(VMEM8, indirect_rule, c)
      }
      if (STATE__NOT_YET_VALID(VMEM16) || _cost[VMEM16] > c) {
        DFA_PRODUCTION__SET_VALID(VMEM16, indirect_rule, c)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R0) || _cost[IREGP_R0] > c) {
        DFA_PRODUCTION__SET_VALID(IREGP_R0, addP_reg_reg_ext_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R1) || _cost[IREGP_R1] > c) {
        DFA_PRODUCTION__SET_VALID(IREGP_R1, addP_reg_reg_ext_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R2) || _cost[IREGP_R2] > c) {
        DFA_PRODUCTION__SET_VALID(IREGP_R2, addP_reg_reg_ext_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R3) || _cost[IREGP_R3] > c) {
        DFA_PRODUCTION__SET_VALID(IREGP_R3, addP_reg_reg_ext_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R4) || _cost[IREGP_R4] > c) {
        DFA_PRODUCTION__SET_VALID(IREGP_R4, addP_reg_reg_ext_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R5) || _cost[IREGP_R5] > c) {
        DFA_PRODUCTION__SET_VALID(IREGP_R5, addP_reg_reg_ext_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R10) || _cost[IREGP_R10] > c) {
        DFA_PRODUCTION__SET_VALID(IREGP_R10, addP_reg_reg_ext_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGP) && STATE__VALID_CHILD(_kids[1], IREGL) ) {
      unsigned int c = _kids[0]->_cost[IREGP]+_kids[1]->_cost[IREGL] + INSN_COST;
      if (STATE__NOT_YET_VALID(IREGPNOSP) || _cost[IREGPNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGPNOSP, addP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP) || _cost[IREGP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGP, addP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(INLINE_CACHE_REGP) || _cost[INLINE_CACHE_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(INLINE_CACHE_REGP, addP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(INTERPRETER_METHOD_OOP_REGP) || _cost[INTERPRETER_METHOD_OOP_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(INTERPRETER_METHOD_OOP_REGP, addP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(THREAD_REGP) || _cost[THREAD_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(THREAD_REGP, addP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LR_REGP) || _cost[LR_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(LR_REGP, addP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c) {
        DFA_PRODUCTION__SET_VALID(INDIRECT, addP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(VMEM4) || _cost[VMEM4] > c) {
        DFA_PRODUCTION__SET_VALID(VMEM4, indirect_rule, c)
      }
      if (STATE__NOT_YET_VALID(VMEM8) || _cost[VMEM8] > c) {
        DFA_PRODUCTION__SET_VALID(VMEM8, indirect_rule, c)
      }
      if (STATE__NOT_YET_VALID(VMEM16) || _cost[VMEM16] > c) {
        DFA_PRODUCTION__SET_VALID(VMEM16, indirect_rule, c)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R0) || _cost[IREGP_R0] > c) {
        DFA_PRODUCTION__SET_VALID(IREGP_R0, addP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R1) || _cost[IREGP_R1] > c) {
        DFA_PRODUCTION__SET_VALID(IREGP_R1, addP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R2) || _cost[IREGP_R2] > c) {
        DFA_PRODUCTION__SET_VALID(IREGP_R2, addP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R3) || _cost[IREGP_R3] > c) {
        DFA_PRODUCTION__SET_VALID(IREGP_R3, addP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R4) || _cost[IREGP_R4] > c) {
        DFA_PRODUCTION__SET_VALID(IREGP_R4, addP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R5) || _cost[IREGP_R5] > c) {
        DFA_PRODUCTION__SET_VALID(IREGP_R5, addP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R10) || _cost[IREGP_R10] > c) {
        DFA_PRODUCTION__SET_VALID(IREGP_R10, addP_reg_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], THREAD_REGP) && STATE__VALID_CHILD(_kids[1], IMML_PC_OFF) ) {
      unsigned int c = _kids[0]->_cost[THREAD_REGP]+_kids[1]->_cost[IMML_PC_OFF];
        DFA_PRODUCTION__SET_VALID(THREAD_ANCHOR_PC, thread_anchor_pc_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _DECODEN_IREGN_) && STATE__VALID_CHILD(_kids[1], IMMLOFFSET) &&
        
#line 5122 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
Universe::narrow_oop_shift() == 0
#line 1479 "../generated/adfiles/dfa_aarch64.cpp"
 ) {
      unsigned int c = _kids[0]->_cost[_DECODEN_IREGN_]+_kids[1]->_cost[IMMLOFFSET];
        DFA_PRODUCTION__SET_VALID(INDOFFLN, indOffLN_rule, c)
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indOffLN_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _DECODEN_IREGN_) && STATE__VALID_CHILD(_kids[1], IMMIOFFSET) &&
        
#line 5107 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
Universe::narrow_oop_shift() == 0
#line 1491 "../generated/adfiles/dfa_aarch64.cpp"
 ) {
      unsigned int c = _kids[0]->_cost[_DECODEN_IREGN_]+_kids[1]->_cost[IMMIOFFSET];
        DFA_PRODUCTION__SET_VALID(INDOFFIN, indOffIN_rule, c)
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indOffIN_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _DECODEN_IREGN_) && STATE__VALID_CHILD(_kids[1], IREGL) &&
        
#line 5092 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
Universe::narrow_oop_shift() == 0
#line 1503 "../generated/adfiles/dfa_aarch64.cpp"
 ) {
      unsigned int c = _kids[0]->_cost[_DECODEN_IREGN_]+_kids[1]->_cost[IREGL];
        DFA_PRODUCTION__SET_VALID(INDINDEXN, indIndexN_rule, c)
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indIndexN_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _DECODEN_IREGN_) && STATE__VALID_CHILD(_kids[1], _LSHIFTL_IREGL_IMMISCALE) &&
        
#line 5077 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
Universe::narrow_oop_shift() == 0
#line 1515 "../generated/adfiles/dfa_aarch64.cpp"
 ) {
      unsigned int c = _kids[0]->_cost[_DECODEN_IREGN_]+_kids[1]->_cost[_LSHIFTL_IREGL_IMMISCALE];
        DFA_PRODUCTION__SET_VALID(INDINDEXSCALEDN, indIndexScaledN_rule, c)
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indIndexScaledN_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _DECODEN_IREGN_) && STATE__VALID_CHILD(_kids[1], _LSHIFTL__CONVI2L_IREGI__IMMISCALE) &&
        
#line 5062 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
Universe::narrow_oop_shift() == 0
#line 1527 "../generated/adfiles/dfa_aarch64.cpp"
 ) {
      unsigned int c = _kids[0]->_cost[_DECODEN_IREGN_]+_kids[1]->_cost[_LSHIFTL__CONVI2L_IREGI__IMMISCALE];
        DFA_PRODUCTION__SET_VALID(INDINDEXSCALEDI2LN, indIndexScaledI2LN_rule, c)
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indIndexScaledI2LN_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _ADDP__DECODEN_IREGN___LSHIFTL__CONVI2L_IREGI__IMMISCALE) && STATE__VALID_CHILD(_kids[1], IMMLU12) &&
        
#line 5047 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
Universe::narrow_oop_shift() == 0
#line 1539 "../generated/adfiles/dfa_aarch64.cpp"
 ) {
      unsigned int c = _kids[0]->_cost[_ADDP__DECODEN_IREGN___LSHIFTL__CONVI2L_IREGI__IMMISCALE]+_kids[1]->_cost[IMMLU12] + INSN_COST;
        DFA_PRODUCTION__SET_VALID(INDINDEXSCALEDOFFSETI2LN, indIndexScaledOffsetI2LN_rule, c)
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indIndexScaledOffsetI2LN_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _DECODEN_IREGN_) && STATE__VALID_CHILD(_kids[1], _LSHIFTL__CONVI2L_IREGI__IMMISCALE) ) {
      unsigned int c = _kids[0]->_cost[_DECODEN_IREGN_]+_kids[1]->_cost[_LSHIFTL__CONVI2L_IREGI__IMMISCALE];
        DFA_PRODUCTION__SET_VALID(_ADDP__DECODEN_IREGN___LSHIFTL__CONVI2L_IREGI__IMMISCALE, _AddP__DecodeN_iRegN___LShiftL__ConvI2L_iRegI__immIScale_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _ADDP__DECODEN_IREGN___CONVI2L_IREGI_) && STATE__VALID_CHILD(_kids[1], IMMLU12) &&
        
#line 5032 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
Universe::narrow_oop_shift() == 0
#line 1555 "../generated/adfiles/dfa_aarch64.cpp"
 ) {
      unsigned int c = _kids[0]->_cost[_ADDP__DECODEN_IREGN___CONVI2L_IREGI_]+_kids[1]->_cost[IMMLU12] + INSN_COST;
        DFA_PRODUCTION__SET_VALID(INDINDEXOFFSETI2LN, indIndexOffsetI2LN_rule, c)
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indIndexOffsetI2LN_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _DECODEN_IREGN_) && STATE__VALID_CHILD(_kids[1], _CONVI2L_IREGI_) ) {
      unsigned int c = _kids[0]->_cost[_DECODEN_IREGN_]+_kids[1]->_cost[_CONVI2L_IREGI_];
        DFA_PRODUCTION__SET_VALID(_ADDP__DECODEN_IREGN___CONVI2L_IREGI_, _AddP__DecodeN_iRegN___ConvI2L_iRegI__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _ADDP__DECODEN_IREGN___LSHIFTL_IREGL_IMMISCALE) && STATE__VALID_CHILD(_kids[1], IMMLU12) &&
        
#line 5017 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
Universe::narrow_oop_shift() == 0
#line 1571 "../generated/adfiles/dfa_aarch64.cpp"
 ) {
      unsigned int c = _kids[0]->_cost[_ADDP__DECODEN_IREGN___LSHIFTL_IREGL_IMMISCALE]+_kids[1]->_cost[IMMLU12] + INSN_COST;
        DFA_PRODUCTION__SET_VALID(INDINDEXSCALEDOFFSETLN, indIndexScaledOffsetLN_rule, c)
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indIndexScaledOffsetLN_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _ADDP__DECODEN_IREGN___LSHIFTL_IREGL_IMMISCALE) && STATE__VALID_CHILD(_kids[1], IMMIU12) &&
        
#line 5002 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
Universe::narrow_oop_shift() == 0
#line 1583 "../generated/adfiles/dfa_aarch64.cpp"
 ) {
      unsigned int c = _kids[0]->_cost[_ADDP__DECODEN_IREGN___LSHIFTL_IREGL_IMMISCALE]+_kids[1]->_cost[IMMIU12];
        DFA_PRODUCTION__SET_VALID(INDINDEXSCALEDOFFSETIN, indIndexScaledOffsetIN_rule, c)
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indIndexScaledOffsetIN_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _DECODEN_IREGN_) && STATE__VALID_CHILD(_kids[1], _LSHIFTL_IREGL_IMMISCALE) ) {
      unsigned int c = _kids[0]->_cost[_DECODEN_IREGN_]+_kids[1]->_cost[_LSHIFTL_IREGL_IMMISCALE];
        DFA_PRODUCTION__SET_VALID(_ADDP__DECODEN_IREGN___LSHIFTL_IREGL_IMMISCALE, _AddP__DecodeN_iRegN___LShiftL_iRegL_immIScale_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGP) && STATE__VALID_CHILD(_kids[1], IMMLOFFSET16) ) {
      unsigned int c = _kids[0]->_cost[IREGP]+_kids[1]->_cost[IMMLOFFSET16];
        DFA_PRODUCTION__SET_VALID(INDOFFL16, indOffL16_rule, c)
      if (STATE__NOT_YET_VALID(VMEM16) || _cost[VMEM16] > c) {
        DFA_PRODUCTION__SET_VALID(VMEM16, indOffL16_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGP) && STATE__VALID_CHILD(_kids[1], IMMLOFFSET8) ) {
      unsigned int c = _kids[0]->_cost[IREGP]+_kids[1]->_cost[IMMLOFFSET8];
        DFA_PRODUCTION__SET_VALID(INDOFFL8, indOffL8_rule, c)
      if (STATE__NOT_YET_VALID(VMEM8) || _cost[VMEM8] > c) {
        DFA_PRODUCTION__SET_VALID(VMEM8, indOffL8_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGP) && STATE__VALID_CHILD(_kids[1], IMMLOFFSET4) ) {
      unsigned int c = _kids[0]->_cost[IREGP]+_kids[1]->_cost[IMMLOFFSET4];
        DFA_PRODUCTION__SET_VALID(INDOFFL4, indOffL4_rule, c)
      if (STATE__NOT_YET_VALID(VMEM4) || _cost[VMEM4] > c) {
        DFA_PRODUCTION__SET_VALID(VMEM4, indOffL4_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGP) && STATE__VALID_CHILD(_kids[1], IMMLOFFSET) ) {
      unsigned int c = _kids[0]->_cost[IREGP]+_kids[1]->_cost[IMMLOFFSET];
        DFA_PRODUCTION__SET_VALID(INDOFFL, indOffL_rule, c)
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indOffL_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGP) && STATE__VALID_CHILD(_kids[1], IMMIOFFSET16) ) {
      unsigned int c = _kids[0]->_cost[IREGP]+_kids[1]->_cost[IMMIOFFSET16];
        DFA_PRODUCTION__SET_VALID(INDOFFI16, indOffI16_rule, c)
      if (STATE__NOT_YET_VALID(VMEM16) || _cost[VMEM16] > c) {
        DFA_PRODUCTION__SET_VALID(VMEM16, indOffI16_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGP) && STATE__VALID_CHILD(_kids[1], IMMIOFFSET8) ) {
      unsigned int c = _kids[0]->_cost[IREGP]+_kids[1]->_cost[IMMIOFFSET8];
        DFA_PRODUCTION__SET_VALID(INDOFFI8, indOffI8_rule, c)
      if (STATE__NOT_YET_VALID(VMEM8) || _cost[VMEM8] > c) {
        DFA_PRODUCTION__SET_VALID(VMEM8, indOffI8_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGP) && STATE__VALID_CHILD(_kids[1], IMMIOFFSET4) ) {
      unsigned int c = _kids[0]->_cost[IREGP]+_kids[1]->_cost[IMMIOFFSET4];
        DFA_PRODUCTION__SET_VALID(INDOFFI4, indOffI4_rule, c)
      if (STATE__NOT_YET_VALID(VMEM4) || _cost[VMEM4] > c) {
        DFA_PRODUCTION__SET_VALID(VMEM4, indOffI4_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGP) && STATE__VALID_CHILD(_kids[1], IMMIOFFSET) ) {
      unsigned int c = _kids[0]->_cost[IREGP]+_kids[1]->_cost[IMMIOFFSET];
        DFA_PRODUCTION__SET_VALID(INDOFFI, indOffI_rule, c)
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indOffI_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGP) && STATE__VALID_CHILD(_kids[1], IREGL) ) {
      unsigned int c = _kids[0]->_cost[IREGP]+_kids[1]->_cost[IREGL];
        DFA_PRODUCTION__SET_VALID(INDINDEX, indIndex_rule, c)
      if (STATE__NOT_YET_VALID(VMEM4) || _cost[VMEM4] > c) {
        DFA_PRODUCTION__SET_VALID(VMEM4, indIndex_rule, c)
      }
      if (STATE__NOT_YET_VALID(VMEM8) || _cost[VMEM8] > c) {
        DFA_PRODUCTION__SET_VALID(VMEM8, indIndex_rule, c)
      }
      if (STATE__NOT_YET_VALID(VMEM16) || _cost[VMEM16] > c) {
        DFA_PRODUCTION__SET_VALID(VMEM16, indIndex_rule, c)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indIndex_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGP) && STATE__VALID_CHILD(_kids[1], _LSHIFTL_IREGL_IMMISCALE) ) {
      unsigned int c = _kids[0]->_cost[IREGP]+_kids[1]->_cost[_LSHIFTL_IREGL_IMMISCALE];
        DFA_PRODUCTION__SET_VALID(INDINDEXSCALED, indIndexScaled_rule, c)
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indIndexScaled_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGP) && STATE__VALID_CHILD(_kids[1], _LSHIFTL__CONVI2L_IREGI__IMMISCALE) ) {
      unsigned int c = _kids[0]->_cost[IREGP]+_kids[1]->_cost[_LSHIFTL__CONVI2L_IREGI__IMMISCALE];
        DFA_PRODUCTION__SET_VALID(INDINDEXSCALEDI2L, indIndexScaledI2L_rule, c)
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indIndexScaledI2L_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _ADDP_IREGP__LSHIFTL__CONVI2L_IREGI__IMMISCALE) && STATE__VALID_CHILD(_kids[1], IMMLU12) ) {
      unsigned int c = _kids[0]->_cost[_ADDP_IREGP__LSHIFTL__CONVI2L_IREGI__IMMISCALE]+_kids[1]->_cost[IMMLU12] + INSN_COST;
        DFA_PRODUCTION__SET_VALID(INDINDEXSCALEDOFFSETI2L, indIndexScaledOffsetI2L_rule, c)
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indIndexScaledOffsetI2L_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGP) && STATE__VALID_CHILD(_kids[1], _LSHIFTL__CONVI2L_IREGI__IMMISCALE) ) {
      unsigned int c = _kids[0]->_cost[IREGP]+_kids[1]->_cost[_LSHIFTL__CONVI2L_IREGI__IMMISCALE];
        DFA_PRODUCTION__SET_VALID(_ADDP_IREGP__LSHIFTL__CONVI2L_IREGI__IMMISCALE, _AddP_iRegP__LShiftL__ConvI2L_iRegI__immIScale_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _ADDP_IREGP__CONVI2L_IREGI_) && STATE__VALID_CHILD(_kids[1], IMMLU12) ) {
      unsigned int c = _kids[0]->_cost[_ADDP_IREGP__CONVI2L_IREGI_]+_kids[1]->_cost[IMMLU12] + INSN_COST;
        DFA_PRODUCTION__SET_VALID(INDINDEXOFFSETI2L, indIndexOffsetI2L_rule, c)
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indIndexOffsetI2L_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGP) && STATE__VALID_CHILD(_kids[1], _CONVI2L_IREGI_) ) {
      unsigned int c = _kids[0]->_cost[IREGP]+_kids[1]->_cost[_CONVI2L_IREGI_];
        DFA_PRODUCTION__SET_VALID(_ADDP_IREGP__CONVI2L_IREGI_, _AddP_iRegP__ConvI2L_iRegI__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _ADDP_IREGP__LSHIFTL_IREGL_IMMISCALE) && STATE__VALID_CHILD(_kids[1], IMMLU12) ) {
      unsigned int c = _kids[0]->_cost[_ADDP_IREGP__LSHIFTL_IREGL_IMMISCALE]+_kids[1]->_cost[IMMLU12] + INSN_COST;
        DFA_PRODUCTION__SET_VALID(INDINDEXSCALEDOFFSETL, indIndexScaledOffsetL_rule, c)
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indIndexScaledOffsetL_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _ADDP_IREGP__LSHIFTL_IREGL_IMMISCALE) && STATE__VALID_CHILD(_kids[1], IMMIU12) ) {
      unsigned int c = _kids[0]->_cost[_ADDP_IREGP__LSHIFTL_IREGL_IMMISCALE]+_kids[1]->_cost[IMMIU12] + INSN_COST;
        DFA_PRODUCTION__SET_VALID(INDINDEXSCALEDOFFSETI, indIndexScaledOffsetI_rule, c)
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indIndexScaledOffsetI_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGP) && STATE__VALID_CHILD(_kids[1], _LSHIFTL_IREGL_IMMISCALE) ) {
      unsigned int c = _kids[0]->_cost[IREGP]+_kids[1]->_cost[_LSHIFTL_IREGL_IMMISCALE];
        DFA_PRODUCTION__SET_VALID(_ADDP_IREGP__LSHIFTL_IREGL_IMMISCALE, _AddP_iRegP__LShiftL_iRegL_immIScale_rule, c)
    }
}
void  State::_sub_Op_AndI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) && STATE__VALID_CHILD(_kids[1], IREGIORL2I) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I]+_kids[1]->_cost[IREGIORL2I];
        DFA_PRODUCTION__SET_VALID(_ANDI_IREGIORL2I_IREGIORL2I, _AndI_iRegIorL2I_iRegIorL2I_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I]+_kids[1]->_cost[IMMI];
        DFA_PRODUCTION__SET_VALID(_ANDI_IREGIORL2I_IMMI, _AndI_iRegIorL2I_immI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) && STATE__VALID_CHILD(_kids[1], IMMILOG) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I]+_kids[1]->_cost[IMMILOG] + INSN_COST;
        DFA_PRODUCTION__SET_VALID(IREGINOSP, andI_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI, andI_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R0, andI_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R2, andI_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R3, andI_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R4, andI_reg_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) && STATE__VALID_CHILD(_kids[1], IREGIORL2I) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I]+_kids[1]->_cost[IREGIORL2I] + INSN_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, andI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, andI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R0) || _cost[IREGI_R0] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R0, andI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R2) || _cost[IREGI_R2] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R2, andI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R3) || _cost[IREGI_R3] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R3, andI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R4) || _cost[IREGI_R4] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R4, andI_reg_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) && STATE__VALID_CHILD(_kids[1], IMMI_65535) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I]+_kids[1]->_cost[IMMI_65535];
        DFA_PRODUCTION__SET_VALID(_ANDI_IREGIORL2I_IMMI_65535, _AndI_iRegIorL2I_immI_65535_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) && STATE__VALID_CHILD(_kids[1], IMMI_255) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I]+_kids[1]->_cost[IMMI_255];
        DFA_PRODUCTION__SET_VALID(_ANDI_IREGIORL2I_IMMI_255, _AndI_iRegIorL2I_immI_255_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _URSHIFTI_IREGIORL2I_IMMI) && STATE__VALID_CHILD(_kids[1], IMMI_BITMASK) ) {
      unsigned int c = _kids[0]->_cost[_URSHIFTI_IREGIORL2I_IMMI]+_kids[1]->_cost[IMMI_BITMASK];
        DFA_PRODUCTION__SET_VALID(_ANDI__URSHIFTI_IREGIORL2I_IMMI_IMMI_BITMASK, _AndI__URShiftI_iRegIorL2I_immI_immI_bitmask_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _URSHIFTI_IREGIORL2I_IMMI) && STATE__VALID_CHILD(_kids[1], IMMI_BITMASK) &&
        (
#line 10911 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
(exact_log2(n->in(2)->get_int() + 1) + (n->in(1)->in(2)->get_int() & 31)) <= (31 + 1)
#line 1781 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_URSHIFTI_IREGIORL2I_IMMI]+_kids[1]->_cost[IMMI_BITMASK] + INSN_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, ubfxwI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, ubfxwI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R0) || _cost[IREGI_R0] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R0, ubfxwI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R2) || _cost[IREGI_R2] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R2, ubfxwI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R3) || _cost[IREGI_R3] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R3, ubfxwI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R4) || _cost[IREGI_R4] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R4, ubfxwI_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LSHIFTI_IREGIORL2I_IMMI) && STATE__VALID_CHILD(_kids[1], IREGIORL2I) ) {
      unsigned int c = _kids[0]->_cost[_LSHIFTI_IREGIORL2I_IMMI]+_kids[1]->_cost[IREGIORL2I]+1.9 * INSN_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, AndI_reg_LShift_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, AndI_reg_LShift_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R0) || _cost[IREGI_R0] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R0, AndI_reg_LShift_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R2) || _cost[IREGI_R2] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R2, AndI_reg_LShift_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R3) || _cost[IREGI_R3] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R3, AndI_reg_LShift_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R4) || _cost[IREGI_R4] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R4, AndI_reg_LShift_reg_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) && STATE__VALID_CHILD(_kids[1], _LSHIFTI_IREGIORL2I_IMMI) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I]+_kids[1]->_cost[_LSHIFTI_IREGIORL2I_IMMI]+1.9 * INSN_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, AndI_reg_LShift_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, AndI_reg_LShift_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R0) || _cost[IREGI_R0] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R0, AndI_reg_LShift_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R2) || _cost[IREGI_R2] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R2, AndI_reg_LShift_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R3) || _cost[IREGI_R3] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R3, AndI_reg_LShift_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R4) || _cost[IREGI_R4] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R4, AndI_reg_LShift_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _RSHIFTI_IREGIORL2I_IMMI) && STATE__VALID_CHILD(_kids[1], IREGIORL2I) ) {
      unsigned int c = _kids[0]->_cost[_RSHIFTI_IREGIORL2I_IMMI]+_kids[1]->_cost[IREGIORL2I]+1.9 * INSN_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, AndI_reg_RShift_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, AndI_reg_RShift_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R0) || _cost[IREGI_R0] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R0, AndI_reg_RShift_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R2) || _cost[IREGI_R2] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R2, AndI_reg_RShift_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R3) || _cost[IREGI_R3] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R3, AndI_reg_RShift_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R4) || _cost[IREGI_R4] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R4, AndI_reg_RShift_reg_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) && STATE__VALID_CHILD(_kids[1], _RSHIFTI_IREGIORL2I_IMMI) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I]+_kids[1]->_cost[_RSHIFTI_IREGIORL2I_IMMI]+1.9 * INSN_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, AndI_reg_RShift_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, AndI_reg_RShift_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R0) || _cost[IREGI_R0] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R0, AndI_reg_RShift_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R2) || _cost[IREGI_R2] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R2, AndI_reg_RShift_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R3) || _cost[IREGI_R3] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R3, AndI_reg_RShift_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R4) || _cost[IREGI_R4] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R4, AndI_reg_RShift_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _URSHIFTI_IREGIORL2I_IMMI) && STATE__VALID_CHILD(_kids[1], IREGIORL2I) ) {
      unsigned int c = _kids[0]->_cost[_URSHIFTI_IREGIORL2I_IMMI]+_kids[1]->_cost[IREGIORL2I]+1.9 * INSN_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, AndI_reg_URShift_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, AndI_reg_URShift_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R0) || _cost[IREGI_R0] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R0, AndI_reg_URShift_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R2) || _cost[IREGI_R2] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R2, AndI_reg_URShift_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R3) || _cost[IREGI_R3] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R3, AndI_reg_URShift_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R4) || _cost[IREGI_R4] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R4, AndI_reg_URShift_reg_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) && STATE__VALID_CHILD(_kids[1], _URSHIFTI_IREGIORL2I_IMMI) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I]+_kids[1]->_cost[_URSHIFTI_IREGIORL2I_IMMI]+1.9 * INSN_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, AndI_reg_URShift_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, AndI_reg_URShift_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R0) || _cost[IREGI_R0] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R0, AndI_reg_URShift_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R2) || _cost[IREGI_R2] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R2, AndI_reg_URShift_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R3) || _cost[IREGI_R3] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R3, AndI_reg_URShift_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R4) || _cost[IREGI_R4] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R4, AndI_reg_URShift_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _XORI__LSHIFTI_IREGIORL2I_IMMI_IMMI_M1) && STATE__VALID_CHILD(_kids[1], IREGIORL2I) ) {
      unsigned int c = _kids[0]->_cost[_XORI__LSHIFTI_IREGIORL2I_IMMI_IMMI_M1]+_kids[1]->_cost[IREGIORL2I]+1.9 * INSN_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, AndI_reg_LShift_not_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, AndI_reg_LShift_not_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R0) || _cost[IREGI_R0] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R0, AndI_reg_LShift_not_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R2) || _cost[IREGI_R2] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R2, AndI_reg_LShift_not_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R3) || _cost[IREGI_R3] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R3, AndI_reg_LShift_not_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R4) || _cost[IREGI_R4] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R4, AndI_reg_LShift_not_reg_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) && STATE__VALID_CHILD(_kids[1], _XORI__LSHIFTI_IREGIORL2I_IMMI_IMMI_M1) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I]+_kids[1]->_cost[_XORI__LSHIFTI_IREGIORL2I_IMMI_IMMI_M1]+1.9 * INSN_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, AndI_reg_LShift_not_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, AndI_reg_LShift_not_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R0) || _cost[IREGI_R0] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R0, AndI_reg_LShift_not_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R2) || _cost[IREGI_R2] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R2, AndI_reg_LShift_not_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R3) || _cost[IREGI_R3] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R3, AndI_reg_LShift_not_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R4) || _cost[IREGI_R4] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R4, AndI_reg_LShift_not_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _XORI__RSHIFTI_IREGIORL2I_IMMI_IMMI_M1) && STATE__VALID_CHILD(_kids[1], IREGIORL2I) ) {
      unsigned int c = _kids[0]->_cost[_XORI__RSHIFTI_IREGIORL2I_IMMI_IMMI_M1]+_kids[1]->_cost[IREGIORL2I]+1.9 * INSN_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, AndI_reg_RShift_not_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, AndI_reg_RShift_not_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R0) || _cost[IREGI_R0] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R0, AndI_reg_RShift_not_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R2) || _cost[IREGI_R2] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R2, AndI_reg_RShift_not_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R3) || _cost[IREGI_R3] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R3, AndI_reg_RShift_not_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R4) || _cost[IREGI_R4] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R4, AndI_reg_RShift_not_reg_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) && STATE__VALID_CHILD(_kids[1], _XORI__RSHIFTI_IREGIORL2I_IMMI_IMMI_M1) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I]+_kids[1]->_cost[_XORI__RSHIFTI_IREGIORL2I_IMMI_IMMI_M1]+1.9 * INSN_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, AndI_reg_RShift_not_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, AndI_reg_RShift_not_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R0) || _cost[IREGI_R0] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R0, AndI_reg_RShift_not_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R2) || _cost[IREGI_R2] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R2, AndI_reg_RShift_not_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R3) || _cost[IREGI_R3] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R3, AndI_reg_RShift_not_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R4) || _cost[IREGI_R4] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R4, AndI_reg_RShift_not_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _XORI__URSHIFTI_IREGIORL2I_IMMI_IMMI_M1) && STATE__VALID_CHILD(_kids[1], IREGIORL2I) ) {
      unsigned int c = _kids[0]->_cost[_XORI__URSHIFTI_IREGIORL2I_IMMI_IMMI_M1]+_kids[1]->_cost[IREGIORL2I]+1.9 * INSN_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, AndI_reg_URShift_not_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, AndI_reg_URShift_not_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R0) || _cost[IREGI_R0] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R0, AndI_reg_URShift_not_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R2) || _cost[IREGI_R2] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R2, AndI_reg_URShift_not_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R3) || _cost[IREGI_R3] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R3, AndI_reg_URShift_not_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R4) || _cost[IREGI_R4] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R4, AndI_reg_URShift_not_reg_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) && STATE__VALID_CHILD(_kids[1], _XORI__URSHIFTI_IREGIORL2I_IMMI_IMMI_M1) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I]+_kids[1]->_cost[_XORI__URSHIFTI_IREGIORL2I_IMMI_IMMI_M1]+1.9 * INSN_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, AndI_reg_URShift_not_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, AndI_reg_URShift_not_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R0) || _cost[IREGI_R0] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R0, AndI_reg_URShift_not_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R2) || _cost[IREGI_R2] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R2, AndI_reg_URShift_not_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R3) || _cost[IREGI_R3] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R3, AndI_reg_URShift_not_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R4) || _cost[IREGI_R4] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R4, AndI_reg_URShift_not_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _XORI_IREGIORL2I_IMMI_M1) && STATE__VALID_CHILD(_kids[1], IREGIORL2I) ) {
      unsigned int c = _kids[0]->_cost[_XORI_IREGIORL2I_IMMI_M1]+_kids[1]->_cost[IREGIORL2I] + INSN_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, AndI_reg_not_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, AndI_reg_not_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R0) || _cost[IREGI_R0] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R0, AndI_reg_not_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R2) || _cost[IREGI_R2] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R2, AndI_reg_not_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R3) || _cost[IREGI_R3] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R3, AndI_reg_not_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R4) || _cost[IREGI_R4] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R4, AndI_reg_not_reg_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) && STATE__VALID_CHILD(_kids[1], _XORI_IREGIORL2I_IMMI_M1) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I]+_kids[1]->_cost[_XORI_IREGIORL2I_IMMI_M1] + INSN_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, AndI_reg_not_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, AndI_reg_not_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R0) || _cost[IREGI_R0] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R0, AndI_reg_not_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R2) || _cost[IREGI_R2] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R2, AndI_reg_not_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R3) || _cost[IREGI_R3] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R3, AndI_reg_not_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R4) || _cost[IREGI_R4] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R4, AndI_reg_not_reg_rule, c)
      }
    }
}
void  State::_sub_Op_AndL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IREGL) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IREGL];
        DFA_PRODUCTION__SET_VALID(_ANDL_IREGL_IREGL, _AndL_iRegL_iRegL_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IMML) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IMML];
        DFA_PRODUCTION__SET_VALID(_ANDL_IREGL_IMML, _AndL_iRegL_immL_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _CONVI2L_IREGIORL2I_) && STATE__VALID_CHILD(_kids[1], IMML_32BITS) ) {
      unsigned int c = _kids[0]->_cost[_CONVI2L_IREGIORL2I_]+_kids[1]->_cost[IMML_32BITS] + INSN_COST;
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, convUI2L_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL, convUI2L_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL_R11, convUI2L_reg_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IMMLLOG) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IMMLLOG] + INSN_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, andL_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, andL_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R11) || _cost[IREGL_R11] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R11, andL_reg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IREGL) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IREGL] + INSN_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, andL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, andL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R11) || _cost[IREGL_R11] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R11, andL_reg_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IMML_4294967295) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IMML_4294967295];
        DFA_PRODUCTION__SET_VALID(_ANDL_IREGL_IMML_4294967295, _AndL_iRegL_immL_4294967295_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IMML_65535) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IMML_65535];
        DFA_PRODUCTION__SET_VALID(_ANDL_IREGL_IMML_65535, _AndL_iRegL_immL_65535_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IMML_255) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IMML_255];
        DFA_PRODUCTION__SET_VALID(_ANDL_IREGL_IMML_255, _AndL_iRegL_immL_255_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _URSHIFTL_IREGL_IMMI) && STATE__VALID_CHILD(_kids[1], IMML_BITMASK) &&
        (
#line 10928 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
(exact_log2_long(n->in(2)->get_long() + 1) + (n->in(1)->in(2)->get_int() & 63)) <= (63 + 1)
#line 2198 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_URSHIFTL_IREGL_IMMI]+_kids[1]->_cost[IMML_BITMASK] + INSN_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, ubfxL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, ubfxL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R11) || _cost[IREGL_R11] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R11, ubfxL_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LSHIFTL_IREGL_IMMI) && STATE__VALID_CHILD(_kids[1], IREGL) ) {
      unsigned int c = _kids[0]->_cost[_LSHIFTL_IREGL_IMMI]+_kids[1]->_cost[IREGL]+1.9 * INSN_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, AndL_reg_LShift_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, AndL_reg_LShift_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R11) || _cost[IREGL_R11] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R11, AndL_reg_LShift_reg_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], _LSHIFTL_IREGL_IMMI) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[_LSHIFTL_IREGL_IMMI]+1.9 * INSN_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, AndL_reg_LShift_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, AndL_reg_LShift_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R11) || _cost[IREGL_R11] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R11, AndL_reg_LShift_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _RSHIFTL_IREGL_IMMI) && STATE__VALID_CHILD(_kids[1], IREGL) ) {
      unsigned int c = _kids[0]->_cost[_RSHIFTL_IREGL_IMMI]+_kids[1]->_cost[IREGL]+1.9 * INSN_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, AndL_reg_RShift_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, AndL_reg_RShift_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R11) || _cost[IREGL_R11] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R11, AndL_reg_RShift_reg_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], _RSHIFTL_IREGL_IMMI) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[_RSHIFTL_IREGL_IMMI]+1.9 * INSN_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, AndL_reg_RShift_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, AndL_reg_RShift_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R11) || _cost[IREGL_R11] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R11, AndL_reg_RShift_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _URSHIFTL_IREGL_IMMI) && STATE__VALID_CHILD(_kids[1], IREGL) ) {
      unsigned int c = _kids[0]->_cost[_URSHIFTL_IREGL_IMMI]+_kids[1]->_cost[IREGL]+1.9 * INSN_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, AndL_reg_URShift_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, AndL_reg_URShift_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R11) || _cost[IREGL_R11] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R11, AndL_reg_URShift_reg_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], _URSHIFTL_IREGL_IMMI) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[_URSHIFTL_IREGL_IMMI]+1.9 * INSN_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, AndL_reg_URShift_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, AndL_reg_URShift_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R11) || _cost[IREGL_R11] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R11, AndL_reg_URShift_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _XORL__LSHIFTL_IREGL_IMMI_IMML_M1) && STATE__VALID_CHILD(_kids[1], IREGL) ) {
      unsigned int c = _kids[0]->_cost[_XORL__LSHIFTL_IREGL_IMMI_IMML_M1]+_kids[1]->_cost[IREGL]+1.9 * INSN_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, AndL_reg_LShift_not_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, AndL_reg_LShift_not_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R11) || _cost[IREGL_R11] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R11, AndL_reg_LShift_not_reg_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], _XORL__LSHIFTL_IREGL_IMMI_IMML_M1) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[_XORL__LSHIFTL_IREGL_IMMI_IMML_M1]+1.9 * INSN_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, AndL_reg_LShift_not_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, AndL_reg_LShift_not_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R11) || _cost[IREGL_R11] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R11, AndL_reg_LShift_not_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _XORL__RSHIFTL_IREGL_IMMI_IMML_M1) && STATE__VALID_CHILD(_kids[1], IREGL) ) {
      unsigned int c = _kids[0]->_cost[_XORL__RSHIFTL_IREGL_IMMI_IMML_M1]+_kids[1]->_cost[IREGL]+1.9 * INSN_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, AndL_reg_RShift_not_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, AndL_reg_RShift_not_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R11) || _cost[IREGL_R11] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R11, AndL_reg_RShift_not_reg_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], _XORL__RSHIFTL_IREGL_IMMI_IMML_M1) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[_XORL__RSHIFTL_IREGL_IMMI_IMML_M1]+1.9 * INSN_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, AndL_reg_RShift_not_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, AndL_reg_RShift_not_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R11) || _cost[IREGL_R11] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R11, AndL_reg_RShift_not_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _XORL__URSHIFTL_IREGL_IMMI_IMML_M1) && STATE__VALID_CHILD(_kids[1], IREGL) ) {
      unsigned int c = _kids[0]->_cost[_XORL__URSHIFTL_IREGL_IMMI_IMML_M1]+_kids[1]->_cost[IREGL]+1.9 * INSN_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, AndL_reg_URShift_not_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, AndL_reg_URShift_not_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R11) || _cost[IREGL_R11] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R11, AndL_reg_URShift_not_reg_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], _XORL__URSHIFTL_IREGL_IMMI_IMML_M1) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[_XORL__URSHIFTL_IREGL_IMMI_IMML_M1]+1.9 * INSN_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, AndL_reg_URShift_not_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, AndL_reg_URShift_not_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R11) || _cost[IREGL_R11] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R11, AndL_reg_URShift_not_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _XORL_IREGL_IMML_M1) && STATE__VALID_CHILD(_kids[1], IREGL) ) {
      unsigned int c = _kids[0]->_cost[_XORL_IREGL_IMML_M1]+_kids[1]->_cost[IREGL] + INSN_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, AndL_reg_not_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, AndL_reg_not_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R11) || _cost[IREGL_R11] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R11, AndL_reg_not_reg_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], _XORL_IREGL_IMML_M1) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[_XORL_IREGL_IMML_M1] + INSN_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, AndL_reg_not_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, AndL_reg_not_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R11) || _cost[IREGL_R11] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R11, AndL_reg_not_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _CONVI2L__LOADI_INDIRECT__) && STATE__VALID_CHILD(_kids[1], IMML_32BITS) ) {
      unsigned int c = _kids[0]->_cost[_CONVI2L__LOADI_INDIRECT__]+_kids[1]->_cost[IMML_32BITS] + VOLATILE_REF_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, loadUI2L_volatile_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, loadUI2L_volatile_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R11) || _cost[IREGL_R11] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R11, loadUI2L_volatile_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _CONVI2L__LOADI_MEMORY__) && STATE__VALID_CHILD(_kids[1], IMML_32BITS) &&
        (
#line 6442 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
!needs_acquiring_load(n->in(1)->in(1)->as_Load())
#line 2395 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_CONVI2L__LOADI_MEMORY__]+_kids[1]->_cost[IMML_32BITS]+4 * INSN_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, loadUI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, loadUI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R11) || _cost[IREGL_R11] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R11, loadUI2L_rule, c)
      }
    }
}
void  State::_sub_Op_AryEq(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGP_R1) && STATE__VALID_CHILD(_kids[1], IREGP_R2) ) {
      unsigned int c = _kids[0]->_cost[IREGP_R1]+_kids[1]->_cost[IREGP_R2] + INSN_COST;
        DFA_PRODUCTION__SET_VALID(IREGI_R0, array_equals_rule, c)
    }
}
void  State::_sub_Op_Binary(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGP_R1) && STATE__VALID_CHILD(_kids[1], IREGI_R3) ) {
      unsigned int c = _kids[0]->_cost[IREGP_R1]+_kids[1]->_cost[IREGI_R3];
        DFA_PRODUCTION__SET_VALID(_BINARY_IREGP_R1_IREGI_R3, _Binary_iRegP_R1_iRegI_R3_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGP_R1) && STATE__VALID_CHILD(_kids[1], IREGP_R3) ) {
      unsigned int c = _kids[0]->_cost[IREGP_R1]+_kids[1]->_cost[IREGP_R3];
        DFA_PRODUCTION__SET_VALID(_BINARY_IREGP_R1_IREGP_R3, _Binary_iRegP_R1_iRegP_R3_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGP_R3) && STATE__VALID_CHILD(_kids[1], IMMI_LE_4) ) {
      unsigned int c = _kids[0]->_cost[IREGP_R3]+_kids[1]->_cost[IMMI_LE_4];
        DFA_PRODUCTION__SET_VALID(_BINARY_IREGP_R3_IMMI_LE_4, _Binary_iRegP_R3_immI_le_4_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGP_R3) && STATE__VALID_CHILD(_kids[1], IREGI_R2) ) {
      unsigned int c = _kids[0]->_cost[IREGP_R3]+_kids[1]->_cost[IREGI_R2];
        DFA_PRODUCTION__SET_VALID(_BINARY_IREGP_R3_IREGI_R2, _Binary_iRegP_R3_iRegI_R2_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGP_R1) && STATE__VALID_CHILD(_kids[1], IREGI_R4) ) {
      unsigned int c = _kids[0]->_cost[IREGP_R1]+_kids[1]->_cost[IREGI_R4];
        DFA_PRODUCTION__SET_VALID(_BINARY_IREGP_R1_IREGI_R4, _Binary_iRegP_R1_iRegI_R4_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGP_R3) && STATE__VALID_CHILD(_kids[1], IREGI_R4) ) {
      unsigned int c = _kids[0]->_cost[IREGP_R3]+_kids[1]->_cost[IREGI_R4];
        DFA_PRODUCTION__SET_VALID(_BINARY_IREGP_R3_IREGI_R4, _Binary_iRegP_R3_iRegI_R4_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGP_R1) && STATE__VALID_CHILD(_kids[1], IREGI_R2) ) {
      unsigned int c = _kids[0]->_cost[IREGP_R1]+_kids[1]->_cost[IREGI_R2];
        DFA_PRODUCTION__SET_VALID(_BINARY_IREGP_R1_IREGI_R2, _Binary_iRegP_R1_iRegI_R2_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VREGD) && STATE__VALID_CHILD(_kids[1], VREGD) ) {
      unsigned int c = _kids[0]->_cost[VREGD]+_kids[1]->_cost[VREGD];
        DFA_PRODUCTION__SET_VALID(_BINARY_VREGD_VREGD, _Binary_vRegD_vRegD_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VREGF) && STATE__VALID_CHILD(_kids[1], VREGF) ) {
      unsigned int c = _kids[0]->_cost[VREGF]+_kids[1]->_cost[VREGF];
        DFA_PRODUCTION__SET_VALID(_BINARY_VREGF_VREGF, _Binary_vRegF_vRegF_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IMMN0) && STATE__VALID_CHILD(_kids[1], IREGN) ) {
      unsigned int c = _kids[0]->_cost[IMMN0]+_kids[1]->_cost[IREGN];
        DFA_PRODUCTION__SET_VALID(_BINARY_IMMN0_IREGN, _Binary_immN0_iRegN_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGN) && STATE__VALID_CHILD(_kids[1], IMMN0) ) {
      unsigned int c = _kids[0]->_cost[IREGN]+_kids[1]->_cost[IMMN0];
        DFA_PRODUCTION__SET_VALID(_BINARY_IREGN_IMMN0, _Binary_iRegN_immN0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IMMP0) && STATE__VALID_CHILD(_kids[1], IREGP) ) {
      unsigned int c = _kids[0]->_cost[IMMP0]+_kids[1]->_cost[IREGP];
        DFA_PRODUCTION__SET_VALID(_BINARY_IMMP0_IREGP, _Binary_immP0_iRegP_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGP) && STATE__VALID_CHILD(_kids[1], IMMP0) ) {
      unsigned int c = _kids[0]->_cost[IREGP]+_kids[1]->_cost[IMMP0];
        DFA_PRODUCTION__SET_VALID(_BINARY_IREGP_IMMP0, _Binary_iRegP_immP0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IMML0) && STATE__VALID_CHILD(_kids[1], IREGL) ) {
      unsigned int c = _kids[0]->_cost[IMML0]+_kids[1]->_cost[IREGL];
        DFA_PRODUCTION__SET_VALID(_BINARY_IMML0_IREGL, _Binary_immL0_iRegL_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IMML0) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IMML0];
        DFA_PRODUCTION__SET_VALID(_BINARY_IREGL_IMML0, _Binary_iRegL_immL0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IREGL) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IREGL];
        DFA_PRODUCTION__SET_VALID(_BINARY_IREGL_IREGL, _Binary_iRegL_iRegL_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI_1) && STATE__VALID_CHILD(_kids[1], IMMI0) ) {
      unsigned int c = _kids[0]->_cost[IMMI_1]+_kids[1]->_cost[IMMI0];
        DFA_PRODUCTION__SET_VALID(_BINARY_IMMI_1_IMMI0, _Binary_immI_1_immI0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) && STATE__VALID_CHILD(_kids[1], IMMI0) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I]+_kids[1]->_cost[IMMI0];
        DFA_PRODUCTION__SET_VALID(_BINARY_IREGIORL2I_IMMI0, _Binary_iRegIorL2I_immI0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI0) && STATE__VALID_CHILD(_kids[1], IREGIORL2I) ) {
      unsigned int c = _kids[0]->_cost[IMMI0]+_kids[1]->_cost[IREGIORL2I];
        DFA_PRODUCTION__SET_VALID(_BINARY_IMMI0_IREGIORL2I, _Binary_immI0_iRegIorL2I_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOPU) && STATE__VALID_CHILD(_kids[1], RFLAGSREGU) ) {
      unsigned int c = _kids[0]->_cost[CMPOPU]+_kids[1]->_cost[RFLAGSREGU];
        DFA_PRODUCTION__SET_VALID(_BINARY_CMPOPU_RFLAGSREGU, _Binary_cmpOpU_rFlagsRegU_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) && STATE__VALID_CHILD(_kids[1], IREGIORL2I) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I]+_kids[1]->_cost[IREGIORL2I];
        DFA_PRODUCTION__SET_VALID(_BINARY_IREGIORL2I_IREGIORL2I, _Binary_iRegIorL2I_iRegIorL2I_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOP) && STATE__VALID_CHILD(_kids[1], RFLAGSREG) ) {
      unsigned int c = _kids[0]->_cost[CMPOP]+_kids[1]->_cost[RFLAGSREG];
        DFA_PRODUCTION__SET_VALID(_BINARY_CMPOP_RFLAGSREG, _Binary_cmpOp_rFlagsReg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGN) && STATE__VALID_CHILD(_kids[1], IREGN) ) {
      unsigned int c = _kids[0]->_cost[IREGN]+_kids[1]->_cost[IREGN];
        DFA_PRODUCTION__SET_VALID(_BINARY_IREGN_IREGN, _Binary_iRegN_iRegN_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGNNOSP) && STATE__VALID_CHILD(_kids[1], IREGNNOSP) ) {
      unsigned int c = _kids[0]->_cost[IREGNNOSP]+_kids[1]->_cost[IREGNNOSP];
        DFA_PRODUCTION__SET_VALID(_BINARY_IREGNNOSP_IREGNNOSP, _Binary_iRegNNoSp_iRegNNoSp_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGINOSP) && STATE__VALID_CHILD(_kids[1], IREGINOSP) ) {
      unsigned int c = _kids[0]->_cost[IREGINOSP]+_kids[1]->_cost[IREGINOSP];
        DFA_PRODUCTION__SET_VALID(_BINARY_IREGINOSP_IREGINOSP, _Binary_iRegINoSp_iRegINoSp_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGLNOSP) && STATE__VALID_CHILD(_kids[1], IREGLNOSP) ) {
      unsigned int c = _kids[0]->_cost[IREGLNOSP]+_kids[1]->_cost[IREGLNOSP];
        DFA_PRODUCTION__SET_VALID(_BINARY_IREGLNOSP_IREGLNOSP, _Binary_iRegLNoSp_iRegLNoSp_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGP) && STATE__VALID_CHILD(_kids[1], IREGP) ) {
      unsigned int c = _kids[0]->_cost[IREGP]+_kids[1]->_cost[IREGP];
        DFA_PRODUCTION__SET_VALID(_BINARY_IREGP_IREGP, _Binary_iRegP_iRegP_rule, c)
    }
}
void  State::_sub_Op_Bool(const Node *n){
    {
      unsigned int c = 1;
        DFA_PRODUCTION__SET_VALID(CMPOPU, cmpOpU_rule, c)
    }
    {
      unsigned int c = 1;
        DFA_PRODUCTION__SET_VALID(CMPOP, cmpOp_rule, c)
    }
}
void  State::_sub_Op_ReverseBytesI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I] + INSN_COST;
        DFA_PRODUCTION__SET_VALID(IREGINOSP, bytes_reverse_int_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI, bytes_reverse_int_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R0, bytes_reverse_int_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R2, bytes_reverse_int_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R3, bytes_reverse_int_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R4, bytes_reverse_int_rule, c)
    }
}
void  State::_sub_Op_ReverseBytesL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGL) ) {
      unsigned int c = _kids[0]->_cost[IREGL] + INSN_COST;
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, bytes_reverse_long_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL, bytes_reverse_long_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL_R11, bytes_reverse_long_rule, c)
    }
}
void  State::_sub_Op_ReverseBytesUS(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I] + INSN_COST;
        DFA_PRODUCTION__SET_VALID(IREGINOSP, bytes_reverse_unsigned_short_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI, bytes_reverse_unsigned_short_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R0, bytes_reverse_unsigned_short_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R2, bytes_reverse_unsigned_short_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R3, bytes_reverse_unsigned_short_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R4, bytes_reverse_unsigned_short_rule, c)
    }
}
void  State::_sub_Op_ReverseBytesS(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I] + INSN_COST;
        DFA_PRODUCTION__SET_VALID(IREGINOSP, bytes_reverse_short_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI, bytes_reverse_short_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R0, bytes_reverse_short_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R2, bytes_reverse_short_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R3, bytes_reverse_short_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R4, bytes_reverse_short_rule, c)
    }
}
void  State::_sub_Op_CallDynamicJava(const Node *n){
    {
      unsigned int c = CALL_COST;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, CallDynamicJavaDirect_rule, c)
    }
}
void  State::_sub_Op_CallLeaf(const Node *n){
    {
      unsigned int c = CALL_COST;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, CallLeafDirect_rule, c)
    }
}
void  State::_sub_Op_CallLeafNoFP(const Node *n){
    {
      unsigned int c = CALL_COST;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, CallLeafNoFPDirect_rule, c)
    }
}
void  State::_sub_Op_CallRuntime(const Node *n){
    {
      unsigned int c = CALL_COST;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, CallRuntimeDirect_rule, c)
    }
}
void  State::_sub_Op_CallStaticJava(const Node *n){
    if(         (
#line 13725 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
((CallStaticJavaNode*)n)->is_method_handle_invoke()
#line 2607 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = CALL_COST;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, CallStaticJavaDirectHandle_rule, c)
    }
    if(         (
#line 13703 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
!((CallStaticJavaNode*)n)->is_method_handle_invoke()
#line 2615 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = CALL_COST;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, CallStaticJavaDirect_rule, c)
      }
    }
}
void  State::_sub_Op_CastII(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGI) ) {
      unsigned int c = _kids[0]->_cost[IREGI];
        DFA_PRODUCTION__SET_VALID(IREGI, castII_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
    }
}
void  State::_sub_Op_CastX2P(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGL) ) {
      unsigned int c = _kids[0]->_cost[IREGL] + INSN_COST;
        DFA_PRODUCTION__SET_VALID(IREGPNOSP, castX2P_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP, castX2P_rule, c)
        DFA_PRODUCTION__SET_VALID(INLINE_CACHE_REGP, castX2P_rule, c)
        DFA_PRODUCTION__SET_VALID(INTERPRETER_METHOD_OOP_REGP, castX2P_rule, c)
        DFA_PRODUCTION__SET_VALID(THREAD_REGP, castX2P_rule, c)
        DFA_PRODUCTION__SET_VALID(LR_REGP, castX2P_rule, c)
        DFA_PRODUCTION__SET_VALID(INDIRECT, castX2P_rule, c)
        DFA_PRODUCTION__SET_VALID(VMEM4, indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(VMEM8, indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(VMEM16, indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R0, castX2P_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R1, castX2P_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R2, castX2P_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R3, castX2P_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R4, castX2P_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R5, castX2P_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R10, castX2P_rule, c)
    }
}
void  State::_sub_Op_CastP2X(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _DECODEN_IREGN_) ) {
      unsigned int c = _kids[0]->_cost[_DECODEN_IREGN_];
        DFA_PRODUCTION__SET_VALID(_CASTP2X__DECODEN_IREGN__, _CastP2X__DecodeN_iRegN___rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGP) ) {
      unsigned int c = _kids[0]->_cost[IREGP];
        DFA_PRODUCTION__SET_VALID(_CASTP2X_IREGP_, _CastP2X_iRegP__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGP) ) {
      unsigned int c = _kids[0]->_cost[IREGP] + INSN_COST;
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, castP2X_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL, castP2X_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL_R11, castP2X_rule, c)
    }
}
void  State::_sub_Op_CastPP(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGPNOSP) ) {
      unsigned int c = _kids[0]->_cost[IREGPNOSP] + INSN_COST;
        DFA_PRODUCTION__SET_VALID(IREGPNOSP, castPP_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP, castPP_rule, c)
        DFA_PRODUCTION__SET_VALID(INLINE_CACHE_REGP, castPP_rule, c)
        DFA_PRODUCTION__SET_VALID(INTERPRETER_METHOD_OOP_REGP, castPP_rule, c)
        DFA_PRODUCTION__SET_VALID(THREAD_REGP, castPP_rule, c)
        DFA_PRODUCTION__SET_VALID(LR_REGP, castPP_rule, c)
        DFA_PRODUCTION__SET_VALID(INDIRECT, castPP_rule, c)
        DFA_PRODUCTION__SET_VALID(VMEM4, indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(VMEM8, indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(VMEM16, indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R0, castPP_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R1, castPP_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R2, castPP_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R3, castPP_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R4, castPP_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R5, castPP_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R10, castPP_rule, c)
    }
}
void  State::_sub_Op_CheckCastPP(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGPNOSP) ) {
      unsigned int c = _kids[0]->_cost[IREGPNOSP] + INSN_COST;
        DFA_PRODUCTION__SET_VALID(IREGPNOSP, checkCastPP_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP, checkCastPP_rule, c)
        DFA_PRODUCTION__SET_VALID(INLINE_CACHE_REGP, checkCastPP_rule, c)
        DFA_PRODUCTION__SET_VALID(INTERPRETER_METHOD_OOP_REGP, checkCastPP_rule, c)
        DFA_PRODUCTION__SET_VALID(THREAD_REGP, checkCastPP_rule, c)
        DFA_PRODUCTION__SET_VALID(LR_REGP, checkCastPP_rule, c)
        DFA_PRODUCTION__SET_VALID(INDIRECT, checkCastPP_rule, c)
        DFA_PRODUCTION__SET_VALID(VMEM4, indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(VMEM8, indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(VMEM16, indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R0, checkCastPP_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R1, checkCastPP_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R2, checkCastPP_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R3, checkCastPP_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R4, checkCastPP_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R5, checkCastPP_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R10, checkCastPP_rule, c)
    }
}
void  State::_sub_Op_ClearArray(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IMML) && STATE__VALID_CHILD(_kids[1], IREGP_R10) ) {
      unsigned int c = _kids[0]->_cost[IMML]+_kids[1]->_cost[IREGP_R10]+4 * INSN_COST;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, clearArray_imm_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL_R11) && STATE__VALID_CHILD(_kids[1], IREGP_R10) ) {
      unsigned int c = _kids[0]->_cost[IREGL_R11]+_kids[1]->_cost[IREGP_R10]+4 * INSN_COST;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, clearArray_reg_reg_rule, c)
      }
    }
}
void  State::_sub_Op_CMoveD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOPU_RFLAGSREGU) && STATE__VALID_CHILD(_kids[1], _BINARY_VREGD_VREGD) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOPU_RFLAGSREGU]+_kids[1]->_cost[_BINARY_VREGD_VREGD]+INSN_COST * 3;
        DFA_PRODUCTION__SET_VALID(VREGD, cmovUD_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP_RFLAGSREG) && STATE__VALID_CHILD(_kids[1], _BINARY_VREGD_VREGD) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP_RFLAGSREG]+_kids[1]->_cost[_BINARY_VREGD_VREGD]+INSN_COST * 3;
      if (STATE__NOT_YET_VALID(VREGD) || _cost[VREGD] > c) {
        DFA_PRODUCTION__SET_VALID(VREGD, cmovD_reg_rule, c)
      }
    }
}
void  State::_sub_Op_CMoveF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOPU_RFLAGSREGU) && STATE__VALID_CHILD(_kids[1], _BINARY_VREGF_VREGF) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOPU_RFLAGSREGU]+_kids[1]->_cost[_BINARY_VREGF_VREGF]+INSN_COST * 3;
        DFA_PRODUCTION__SET_VALID(VREGF, cmovUF_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP_RFLAGSREG) && STATE__VALID_CHILD(_kids[1], _BINARY_VREGF_VREGF) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP_RFLAGSREG]+_kids[1]->_cost[_BINARY_VREGF_VREGF]+INSN_COST * 3;
      if (STATE__NOT_YET_VALID(VREGF) || _cost[VREGF] > c) {
        DFA_PRODUCTION__SET_VALID(VREGF, cmovF_reg_rule, c)
      }
    }
}
void  State::_sub_Op_CMoveI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOPU_RFLAGSREGU) && STATE__VALID_CHILD(_kids[1], _BINARY_IMMI_1_IMMI0) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOPU_RFLAGSREGU]+_kids[1]->_cost[_BINARY_IMMI_1_IMMI0]+INSN_COST * 2;
        DFA_PRODUCTION__SET_VALID(IREGINOSP, cmovUI_reg_zero_one_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI, cmovUI_reg_zero_one_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R0, cmovUI_reg_zero_one_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R2, cmovUI_reg_zero_one_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R3, cmovUI_reg_zero_one_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R4, cmovUI_reg_zero_one_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP_RFLAGSREG) && STATE__VALID_CHILD(_kids[1], _BINARY_IMMI_1_IMMI0) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP_RFLAGSREG]+_kids[1]->_cost[_BINARY_IMMI_1_IMMI0]+INSN_COST * 2;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, cmovI_reg_zero_one_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, cmovI_reg_zero_one_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R0) || _cost[IREGI_R0] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R0, cmovI_reg_zero_one_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R2) || _cost[IREGI_R2] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R2, cmovI_reg_zero_one_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R3) || _cost[IREGI_R3] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R3, cmovI_reg_zero_one_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R4) || _cost[IREGI_R4] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R4, cmovI_reg_zero_one_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOPU_RFLAGSREGU) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGIORL2I_IMMI0) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOPU_RFLAGSREGU]+_kids[1]->_cost[_BINARY_IREGIORL2I_IMMI0]+INSN_COST * 2;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, cmovUI_reg_zero_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, cmovUI_reg_zero_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R0) || _cost[IREGI_R0] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R0, cmovUI_reg_zero_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R2) || _cost[IREGI_R2] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R2, cmovUI_reg_zero_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R3) || _cost[IREGI_R3] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R3, cmovUI_reg_zero_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R4) || _cost[IREGI_R4] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R4, cmovUI_reg_zero_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP_RFLAGSREG) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGIORL2I_IMMI0) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP_RFLAGSREG]+_kids[1]->_cost[_BINARY_IREGIORL2I_IMMI0]+INSN_COST * 2;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, cmovI_reg_zero_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, cmovI_reg_zero_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R0) || _cost[IREGI_R0] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R0, cmovI_reg_zero_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R2) || _cost[IREGI_R2] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R2, cmovI_reg_zero_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R3) || _cost[IREGI_R3] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R3, cmovI_reg_zero_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R4) || _cost[IREGI_R4] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R4, cmovI_reg_zero_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOPU_RFLAGSREGU) && STATE__VALID_CHILD(_kids[1], _BINARY_IMMI0_IREGIORL2I) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOPU_RFLAGSREGU]+_kids[1]->_cost[_BINARY_IMMI0_IREGIORL2I]+INSN_COST * 2;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, cmovUI_zero_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, cmovUI_zero_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R0) || _cost[IREGI_R0] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R0, cmovUI_zero_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R2) || _cost[IREGI_R2] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R2, cmovUI_zero_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R3) || _cost[IREGI_R3] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R3, cmovUI_zero_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R4) || _cost[IREGI_R4] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R4, cmovUI_zero_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP_RFLAGSREG) && STATE__VALID_CHILD(_kids[1], _BINARY_IMMI0_IREGIORL2I) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP_RFLAGSREG]+_kids[1]->_cost[_BINARY_IMMI0_IREGIORL2I]+INSN_COST * 2;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, cmovI_zero_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, cmovI_zero_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R0) || _cost[IREGI_R0] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R0, cmovI_zero_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R2) || _cost[IREGI_R2] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R2, cmovI_zero_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R3) || _cost[IREGI_R3] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R3, cmovI_zero_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R4) || _cost[IREGI_R4] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R4, cmovI_zero_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOPU_RFLAGSREGU) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGIORL2I_IREGIORL2I) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOPU_RFLAGSREGU]+_kids[1]->_cost[_BINARY_IREGIORL2I_IREGIORL2I]+INSN_COST * 2;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, cmovUI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, cmovUI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R0) || _cost[IREGI_R0] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R0, cmovUI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R2) || _cost[IREGI_R2] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R2, cmovUI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R3) || _cost[IREGI_R3] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R3, cmovUI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R4) || _cost[IREGI_R4] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R4, cmovUI_reg_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP_RFLAGSREG) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGIORL2I_IREGIORL2I) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP_RFLAGSREG]+_kids[1]->_cost[_BINARY_IREGIORL2I_IREGIORL2I]+INSN_COST * 2;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, cmovI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, cmovI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R0) || _cost[IREGI_R0] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R0, cmovI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R2) || _cost[IREGI_R2] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R2, cmovI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R3) || _cost[IREGI_R3] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R3, cmovI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R4) || _cost[IREGI_R4] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R4, cmovI_reg_reg_rule, c)
      }
    }
}
void  State::_sub_Op_CMoveL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOPU_RFLAGSREGU) && STATE__VALID_CHILD(_kids[1], _BINARY_IMML0_IREGL) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOPU_RFLAGSREGU]+_kids[1]->_cost[_BINARY_IMML0_IREGL]+INSN_COST * 2;
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, cmovUL_zero_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL, cmovUL_zero_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL_R11, cmovUL_zero_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP_RFLAGSREG) && STATE__VALID_CHILD(_kids[1], _BINARY_IMML0_IREGL) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP_RFLAGSREG]+_kids[1]->_cost[_BINARY_IMML0_IREGL]+INSN_COST * 2;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, cmovL_zero_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, cmovL_zero_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R11) || _cost[IREGL_R11] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R11, cmovL_zero_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOPU_RFLAGSREGU) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGL_IMML0) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOPU_RFLAGSREGU]+_kids[1]->_cost[_BINARY_IREGL_IMML0]+INSN_COST * 2;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, cmovUL_reg_zero_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, cmovUL_reg_zero_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R11) || _cost[IREGL_R11] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R11, cmovUL_reg_zero_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP_RFLAGSREG) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGL_IMML0) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP_RFLAGSREG]+_kids[1]->_cost[_BINARY_IREGL_IMML0]+INSN_COST * 2;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, cmovL_reg_zero_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, cmovL_reg_zero_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R11) || _cost[IREGL_R11] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R11, cmovL_reg_zero_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOPU_RFLAGSREGU) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGL_IREGL) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOPU_RFLAGSREGU]+_kids[1]->_cost[_BINARY_IREGL_IREGL]+INSN_COST * 2;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, cmovUL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, cmovUL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R11) || _cost[IREGL_R11] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R11, cmovUL_reg_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP_RFLAGSREG) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGL_IREGL) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP_RFLAGSREG]+_kids[1]->_cost[_BINARY_IREGL_IREGL]+INSN_COST * 2;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, cmovL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, cmovL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R11) || _cost[IREGL_R11] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R11, cmovL_reg_reg_rule, c)
      }
    }
}
void  State::_sub_Op_CMoveP(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOPU_RFLAGSREGU) && STATE__VALID_CHILD(_kids[1], _BINARY_IMMP0_IREGP) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOPU_RFLAGSREGU]+_kids[1]->_cost[_BINARY_IMMP0_IREGP]+INSN_COST * 2;
        DFA_PRODUCTION__SET_VALID(IREGPNOSP, cmovUP_zero_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP, cmovUP_zero_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(INLINE_CACHE_REGP, cmovUP_zero_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(INTERPRETER_METHOD_OOP_REGP, cmovUP_zero_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(THREAD_REGP, cmovUP_zero_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(LR_REGP, cmovUP_zero_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(INDIRECT, cmovUP_zero_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(VMEM4, indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(VMEM8, indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(VMEM16, indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R0, cmovUP_zero_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R1, cmovUP_zero_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R2, cmovUP_zero_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R3, cmovUP_zero_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R4, cmovUP_zero_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R5, cmovUP_zero_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R10, cmovUP_zero_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP_RFLAGSREG) && STATE__VALID_CHILD(_kids[1], _BINARY_IMMP0_IREGP) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP_RFLAGSREG]+_kids[1]->_cost[_BINARY_IMMP0_IREGP]+INSN_COST * 2;
      if (STATE__NOT_YET_VALID(IREGPNOSP) || _cost[IREGPNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGPNOSP, cmovP_zero_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP) || _cost[IREGP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGP, cmovP_zero_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(INLINE_CACHE_REGP) || _cost[INLINE_CACHE_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(INLINE_CACHE_REGP, cmovP_zero_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(INTERPRETER_METHOD_OOP_REGP) || _cost[INTERPRETER_METHOD_OOP_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(INTERPRETER_METHOD_OOP_REGP, cmovP_zero_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(THREAD_REGP) || _cost[THREAD_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(THREAD_REGP, cmovP_zero_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LR_REGP) || _cost[LR_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(LR_REGP, cmovP_zero_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c) {
        DFA_PRODUCTION__SET_VALID(INDIRECT, cmovP_zero_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(VMEM4) || _cost[VMEM4] > c) {
        DFA_PRODUCTION__SET_VALID(VMEM4, indirect_rule, c)
      }
      if (STATE__NOT_YET_VALID(VMEM8) || _cost[VMEM8] > c) {
        DFA_PRODUCTION__SET_VALID(VMEM8, indirect_rule, c)
      }
      if (STATE__NOT_YET_VALID(VMEM16) || _cost[VMEM16] > c) {
        DFA_PRODUCTION__SET_VALID(VMEM16, indirect_rule, c)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R0) || _cost[IREGP_R0] > c) {
        DFA_PRODUCTION__SET_VALID(IREGP_R0, cmovP_zero_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R1) || _cost[IREGP_R1] > c) {
        DFA_PRODUCTION__SET_VALID(IREGP_R1, cmovP_zero_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R2) || _cost[IREGP_R2] > c) {
        DFA_PRODUCTION__SET_VALID(IREGP_R2, cmovP_zero_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R3) || _cost[IREGP_R3] > c) {
        DFA_PRODUCTION__SET_VALID(IREGP_R3, cmovP_zero_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R4) || _cost[IREGP_R4] > c) {
        DFA_PRODUCTION__SET_VALID(IREGP_R4, cmovP_zero_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R5) || _cost[IREGP_R5] > c) {
        DFA_PRODUCTION__SET_VALID(IREGP_R5, cmovP_zero_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R10) || _cost[IREGP_R10] > c) {
        DFA_PRODUCTION__SET_VALID(IREGP_R10, cmovP_zero_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOPU_RFLAGSREGU) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGP_IMMP0) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOPU_RFLAGSREGU]+_kids[1]->_cost[_BINARY_IREGP_IMMP0]+INSN_COST * 2;
      if (STATE__NOT_YET_VALID(IREGPNOSP) || _cost[IREGPNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGPNOSP, cmovUP_reg_zero_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP) || _cost[IREGP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGP, cmovUP_reg_zero_rule, c)
      }
      if (STATE__NOT_YET_VALID(INLINE_CACHE_REGP) || _cost[INLINE_CACHE_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(INLINE_CACHE_REGP, cmovUP_reg_zero_rule, c)
      }
      if (STATE__NOT_YET_VALID(INTERPRETER_METHOD_OOP_REGP) || _cost[INTERPRETER_METHOD_OOP_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(INTERPRETER_METHOD_OOP_REGP, cmovUP_reg_zero_rule, c)
      }
      if (STATE__NOT_YET_VALID(THREAD_REGP) || _cost[THREAD_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(THREAD_REGP, cmovUP_reg_zero_rule, c)
      }
      if (STATE__NOT_YET_VALID(LR_REGP) || _cost[LR_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(LR_REGP, cmovUP_reg_zero_rule, c)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c) {
        DFA_PRODUCTION__SET_VALID(INDIRECT, cmovUP_reg_zero_rule, c)
      }
      if (STATE__NOT_YET_VALID(VMEM4) || _cost[VMEM4] > c) {
        DFA_PRODUCTION__SET_VALID(VMEM4, indirect_rule, c)
      }
      if (STATE__NOT_YET_VALID(VMEM8) || _cost[VMEM8] > c) {
        DFA_PRODUCTION__SET_VALID(VMEM8, indirect_rule, c)
      }
      if (STATE__NOT_YET_VALID(VMEM16) || _cost[VMEM16] > c) {
        DFA_PRODUCTION__SET_VALID(VMEM16, indirect_rule, c)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R0) || _cost[IREGP_R0] > c) {
        DFA_PRODUCTION__SET_VALID(IREGP_R0, cmovUP_reg_zero_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R1) || _cost[IREGP_R1] > c) {
        DFA_PRODUCTION__SET_VALID(IREGP_R1, cmovUP_reg_zero_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R2) || _cost[IREGP_R2] > c) {
        DFA_PRODUCTION__SET_VALID(IREGP_R2, cmovUP_reg_zero_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R3) || _cost[IREGP_R3] > c) {
        DFA_PRODUCTION__SET_VALID(IREGP_R3, cmovUP_reg_zero_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R4) || _cost[IREGP_R4] > c) {
        DFA_PRODUCTION__SET_VALID(IREGP_R4, cmovUP_reg_zero_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R5) || _cost[IREGP_R5] > c) {
        DFA_PRODUCTION__SET_VALID(IREGP_R5, cmovUP_reg_zero_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R10) || _cost[IREGP_R10] > c) {
        DFA_PRODUCTION__SET_VALID(IREGP_R10, cmovUP_reg_zero_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP_RFLAGSREG) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGP_IMMP0) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP_RFLAGSREG]+_kids[1]->_cost[_BINARY_IREGP_IMMP0]+INSN_COST * 2;
      if (STATE__NOT_YET_VALID(IREGPNOSP) || _cost[IREGPNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGPNOSP, cmovP_reg_zero_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP) || _cost[IREGP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGP, cmovP_reg_zero_rule, c)
      }
      if (STATE__NOT_YET_VALID(INLINE_CACHE_REGP) || _cost[INLINE_CACHE_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(INLINE_CACHE_REGP, cmovP_reg_zero_rule, c)
      }
      if (STATE__NOT_YET_VALID(INTERPRETER_METHOD_OOP_REGP) || _cost[INTERPRETER_METHOD_OOP_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(INTERPRETER_METHOD_OOP_REGP, cmovP_reg_zero_rule, c)
      }
      if (STATE__NOT_YET_VALID(THREAD_REGP) || _cost[THREAD_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(THREAD_REGP, cmovP_reg_zero_rule, c)
      }
      if (STATE__NOT_YET_VALID(LR_REGP) || _cost[LR_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(LR_REGP, cmovP_reg_zero_rule, c)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c) {
        DFA_PRODUCTION__SET_VALID(INDIRECT, cmovP_reg_zero_rule, c)
      }
      if (STATE__NOT_YET_VALID(VMEM4) || _cost[VMEM4] > c) {
        DFA_PRODUCTION__SET_VALID(VMEM4, indirect_rule, c)
      }
      if (STATE__NOT_YET_VALID(VMEM8) || _cost[VMEM8] > c) {
        DFA_PRODUCTION__SET_VALID(VMEM8, indirect_rule, c)
      }
      if (STATE__NOT_YET_VALID(VMEM16) || _cost[VMEM16] > c) {
        DFA_PRODUCTION__SET_VALID(VMEM16, indirect_rule, c)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R0) || _cost[IREGP_R0] > c) {
        DFA_PRODUCTION__SET_VALID(IREGP_R0, cmovP_reg_zero_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R1) || _cost[IREGP_R1] > c) {
        DFA_PRODUCTION__SET_VALID(IREGP_R1, cmovP_reg_zero_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R2) || _cost[IREGP_R2] > c) {
        DFA_PRODUCTION__SET_VALID(IREGP_R2, cmovP_reg_zero_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R3) || _cost[IREGP_R3] > c) {
        DFA_PRODUCTION__SET_VALID(IREGP_R3, cmovP_reg_zero_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R4) || _cost[IREGP_R4] > c) {
        DFA_PRODUCTION__SET_VALID(IREGP_R4, cmovP_reg_zero_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R5) || _cost[IREGP_R5] > c) {
        DFA_PRODUCTION__SET_VALID(IREGP_R5, cmovP_reg_zero_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R10) || _cost[IREGP_R10] > c) {
        DFA_PRODUCTION__SET_VALID(IREGP_R10, cmovP_reg_zero_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOPU_RFLAGSREGU) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGP_IREGP) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOPU_RFLAGSREGU]+_kids[1]->_cost[_BINARY_IREGP_IREGP]+INSN_COST * 2;
      if (STATE__NOT_YET_VALID(IREGPNOSP) || _cost[IREGPNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGPNOSP, cmovUP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP) || _cost[IREGP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGP, cmovUP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(INLINE_CACHE_REGP) || _cost[INLINE_CACHE_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(INLINE_CACHE_REGP, cmovUP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(INTERPRETER_METHOD_OOP_REGP) || _cost[INTERPRETER_METHOD_OOP_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(INTERPRETER_METHOD_OOP_REGP, cmovUP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(THREAD_REGP) || _cost[THREAD_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(THREAD_REGP, cmovUP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LR_REGP) || _cost[LR_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(LR_REGP, cmovUP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c) {
        DFA_PRODUCTION__SET_VALID(INDIRECT, cmovUP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(VMEM4) || _cost[VMEM4] > c) {
        DFA_PRODUCTION__SET_VALID(VMEM4, indirect_rule, c)
      }
      if (STATE__NOT_YET_VALID(VMEM8) || _cost[VMEM8] > c) {
        DFA_PRODUCTION__SET_VALID(VMEM8, indirect_rule, c)
      }
      if (STATE__NOT_YET_VALID(VMEM16) || _cost[VMEM16] > c) {
        DFA_PRODUCTION__SET_VALID(VMEM16, indirect_rule, c)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R0) || _cost[IREGP_R0] > c) {
        DFA_PRODUCTION__SET_VALID(IREGP_R0, cmovUP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R1) || _cost[IREGP_R1] > c) {
        DFA_PRODUCTION__SET_VALID(IREGP_R1, cmovUP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R2) || _cost[IREGP_R2] > c) {
        DFA_PRODUCTION__SET_VALID(IREGP_R2, cmovUP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R3) || _cost[IREGP_R3] > c) {
        DFA_PRODUCTION__SET_VALID(IREGP_R3, cmovUP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R4) || _cost[IREGP_R4] > c) {
        DFA_PRODUCTION__SET_VALID(IREGP_R4, cmovUP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R5) || _cost[IREGP_R5] > c) {
        DFA_PRODUCTION__SET_VALID(IREGP_R5, cmovUP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R10) || _cost[IREGP_R10] > c) {
        DFA_PRODUCTION__SET_VALID(IREGP_R10, cmovUP_reg_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP_RFLAGSREG) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGP_IREGP) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP_RFLAGSREG]+_kids[1]->_cost[_BINARY_IREGP_IREGP]+INSN_COST * 2;
      if (STATE__NOT_YET_VALID(IREGPNOSP) || _cost[IREGPNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGPNOSP, cmovP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP) || _cost[IREGP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGP, cmovP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(INLINE_CACHE_REGP) || _cost[INLINE_CACHE_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(INLINE_CACHE_REGP, cmovP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(INTERPRETER_METHOD_OOP_REGP) || _cost[INTERPRETER_METHOD_OOP_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(INTERPRETER_METHOD_OOP_REGP, cmovP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(THREAD_REGP) || _cost[THREAD_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(THREAD_REGP, cmovP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LR_REGP) || _cost[LR_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(LR_REGP, cmovP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c) {
        DFA_PRODUCTION__SET_VALID(INDIRECT, cmovP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(VMEM4) || _cost[VMEM4] > c) {
        DFA_PRODUCTION__SET_VALID(VMEM4, indirect_rule, c)
      }
      if (STATE__NOT_YET_VALID(VMEM8) || _cost[VMEM8] > c) {
        DFA_PRODUCTION__SET_VALID(VMEM8, indirect_rule, c)
      }
      if (STATE__NOT_YET_VALID(VMEM16) || _cost[VMEM16] > c) {
        DFA_PRODUCTION__SET_VALID(VMEM16, indirect_rule, c)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R0) || _cost[IREGP_R0] > c) {
        DFA_PRODUCTION__SET_VALID(IREGP_R0, cmovP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R1) || _cost[IREGP_R1] > c) {
        DFA_PRODUCTION__SET_VALID(IREGP_R1, cmovP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R2) || _cost[IREGP_R2] > c) {
        DFA_PRODUCTION__SET_VALID(IREGP_R2, cmovP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R3) || _cost[IREGP_R3] > c) {
        DFA_PRODUCTION__SET_VALID(IREGP_R3, cmovP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R4) || _cost[IREGP_R4] > c) {
        DFA_PRODUCTION__SET_VALID(IREGP_R4, cmovP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R5) || _cost[IREGP_R5] > c) {
        DFA_PRODUCTION__SET_VALID(IREGP_R5, cmovP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R10) || _cost[IREGP_R10] > c) {
        DFA_PRODUCTION__SET_VALID(IREGP_R10, cmovP_reg_reg_rule, c)
      }
    }
}
void  State::_sub_Op_CMoveN(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOPU_RFLAGSREGU) && STATE__VALID_CHILD(_kids[1], _BINARY_IMMN0_IREGN) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOPU_RFLAGSREGU]+_kids[1]->_cost[_BINARY_IMMN0_IREGN]+INSN_COST * 2;
        DFA_PRODUCTION__SET_VALID(IREGNNOSP, cmovUN_zero_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGN, cmovUN_zero_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP_RFLAGSREG) && STATE__VALID_CHILD(_kids[1], _BINARY_IMMN0_IREGN) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP_RFLAGSREG]+_kids[1]->_cost[_BINARY_IMMN0_IREGN]+INSN_COST * 2;
      if (STATE__NOT_YET_VALID(IREGNNOSP) || _cost[IREGNNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGNNOSP, cmovN_zero_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGN) || _cost[IREGN] > c) {
        DFA_PRODUCTION__SET_VALID(IREGN, cmovN_zero_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOPU_RFLAGSREGU) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGN_IMMN0) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOPU_RFLAGSREGU]+_kids[1]->_cost[_BINARY_IREGN_IMMN0]+INSN_COST * 2;
      if (STATE__NOT_YET_VALID(IREGNNOSP) || _cost[IREGNNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGNNOSP, cmovUN_reg_zero_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGN) || _cost[IREGN] > c) {
        DFA_PRODUCTION__SET_VALID(IREGN, cmovUN_reg_zero_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP_RFLAGSREG) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGN_IMMN0) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP_RFLAGSREG]+_kids[1]->_cost[_BINARY_IREGN_IMMN0]+INSN_COST * 2;
      if (STATE__NOT_YET_VALID(IREGNNOSP) || _cost[IREGNNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGNNOSP, cmovN_reg_zero_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGN) || _cost[IREGN] > c) {
        DFA_PRODUCTION__SET_VALID(IREGN, cmovN_reg_zero_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOPU_RFLAGSREGU) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGN_IREGN) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOPU_RFLAGSREGU]+_kids[1]->_cost[_BINARY_IREGN_IREGN]+INSN_COST * 2;
      if (STATE__NOT_YET_VALID(IREGNNOSP) || _cost[IREGNNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGNNOSP, cmovUN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGN) || _cost[IREGN] > c) {
        DFA_PRODUCTION__SET_VALID(IREGN, cmovUN_reg_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP_RFLAGSREG) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGN_IREGN) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP_RFLAGSREG]+_kids[1]->_cost[_BINARY_IREGN_IREGN]+INSN_COST * 2;
      if (STATE__NOT_YET_VALID(IREGNNOSP) || _cost[IREGNNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGNNOSP, cmovN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGN) || _cost[IREGN] > c) {
        DFA_PRODUCTION__SET_VALID(IREGN, cmovN_reg_reg_rule, c)
      }
    }
}
void  State::_sub_Op_CmpN(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGN) && STATE__VALID_CHILD(_kids[1], IMMN0) ) {
      unsigned int c = _kids[0]->_cost[IREGN]+_kids[1]->_cost[IMMN0];
        DFA_PRODUCTION__SET_VALID(_CMPN_IREGN_IMMN0, _CmpN_iRegN_immN0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGN) && STATE__VALID_CHILD(_kids[1], IMMN0) ) {
      unsigned int c = _kids[0]->_cost[IREGN]+_kids[1]->_cost[IMMN0] + INSN_COST;
        DFA_PRODUCTION__SET_VALID(RFLAGSREGU, testN_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGN) && STATE__VALID_CHILD(_kids[1], IREGN) ) {
      unsigned int c = _kids[0]->_cost[IREGN]+_kids[1]->_cost[IREGN] + INSN_COST;
      if (STATE__NOT_YET_VALID(RFLAGSREGU) || _cost[RFLAGSREGU] > c) {
        DFA_PRODUCTION__SET_VALID(RFLAGSREGU, compN_reg_reg_rule, c)
      }
    }
}
void  State::_sub_Op_CmpD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VREGD) && STATE__VALID_CHILD(_kids[1], IMMD0) ) {
      unsigned int c = _kids[0]->_cost[VREGD]+_kids[1]->_cost[IMMD0]+3 * INSN_COST;
        DFA_PRODUCTION__SET_VALID(RFLAGSREG, compD_reg_zero_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VREGD) && STATE__VALID_CHILD(_kids[1], VREGD) ) {
      unsigned int c = _kids[0]->_cost[VREGD]+_kids[1]->_cost[VREGD]+3 * INSN_COST;
      if (STATE__NOT_YET_VALID(RFLAGSREG) || _cost[RFLAGSREG] > c) {
        DFA_PRODUCTION__SET_VALID(RFLAGSREG, compD_reg_reg_rule, c)
      }
    }
}
void  State::_sub_Op_CmpD3(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VREGD) && STATE__VALID_CHILD(_kids[1], IMMD0) ) {
      unsigned int c = _kids[0]->_cost[VREGD]+_kids[1]->_cost[IMMD0]+5 * INSN_COST;
        DFA_PRODUCTION__SET_VALID(IREGINOSP, compD3_reg_immD0_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI, compD3_reg_immD0_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R0, compD3_reg_immD0_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R2, compD3_reg_immD0_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R3, compD3_reg_immD0_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R4, compD3_reg_immD0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VREGD) && STATE__VALID_CHILD(_kids[1], VREGD) ) {
      unsigned int c = _kids[0]->_cost[VREGD]+_kids[1]->_cost[VREGD]+5 * INSN_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, compD3_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, compD3_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R0) || _cost[IREGI_R0] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R0, compD3_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R2) || _cost[IREGI_R2] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R2, compD3_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R3) || _cost[IREGI_R3] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R3, compD3_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R4) || _cost[IREGI_R4] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R4, compD3_reg_reg_rule, c)
      }
    }
}
void  State::_sub_Op_CmpF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VREGF) && STATE__VALID_CHILD(_kids[1], IMMF0) ) {
      unsigned int c = _kids[0]->_cost[VREGF]+_kids[1]->_cost[IMMF0]+3 * INSN_COST;
        DFA_PRODUCTION__SET_VALID(RFLAGSREG, compF_reg_zero_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VREGF) && STATE__VALID_CHILD(_kids[1], VREGF) ) {
      unsigned int c = _kids[0]->_cost[VREGF]+_kids[1]->_cost[VREGF]+3 * INSN_COST;
      if (STATE__NOT_YET_VALID(RFLAGSREG) || _cost[RFLAGSREG] > c) {
        DFA_PRODUCTION__SET_VALID(RFLAGSREG, compF_reg_reg_rule, c)
      }
    }
}
void  State::_sub_Op_CmpF3(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VREGF) && STATE__VALID_CHILD(_kids[1], IMMF0) ) {
      unsigned int c = _kids[0]->_cost[VREGF]+_kids[1]->_cost[IMMF0]+5 * INSN_COST;
        DFA_PRODUCTION__SET_VALID(IREGINOSP, compF3_reg_immF0_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI, compF3_reg_immF0_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R0, compF3_reg_immF0_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R2, compF3_reg_immF0_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R3, compF3_reg_immF0_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R4, compF3_reg_immF0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VREGF) && STATE__VALID_CHILD(_kids[1], VREGF) ) {
      unsigned int c = _kids[0]->_cost[VREGF]+_kids[1]->_cost[VREGF]+5 * INSN_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, compF3_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, compF3_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R0) || _cost[IREGI_R0] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R0, compF3_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R2) || _cost[IREGI_R2] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R2, compF3_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R3) || _cost[IREGI_R3] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R3, compF3_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R4) || _cost[IREGI_R4] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R4, compF3_reg_reg_rule, c)
      }
    }
}
void  State::_sub_Op_CmpI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _ANDI_IREGIORL2I_IREGIORL2I) && STATE__VALID_CHILD(_kids[1], IMMI0) ) {
      unsigned int c = _kids[0]->_cost[_ANDI_IREGIORL2I_IREGIORL2I]+_kids[1]->_cost[IMMI0] + INSN_COST;
        DFA_PRODUCTION__SET_VALID(RFLAGSREG, cmpI_and_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _ANDI_IREGIORL2I_IMMI) && STATE__VALID_CHILD(_kids[1], IMMI0) &&
        (
#line 13563 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
Assembler::operand_valid_for_logical_immediate
            (/*is_32*/true, n->in(1)->in(2)->get_int())
#line 3481 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_ANDI_IREGIORL2I_IMMI]+_kids[1]->_cost[IMMI0] + INSN_COST;
      if (STATE__NOT_YET_VALID(RFLAGSREG) || _cost[RFLAGSREG] > c) {
        DFA_PRODUCTION__SET_VALID(RFLAGSREG, cmpI_and_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _ANDI_IREGIORL2I_IMMI) && STATE__VALID_CHILD(_kids[1], IMMI0) ) {
      unsigned int c = _kids[0]->_cost[_ANDI_IREGIORL2I_IMMI]+_kids[1]->_cost[IMMI0];
        DFA_PRODUCTION__SET_VALID(_CMPI__ANDI_IREGIORL2I_IMMI_IMMI0, _CmpI__AndI_iRegIorL2I_immI_immI0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) && STATE__VALID_CHILD(_kids[1], IMMI0) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I]+_kids[1]->_cost[IMMI0];
        DFA_PRODUCTION__SET_VALID(_CMPI_IREGIORL2I_IMMI0, _CmpI_iRegIorL2I_immI0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGI) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[IREGI]+_kids[1]->_cost[IMMI]+INSN_COST * 2;
      if (STATE__NOT_YET_VALID(RFLAGSREG) || _cost[RFLAGSREG] > c) {
        DFA_PRODUCTION__SET_VALID(RFLAGSREG, compI_reg_immI_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGI) && STATE__VALID_CHILD(_kids[1], IMMIADDSUB) ) {
      unsigned int c = _kids[0]->_cost[IREGI]+_kids[1]->_cost[IMMIADDSUB] + INSN_COST;
      if (STATE__NOT_YET_VALID(RFLAGSREG) || _cost[RFLAGSREG] > c) {
        DFA_PRODUCTION__SET_VALID(RFLAGSREG, compI_reg_immIAddSub_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGI) && STATE__VALID_CHILD(_kids[1], IMMI0) ) {
      unsigned int c = _kids[0]->_cost[IREGI]+_kids[1]->_cost[IMMI0] + INSN_COST;
      if (STATE__NOT_YET_VALID(RFLAGSREG) || _cost[RFLAGSREG] > c) {
        DFA_PRODUCTION__SET_VALID(RFLAGSREG, compI_reg_immI0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGI) && STATE__VALID_CHILD(_kids[1], IREGI) ) {
      unsigned int c = _kids[0]->_cost[IREGI]+_kids[1]->_cost[IREGI] + INSN_COST;
      if (STATE__NOT_YET_VALID(RFLAGSREG) || _cost[RFLAGSREG] > c) {
        DFA_PRODUCTION__SET_VALID(RFLAGSREG, compI_reg_reg_rule, c)
      }
    }
}
void  State::_sub_Op_CmpL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _ANDL_IREGL_IREGL) && STATE__VALID_CHILD(_kids[1], IMML0) ) {
      unsigned int c = _kids[0]->_cost[_ANDL_IREGL_IREGL]+_kids[1]->_cost[IMML0] + INSN_COST;
        DFA_PRODUCTION__SET_VALID(RFLAGSREG, cmpL_and_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _ANDL_IREGL_IMML) && STATE__VALID_CHILD(_kids[1], IMML0) &&
        (
#line 13550 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
Assembler::operand_valid_for_logical_immediate
            (/*is_32*/false, n->in(1)->in(2)->get_long())
#line 3531 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_ANDL_IREGL_IMML]+_kids[1]->_cost[IMML0] + INSN_COST;
      if (STATE__NOT_YET_VALID(RFLAGSREG) || _cost[RFLAGSREG] > c) {
        DFA_PRODUCTION__SET_VALID(RFLAGSREG, cmpL_and_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _ANDL_IREGL_IMML) && STATE__VALID_CHILD(_kids[1], IMML0) ) {
      unsigned int c = _kids[0]->_cost[_ANDL_IREGL_IMML]+_kids[1]->_cost[IMML0];
        DFA_PRODUCTION__SET_VALID(_CMPL__ANDL_IREGL_IMML_IMML0, _CmpL__AndL_iRegL_immL_immL0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IMML0) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IMML0];
        DFA_PRODUCTION__SET_VALID(_CMPL_IREGL_IMML0, _CmpL_iRegL_immL0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IMML) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IMML]+INSN_COST * 2;
      if (STATE__NOT_YET_VALID(RFLAGSREG) || _cost[RFLAGSREG] > c) {
        DFA_PRODUCTION__SET_VALID(RFLAGSREG, compL_reg_immL_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IMMLADDSUB) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IMMLADDSUB] + INSN_COST;
      if (STATE__NOT_YET_VALID(RFLAGSREG) || _cost[RFLAGSREG] > c) {
        DFA_PRODUCTION__SET_VALID(RFLAGSREG, compL_reg_immLAddSub_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IMML0) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IMML0] + INSN_COST;
      if (STATE__NOT_YET_VALID(RFLAGSREG) || _cost[RFLAGSREG] > c) {
        DFA_PRODUCTION__SET_VALID(RFLAGSREG, compL_reg_immL0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IREGL) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IREGL] + INSN_COST;
      if (STATE__NOT_YET_VALID(RFLAGSREG) || _cost[RFLAGSREG] > c) {
        DFA_PRODUCTION__SET_VALID(RFLAGSREG, compL_reg_reg_rule, c)
      }
    }
}
void  State::_sub_Op_CmpL3(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IREGL) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IREGL]+INSN_COST * 6;
        DFA_PRODUCTION__SET_VALID(IREGINOSP, cmpL3_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI, cmpL3_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R0, cmpL3_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R2, cmpL3_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R3, cmpL3_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R4, cmpL3_reg_reg_rule, c)
    }
}
void  State::_sub_Op_CmpLTMask(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) && STATE__VALID_CHILD(_kids[1], IMMI0) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I]+_kids[1]->_cost[IMMI0] + INSN_COST;
        DFA_PRODUCTION__SET_VALID(IREGINOSP, cmpLTMask_reg_zero_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI, cmpLTMask_reg_zero_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R0, cmpLTMask_reg_zero_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R2, cmpLTMask_reg_zero_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R3, cmpLTMask_reg_zero_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R4, cmpLTMask_reg_zero_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) && STATE__VALID_CHILD(_kids[1], IREGIORL2I) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I]+_kids[1]->_cost[IREGIORL2I]+3 * INSN_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, cmpLTMask_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, cmpLTMask_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R0) || _cost[IREGI_R0] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R0, cmpLTMask_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R2) || _cost[IREGI_R2] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R2, cmpLTMask_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R3) || _cost[IREGI_R3] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R3, cmpLTMask_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R4) || _cost[IREGI_R4] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R4, cmpLTMask_reg_reg_rule, c)
      }
    }
}
void  State::_sub_Op_CmpP(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _PARTIALSUBTYPECHECK_IREGP_R4_IREGP_R0) && STATE__VALID_CHILD(_kids[1], IMMP0) ) {
      unsigned int c = _kids[0]->_cost[_PARTIALSUBTYPECHECK_IREGP_R4_IREGP_R0]+_kids[1]->_cost[IMMP0]+1100;
        DFA_PRODUCTION__SET_VALID(RFLAGSREG, partialSubtypeCheckVsZero_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _DECODEN_IREGN_) && STATE__VALID_CHILD(_kids[1], IMMP0) ) {
      unsigned int c = _kids[0]->_cost[_DECODEN_IREGN_]+_kids[1]->_cost[IMMP0];
        DFA_PRODUCTION__SET_VALID(_CMPP__DECODEN_IREGN__IMMP0, _CmpP__DecodeN_iRegN__immP0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGP) && STATE__VALID_CHILD(_kids[1], IMMP0) ) {
      unsigned int c = _kids[0]->_cost[IREGP]+_kids[1]->_cost[IMMP0];
        DFA_PRODUCTION__SET_VALID(_CMPP_IREGP_IMMP0, _CmpP_iRegP_immP0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGP) && STATE__VALID_CHILD(_kids[1], IMMP0) ) {
      unsigned int c = _kids[0]->_cost[IREGP]+_kids[1]->_cost[IMMP0] + INSN_COST;
        DFA_PRODUCTION__SET_VALID(RFLAGSREGU, testP_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGP) && STATE__VALID_CHILD(_kids[1], IREGP) ) {
      unsigned int c = _kids[0]->_cost[IREGP]+_kids[1]->_cost[IREGP] + INSN_COST;
      if (STATE__NOT_YET_VALID(RFLAGSREGU) || _cost[RFLAGSREGU] > c) {
        DFA_PRODUCTION__SET_VALID(RFLAGSREGU, compP_reg_reg_rule, c)
      }
    }
}
void  State::_sub_Op_CmpU(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) && STATE__VALID_CHILD(_kids[1], IMMI0) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I]+_kids[1]->_cost[IMMI0];
        DFA_PRODUCTION__SET_VALID(_CMPU_IREGIORL2I_IMMI0, _CmpU_iRegIorL2I_immI0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGI) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[IREGI]+_kids[1]->_cost[IMMI]+INSN_COST * 2;
        DFA_PRODUCTION__SET_VALID(RFLAGSREGU, compU_reg_immI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGI) && STATE__VALID_CHILD(_kids[1], IMMIADDSUB) ) {
      unsigned int c = _kids[0]->_cost[IREGI]+_kids[1]->_cost[IMMIADDSUB] + INSN_COST;
      if (STATE__NOT_YET_VALID(RFLAGSREGU) || _cost[RFLAGSREGU] > c) {
        DFA_PRODUCTION__SET_VALID(RFLAGSREGU, compU_reg_immIAddSub_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGI) && STATE__VALID_CHILD(_kids[1], IMMI0) ) {
      unsigned int c = _kids[0]->_cost[IREGI]+_kids[1]->_cost[IMMI0] + INSN_COST;
      if (STATE__NOT_YET_VALID(RFLAGSREGU) || _cost[RFLAGSREGU] > c) {
        DFA_PRODUCTION__SET_VALID(RFLAGSREGU, compU_reg_immI0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGI) && STATE__VALID_CHILD(_kids[1], IREGI) ) {
      unsigned int c = _kids[0]->_cost[IREGI]+_kids[1]->_cost[IREGI] + INSN_COST;
      if (STATE__NOT_YET_VALID(RFLAGSREGU) || _cost[RFLAGSREGU] > c) {
        DFA_PRODUCTION__SET_VALID(RFLAGSREGU, compU_reg_reg_rule, c)
      }
    }
}
void  State::_sub_Op_CmpUL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IMML0) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IMML0];
        DFA_PRODUCTION__SET_VALID(_CMPUL_IREGL_IMML0, _CmpUL_iRegL_immL0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IMML) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IMML]+INSN_COST * 2;
        DFA_PRODUCTION__SET_VALID(RFLAGSREGU, compUL_reg_immL_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IMMLADDSUB) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IMMLADDSUB] + INSN_COST;
      if (STATE__NOT_YET_VALID(RFLAGSREGU) || _cost[RFLAGSREGU] > c) {
        DFA_PRODUCTION__SET_VALID(RFLAGSREGU, compUL_reg_immLAddSub_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IMML0) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IMML0] + INSN_COST;
      if (STATE__NOT_YET_VALID(RFLAGSREGU) || _cost[RFLAGSREGU] > c) {
        DFA_PRODUCTION__SET_VALID(RFLAGSREGU, compUL_reg_immL0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IREGL) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IREGL] + INSN_COST;
      if (STATE__NOT_YET_VALID(RFLAGSREGU) || _cost[RFLAGSREGU] > c) {
        DFA_PRODUCTION__SET_VALID(RFLAGSREGU, compUL_reg_reg_rule, c)
      }
    }
}
void  State::_sub_Op_CompareAndSwapI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGINOSP_IREGINOSP) &&
        (
#line 8164 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
needs_acquiring_load_exclusive(n)
#line 3704 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[_BINARY_IREGINOSP_IREGINOSP] + VOLATILE_REF_COST;
        DFA_PRODUCTION__SET_VALID(IREGINOSP, compareAndSwapIAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI, compareAndSwapIAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R0, compareAndSwapIAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R2, compareAndSwapIAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R3, compareAndSwapIAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R4, compareAndSwapIAcq_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGINOSP_IREGINOSP) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[_BINARY_IREGINOSP_IREGINOSP]+2 * VOLATILE_REF_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, compareAndSwapI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, compareAndSwapI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R0) || _cost[IREGI_R0] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R0, compareAndSwapI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R2) || _cost[IREGI_R2] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R2, compareAndSwapI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R3) || _cost[IREGI_R3] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R3, compareAndSwapI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R4) || _cost[IREGI_R4] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R4, compareAndSwapI_rule, c)
      }
    }
}
void  State::_sub_Op_CompareAndSwapL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGLNOSP_IREGLNOSP) &&
        (
#line 8183 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
needs_acquiring_load_exclusive(n)
#line 3745 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[_BINARY_IREGLNOSP_IREGLNOSP] + VOLATILE_REF_COST;
        DFA_PRODUCTION__SET_VALID(IREGINOSP, compareAndSwapLAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI, compareAndSwapLAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R0, compareAndSwapLAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R2, compareAndSwapLAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R3, compareAndSwapLAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R4, compareAndSwapLAcq_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGLNOSP_IREGLNOSP) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[_BINARY_IREGLNOSP_IREGLNOSP]+2 * VOLATILE_REF_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, compareAndSwapL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, compareAndSwapL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R0) || _cost[IREGI_R0] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R0, compareAndSwapL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R2) || _cost[IREGI_R2] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R2, compareAndSwapL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R3) || _cost[IREGI_R3] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R3, compareAndSwapL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R4) || _cost[IREGI_R4] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R4, compareAndSwapL_rule, c)
      }
    }
}
void  State::_sub_Op_CompareAndSwapP(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGP_IREGP) &&
        (
#line 8221 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
needs_acquiring_load_exclusive(n) && UseShenandoahGC && ShenandoahCASBarrier && n->in(3)->in(1)->bottom_type() != TypePtr::NULL_PTR
#line 3786 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[_BINARY_IREGP_IREGP] + VOLATILE_REF_COST;
        DFA_PRODUCTION__SET_VALID(IREGINOSP, compareAndSwapPAcq_shenandoah_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI, compareAndSwapPAcq_shenandoah_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R0, compareAndSwapPAcq_shenandoah_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R2, compareAndSwapPAcq_shenandoah_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R3, compareAndSwapPAcq_shenandoah_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R4, compareAndSwapPAcq_shenandoah_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGP_IREGP) &&
        (
#line 8202 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
needs_acquiring_load_exclusive(n) && (!UseShenandoahGC || !ShenandoahCASBarrier || n->in(3)->in(1)->bottom_type() == TypePtr::NULL_PTR)
#line 3801 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[_BINARY_IREGP_IREGP] + VOLATILE_REF_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, compareAndSwapPAcq_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, compareAndSwapPAcq_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R0) || _cost[IREGI_R0] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R0, compareAndSwapPAcq_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R2) || _cost[IREGI_R2] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R2, compareAndSwapPAcq_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R3) || _cost[IREGI_R3] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R3, compareAndSwapPAcq_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R4) || _cost[IREGI_R4] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R4, compareAndSwapPAcq_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGP_IREGP) &&
        (
#line 8105 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
UseShenandoahGC && ShenandoahCASBarrier && n->in(3)->in(1)->bottom_type() != TypePtr::NULL_PTR
#line 3830 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[_BINARY_IREGP_IREGP]+2 * VOLATILE_REF_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, compareAndSwapP_shenandoah_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, compareAndSwapP_shenandoah_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R0) || _cost[IREGI_R0] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R0, compareAndSwapP_shenandoah_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R2) || _cost[IREGI_R2] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R2, compareAndSwapP_shenandoah_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R3) || _cost[IREGI_R3] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R3, compareAndSwapP_shenandoah_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R4) || _cost[IREGI_R4] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R4, compareAndSwapP_shenandoah_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGP_IREGP) &&
        (
#line 8086 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
!UseShenandoahGC || !ShenandoahCASBarrier || n->in(3)->in(1)->bottom_type() == TypePtr::NULL_PTR
#line 3859 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[_BINARY_IREGP_IREGP]+2 * VOLATILE_REF_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, compareAndSwapP_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, compareAndSwapP_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R0) || _cost[IREGI_R0] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R0, compareAndSwapP_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R2) || _cost[IREGI_R2] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R2, compareAndSwapP_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R3) || _cost[IREGI_R3] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R3, compareAndSwapP_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R4) || _cost[IREGI_R4] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R4, compareAndSwapP_rule, c)
      }
    }
}
void  State::_sub_Op_CompareAndSwapN(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGN_IREGN) &&
        (
#line 8257 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
needs_acquiring_load_exclusive(n) && UseShenandoahGC && ShenandoahCASBarrier && n->in(3)->in(1)->bottom_type() != TypeNarrowOop::NULL_PTR
#line 3890 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[_BINARY_IREGN_IREGN] + VOLATILE_REF_COST;
        DFA_PRODUCTION__SET_VALID(IREGINOSP, compareAndSwapNAcq_shenandoah_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI, compareAndSwapNAcq_shenandoah_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R0, compareAndSwapNAcq_shenandoah_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R2, compareAndSwapNAcq_shenandoah_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R3, compareAndSwapNAcq_shenandoah_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R4, compareAndSwapNAcq_shenandoah_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGNNOSP_IREGNNOSP) &&
        (
#line 8238 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
needs_acquiring_load_exclusive(n) && (!UseShenandoahGC || !ShenandoahCASBarrier|| n->in(3)->in(1)->bottom_type() == TypeNarrowOop::NULL_PTR)
#line 3905 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[_BINARY_IREGNNOSP_IREGNNOSP] + VOLATILE_REF_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, compareAndSwapNAcq_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, compareAndSwapNAcq_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R0) || _cost[IREGI_R0] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R0, compareAndSwapNAcq_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R2) || _cost[IREGI_R2] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R2, compareAndSwapNAcq_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R3) || _cost[IREGI_R3] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R3, compareAndSwapNAcq_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R4) || _cost[IREGI_R4] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R4, compareAndSwapNAcq_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGN_IREGN) &&
        (
#line 8141 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
UseShenandoahGC && ShenandoahCASBarrier && n->in(3)->in(1)->bottom_type() != TypeNarrowOop::NULL_PTR
#line 3934 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[_BINARY_IREGN_IREGN]+2 * VOLATILE_REF_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, compareAndSwapN_shenandoah_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, compareAndSwapN_shenandoah_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R0) || _cost[IREGI_R0] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R0, compareAndSwapN_shenandoah_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R2) || _cost[IREGI_R2] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R2, compareAndSwapN_shenandoah_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R3) || _cost[IREGI_R3] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R3, compareAndSwapN_shenandoah_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R4) || _cost[IREGI_R4] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R4, compareAndSwapN_shenandoah_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGNNOSP_IREGNNOSP) &&
        (
#line 8122 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
!UseShenandoahGC || !ShenandoahCASBarrier || n->in(3)->in(1)->bottom_type() == TypeNarrowOop::NULL_PTR
#line 3963 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[_BINARY_IREGNNOSP_IREGNNOSP]+2 * VOLATILE_REF_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, compareAndSwapN_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, compareAndSwapN_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R0) || _cost[IREGI_R0] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R0, compareAndSwapN_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R2) || _cost[IREGI_R2] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R2, compareAndSwapN_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R3) || _cost[IREGI_R3] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R3, compareAndSwapN_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R4) || _cost[IREGI_R4] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R4, compareAndSwapN_rule, c)
      }
    }
}
void  State::_sub_Op_GetAndAddI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], IMMIADDSUB) &&
        (
#line 8523 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
n->as_LoadStore()->result_not_used() && needs_acquiring_load_exclusive(n)
#line 3994 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[IMMIADDSUB] + VOLATILE_REF_COST;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, get_and_addIi_no_resAcq_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], IMMIADDSUB) &&
        (
#line 8512 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
needs_acquiring_load_exclusive(n)
#line 4003 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[IMMIADDSUB]+VOLATILE_REF_COST + 1;
        DFA_PRODUCTION__SET_VALID(IREGINOSP, get_and_addIiAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI, get_and_addIiAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R0, get_and_addIiAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R2, get_and_addIiAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R3, get_and_addIiAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R4, get_and_addIiAcq_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], IREGIORL2I) &&
        (
#line 8501 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
n->as_LoadStore()->result_not_used() && needs_acquiring_load_exclusive(n)
#line 4018 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[IREGIORL2I] + VOLATILE_REF_COST;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, get_and_addI_no_resAcq_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], IREGIORL2I) &&
        (
#line 8490 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
needs_acquiring_load_exclusive(n)
#line 4029 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[IREGIORL2I]+VOLATILE_REF_COST + 1;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, get_and_addIAcq_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, get_and_addIAcq_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R0) || _cost[IREGI_R0] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R0, get_and_addIAcq_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R2) || _cost[IREGI_R2] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R2, get_and_addIAcq_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R3) || _cost[IREGI_R3] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R3, get_and_addIAcq_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R4) || _cost[IREGI_R4] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R4, get_and_addIAcq_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], IMMIADDSUB) &&
        (
#line 8435 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
n->as_LoadStore()->result_not_used()
#line 4058 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[IMMIADDSUB]+2 * VOLATILE_REF_COST;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, get_and_addIi_no_res_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], IMMIADDSUB) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[IMMIADDSUB]+2 * VOLATILE_REF_COST + 1;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, get_and_addIi_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, get_and_addIi_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R0) || _cost[IREGI_R0] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R0, get_and_addIi_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R2) || _cost[IREGI_R2] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R2, get_and_addIi_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R3) || _cost[IREGI_R3] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R3, get_and_addIi_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R4) || _cost[IREGI_R4] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R4, get_and_addIi_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], IREGIORL2I) &&
        (
#line 8414 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
n->as_LoadStore()->result_not_used()
#line 4093 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[IREGIORL2I]+2 * VOLATILE_REF_COST;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, get_and_addI_no_res_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], IREGIORL2I) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[IREGIORL2I]+2 * VOLATILE_REF_COST + 1;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, get_and_addI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, get_and_addI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R0) || _cost[IREGI_R0] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R0, get_and_addI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R2) || _cost[IREGI_R2] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R2, get_and_addI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R3) || _cost[IREGI_R3] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R3, get_and_addI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R4) || _cost[IREGI_R4] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R4, get_and_addI_rule, c)
      }
    }
}
void  State::_sub_Op_GetAndAddL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], IMMLADDSUB) &&
        (
#line 8479 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
n->as_LoadStore()->result_not_used() && needs_acquiring_load_exclusive(n)
#line 4130 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[IMMLADDSUB] + VOLATILE_REF_COST;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, get_and_addLi_no_resAcq_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], IMMLADDSUB) &&
        (
#line 8468 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
needs_acquiring_load_exclusive(n)
#line 4139 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[IMMLADDSUB]+VOLATILE_REF_COST + 1;
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, get_and_addLiAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL, get_and_addLiAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL_R11, get_and_addLiAcq_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], IREGL) &&
        (
#line 8457 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
n->as_LoadStore()->result_not_used() && needs_acquiring_load_exclusive(n)
#line 4150 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[IREGL] + VOLATILE_REF_COST;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, get_and_addL_no_resAcq_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], IREGL) &&
        (
#line 8446 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
needs_acquiring_load_exclusive(n)
#line 4161 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[IREGL]+VOLATILE_REF_COST + 1;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, get_and_addLAcq_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, get_and_addLAcq_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R11) || _cost[IREGL_R11] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R11, get_and_addLAcq_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], IMMLADDSUB) &&
        (
#line 8393 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
n->as_LoadStore()->result_not_used()
#line 4178 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[IMMLADDSUB]+2 * VOLATILE_REF_COST;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, get_and_addLi_no_res_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], IMMLADDSUB) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[IMMLADDSUB]+2 * VOLATILE_REF_COST + 1;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, get_and_addLi_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, get_and_addLi_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R11) || _cost[IREGL_R11] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R11, get_and_addLi_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], IREGL) &&
        (
#line 8372 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
n->as_LoadStore()->result_not_used()
#line 4201 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[IREGL]+2 * VOLATILE_REF_COST;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, get_and_addL_no_res_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], IREGL) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[IREGL]+2 * VOLATILE_REF_COST + 1;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, get_and_addL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, get_and_addL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R11) || _cost[IREGL_R11] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R11, get_and_addL_rule, c)
      }
    }
}
void  State::_sub_Op_GetAndSetI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], IREGI) &&
        (
#line 8317 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
needs_acquiring_load_exclusive(n)
#line 4226 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[IREGI] + VOLATILE_REF_COST;
        DFA_PRODUCTION__SET_VALID(IREGINOSP, get_and_setIAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI, get_and_setIAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R0, get_and_setIAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R2, get_and_setIAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R3, get_and_setIAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R4, get_and_setIAcq_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], IREGI) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[IREGI]+2 * VOLATILE_REF_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, get_and_setI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, get_and_setI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R0) || _cost[IREGI_R0] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R0, get_and_setI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R2) || _cost[IREGI_R2] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R2, get_and_setI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R3) || _cost[IREGI_R3] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R3, get_and_setI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R4) || _cost[IREGI_R4] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R4, get_and_setI_rule, c)
      }
    }
}
void  State::_sub_Op_GetAndSetL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], IREGL) &&
        (
#line 8328 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
needs_acquiring_load_exclusive(n)
#line 4267 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[IREGL] + VOLATILE_REF_COST;
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, get_and_setLAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL, get_and_setLAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL_R11, get_and_setLAcq_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], IREGL) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[IREGL]+2 * VOLATILE_REF_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, get_and_setL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, get_and_setL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R11) || _cost[IREGL_R11] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R11, get_and_setL_rule, c)
      }
    }
}
void  State::_sub_Op_GetAndSetP(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], IREGP) &&
        (
#line 8350 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
needs_acquiring_load_exclusive(n)
#line 4292 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[IREGP] + VOLATILE_REF_COST;
        DFA_PRODUCTION__SET_VALID(IREGPNOSP, get_and_setPAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP, get_and_setPAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(INLINE_CACHE_REGP, get_and_setPAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(INTERPRETER_METHOD_OOP_REGP, get_and_setPAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(THREAD_REGP, get_and_setPAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(LR_REGP, get_and_setPAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(INDIRECT, get_and_setPAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(VMEM4, indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(VMEM8, indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(VMEM16, indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R0, get_and_setPAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R1, get_and_setPAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R2, get_and_setPAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R3, get_and_setPAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R4, get_and_setPAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R5, get_and_setPAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R10, get_and_setPAcq_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], IREGP) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[IREGP]+2 * VOLATILE_REF_COST;
      if (STATE__NOT_YET_VALID(IREGPNOSP) || _cost[IREGPNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGPNOSP, get_and_setP_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP) || _cost[IREGP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGP, get_and_setP_rule, c)
      }
      if (STATE__NOT_YET_VALID(INLINE_CACHE_REGP) || _cost[INLINE_CACHE_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(INLINE_CACHE_REGP, get_and_setP_rule, c)
      }
      if (STATE__NOT_YET_VALID(INTERPRETER_METHOD_OOP_REGP) || _cost[INTERPRETER_METHOD_OOP_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(INTERPRETER_METHOD_OOP_REGP, get_and_setP_rule, c)
      }
      if (STATE__NOT_YET_VALID(THREAD_REGP) || _cost[THREAD_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(THREAD_REGP, get_and_setP_rule, c)
      }
      if (STATE__NOT_YET_VALID(LR_REGP) || _cost[LR_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(LR_REGP, get_and_setP_rule, c)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c) {
        DFA_PRODUCTION__SET_VALID(INDIRECT, get_and_setP_rule, c)
      }
      if (STATE__NOT_YET_VALID(VMEM4) || _cost[VMEM4] > c) {
        DFA_PRODUCTION__SET_VALID(VMEM4, indirect_rule, c)
      }
      if (STATE__NOT_YET_VALID(VMEM8) || _cost[VMEM8] > c) {
        DFA_PRODUCTION__SET_VALID(VMEM8, indirect_rule, c)
      }
      if (STATE__NOT_YET_VALID(VMEM16) || _cost[VMEM16] > c) {
        DFA_PRODUCTION__SET_VALID(VMEM16, indirect_rule, c)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R0) || _cost[IREGP_R0] > c) {
        DFA_PRODUCTION__SET_VALID(IREGP_R0, get_and_setP_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R1) || _cost[IREGP_R1] > c) {
        DFA_PRODUCTION__SET_VALID(IREGP_R1, get_and_setP_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R2) || _cost[IREGP_R2] > c) {
        DFA_PRODUCTION__SET_VALID(IREGP_R2, get_and_setP_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R3) || _cost[IREGP_R3] > c) {
        DFA_PRODUCTION__SET_VALID(IREGP_R3, get_and_setP_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R4) || _cost[IREGP_R4] > c) {
        DFA_PRODUCTION__SET_VALID(IREGP_R4, get_and_setP_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R5) || _cost[IREGP_R5] > c) {
        DFA_PRODUCTION__SET_VALID(IREGP_R5, get_and_setP_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R10) || _cost[IREGP_R10] > c) {
        DFA_PRODUCTION__SET_VALID(IREGP_R10, get_and_setP_rule, c)
      }
    }
}
void  State::_sub_Op_GetAndSetN(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], IREGN) &&
        (
#line 8339 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
needs_acquiring_load_exclusive(n)
#line 4377 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[IREGN] + VOLATILE_REF_COST;
        DFA_PRODUCTION__SET_VALID(IREGINOSP, get_and_setNAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI, get_and_setNAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R0, get_and_setNAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R2, get_and_setNAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R3, get_and_setNAcq_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R4, get_and_setNAcq_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], IREGN) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[IREGN]+2 * VOLATILE_REF_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, get_and_setN_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, get_and_setN_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R0) || _cost[IREGI_R0] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R0, get_and_setN_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R2) || _cost[IREGI_R2] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R2, get_and_setN_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R3) || _cost[IREGI_R3] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R3, get_and_setN_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R4) || _cost[IREGI_R4] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R4, get_and_setN_rule, c)
      }
    }
}
void  State::_sub_Op_ConN(const Node *n){
    if(         
#line 4319 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
n->get_narrowcon() == 0
#line 4417 "../generated/adfiles/dfa_aarch64.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMN0, immN0_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGNNOSP, loadConN0_rule, c+INSN_COST)
        DFA_PRODUCTION__SET_VALID(IREGN, loadConN0_rule, c+INSN_COST)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMN, immN_rule, c)
      if (STATE__NOT_YET_VALID(IREGNNOSP) || _cost[IREGNNOSP] > c+INSN_COST * 4) {
        DFA_PRODUCTION__SET_VALID(IREGNNOSP, loadConN_rule, c+INSN_COST * 4)
      }
      if (STATE__NOT_YET_VALID(IREGN) || _cost[IREGN] > c+INSN_COST * 4) {
        DFA_PRODUCTION__SET_VALID(IREGN, loadConN_rule, c+INSN_COST * 4)
      }
    }
   if ( /* IREGNNOSP KNOWN_VALID || */ _cost[IREGNNOSP] > INSN_COST * 4) {
     DFA_PRODUCTION(IREGNNOSP, loadConN_rule, INSN_COST * 4)
   }
   if ( /* IREGN KNOWN_VALID || */ _cost[IREGN] > INSN_COST * 4) {
     DFA_PRODUCTION(IREGN, loadConN_rule, INSN_COST * 4)
   }
}
void  State::_sub_Op_ConNKlass(const Node *n){
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMNKLASS, immNKlass_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGNNOSP, loadConNKlass_rule, c+INSN_COST)
        DFA_PRODUCTION__SET_VALID(IREGN, loadConNKlass_rule, c+INSN_COST)
    }
}
void  State::_sub_Op_ConD(const Node *n){
    if(         
#line 4268 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
Assembler::operand_valid_for_float_immediate(n->getd())
#line 4453 "../generated/adfiles/dfa_aarch64.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMDPACKED, immDPacked_rule, c)
        DFA_PRODUCTION__SET_VALID(VREGD, loadConD_packed_rule, c+INSN_COST)
    }
    if(         
#line 4257 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
(n->getd() == 0) &&
            (fpclassify(n->getd()) == FP_ZERO) && (signbit(n->getd()) == 0)
#line 4463 "../generated/adfiles/dfa_aarch64.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMD0, immD0_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMD, immD_rule, c)
      if (STATE__NOT_YET_VALID(VREGD) || _cost[VREGD] > c+INSN_COST * 5) {
        DFA_PRODUCTION__SET_VALID(VREGD, loadConD_rule, c+INSN_COST * 5)
      }
    }
   if ( /* VREGD KNOWN_VALID || */ _cost[VREGD] > INSN_COST * 5) {
     DFA_PRODUCTION(VREGD, loadConD_rule, INSN_COST * 5)
   }
}
void  State::_sub_Op_ConF(const Node *n){
    if(         
#line 4298 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
Assembler::operand_valid_for_float_immediate((double)n->getf())
#line 4483 "../generated/adfiles/dfa_aarch64.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMFPACKED, immFPacked_rule, c)
        DFA_PRODUCTION__SET_VALID(VREGF, loadConF_packed_rule, c+INSN_COST * 4)
    }
    if(         
#line 4287 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
(n->getf() == 0) &&
            (fpclassify(n->getf()) == FP_ZERO) && (signbit(n->getf()) == 0)
#line 4493 "../generated/adfiles/dfa_aarch64.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMF0, immF0_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMF, immF_rule, c)
      if (STATE__NOT_YET_VALID(VREGF) || _cost[VREGF] > c+INSN_COST * 4) {
        DFA_PRODUCTION__SET_VALID(VREGF, loadConF_rule, c+INSN_COST * 4)
      }
    }
   if ( /* VREGF KNOWN_VALID || */ _cost[VREGF] > INSN_COST * 4) {
     DFA_PRODUCTION(VREGF, loadConF_rule, INSN_COST * 4)
   }
}
void  State::_sub_Op_ConI(const Node *n){
    int _n_get_int__ = n->get_int();
    if(         
#line 4067 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
Assembler::operand_valid_for_logical_immediate(/*is32*/true, (unsigned long)n->get_int())
#line 4514 "../generated/adfiles/dfa_aarch64.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMILOG, immILog_rule, c)
    }
    if(         
#line 4056 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
Assembler::operand_valid_for_add_sub_immediate((long)n->get_int())
#line 4522 "../generated/adfiles/dfa_aarch64.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMIADDSUB, immIAddSub_rule, c)
    }
    if(         
#line 4005 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
Address::offset_ok_for_immed(_n_get_int__, 4)
#line 4530 "../generated/adfiles/dfa_aarch64.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMIOFFSET16, immIOffset16_rule, c)
    }
    if(         
#line 3995 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
Address::offset_ok_for_immed(_n_get_int__, 3)
#line 4538 "../generated/adfiles/dfa_aarch64.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMIOFFSET8, immIOffset8_rule, c)
    }
    if(         
#line 3985 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
Address::offset_ok_for_immed(_n_get_int__, 2)
#line 4546 "../generated/adfiles/dfa_aarch64.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMIOFFSET4, immIOffset4_rule, c)
    }
    if(         
#line 3975 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
Address::offset_ok_for_immed(_n_get_int__)
#line 4554 "../generated/adfiles/dfa_aarch64.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMIOFFSET, immIOffset_rule, c)
    }
    if(         
#line 3954 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
(0 <= _n_get_int__) && (_n_get_int__ < (1 << 12))
#line 4562 "../generated/adfiles/dfa_aarch64.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMIU12, immIU12_rule, c)
    }
    if(         
#line 3943 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
((-(1 << 18)) <= _n_get_int__) && (_n_get_int__ < (1 << 18))
#line 4570 "../generated/adfiles/dfa_aarch64.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMI19, immI19_rule, c)
    }
    if(         
#line 3932 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
((-(1 << 25)) <= _n_get_int__) && (_n_get_int__ < (1 << 25))
#line 4578 "../generated/adfiles/dfa_aarch64.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMI26, immI26_rule, c)
    }
    if(         
#line 3921 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
0 <= _n_get_int__ && (_n_get_int__ <= 3)
#line 4586 "../generated/adfiles/dfa_aarch64.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMISCALE, immIScale_rule, c)
    }
    if(         
#line 3908 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
(_n_get_int__ != 0)
            && ((_n_get_int__ & 0xc0000000) == 0)
	    && is_power_of_2(_n_get_int__ + 1)
#line 4596 "../generated/adfiles/dfa_aarch64.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMI_BITMASK, immI_bitmask_rule, c)
    }
    if(         
#line 3866 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
_n_get_int__ == 255
#line 4604 "../generated/adfiles/dfa_aarch64.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMML_255, immL_255_rule, c)
    }
    if(         
#line 3856 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
_n_get_int__ == 63
#line 4612 "../generated/adfiles/dfa_aarch64.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMML_63, immL_63_rule, c)
    }
    if(         
#line 3846 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
_n_get_int__ == 65535
#line 4620 "../generated/adfiles/dfa_aarch64.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMI_65535, immI_65535_rule, c)
    }
    if(         
#line 3836 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
_n_get_int__ == 255
#line 4628 "../generated/adfiles/dfa_aarch64.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMI_255, immI_255_rule, c)
    }
    if(         
#line 3826 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
_n_get_int__ == 64
#line 4636 "../generated/adfiles/dfa_aarch64.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMI_64, immI_64_rule, c)
    }
    if(         
#line 3816 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
_n_get_int__ == 56
#line 4644 "../generated/adfiles/dfa_aarch64.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMI_56, immI_56_rule, c)
    }
    if(         
#line 3806 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
_n_get_int__ == 48
#line 4652 "../generated/adfiles/dfa_aarch64.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMI_48, immI_48_rule, c)
    }
    if(         
#line 3796 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
_n_get_int__ == 32
#line 4660 "../generated/adfiles/dfa_aarch64.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMI_32, immI_32_rule, c)
    }
    if(         
#line 3786 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
_n_get_int__ == 24
#line 4668 "../generated/adfiles/dfa_aarch64.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMI_24, immI_24_rule, c)
    }
    if(         
#line 3776 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
_n_get_int__ == 16
#line 4676 "../generated/adfiles/dfa_aarch64.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMI_16, immI_16_rule, c)
    }
    if(         
#line 3766 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
_n_get_int__ == 8
#line 4684 "../generated/adfiles/dfa_aarch64.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMI_8, immI_8_rule, c)
    }
    if(         
#line 3756 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
_n_get_int__ == 31
#line 4692 "../generated/adfiles/dfa_aarch64.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMI_31, immI_31_rule, c)
    }
    if(         
#line 3746 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
_n_get_int__ <= 4
#line 4700 "../generated/adfiles/dfa_aarch64.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMI_LE_4, immI_le_4_rule, c)
    }
    if(         
#line 3736 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
_n_get_int__ == -1
#line 4708 "../generated/adfiles/dfa_aarch64.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMI_M1, immI_M1_rule, c)
    }
    if(         
#line 3725 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
_n_get_int__ == 1
#line 4716 "../generated/adfiles/dfa_aarch64.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMI_1, immI_1_rule, c)
    }
    if(         
#line 3714 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
_n_get_int__ == 0
#line 4724 "../generated/adfiles/dfa_aarch64.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMI0, immI0_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMI, immI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGINOSP, loadConI_rule, c+INSN_COST)
        DFA_PRODUCTION__SET_VALID(IREGI, loadConI_rule, c+INSN_COST)
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c+INSN_COST)
        DFA_PRODUCTION__SET_VALID(IREGI_R0, loadConI_rule, c+INSN_COST)
        DFA_PRODUCTION__SET_VALID(IREGI_R2, loadConI_rule, c+INSN_COST)
        DFA_PRODUCTION__SET_VALID(IREGI_R3, loadConI_rule, c+INSN_COST)
        DFA_PRODUCTION__SET_VALID(IREGI_R4, loadConI_rule, c+INSN_COST)
    }
}
void  State::_sub_Op_ConL(const Node *n){
    jlong _n_get_long__ = n->get_long();
    if(         
#line 4155 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
_n_get_long__ == 0xFFFFFFFFL
#line 4746 "../generated/adfiles/dfa_aarch64.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMML_32BITS, immL_32bits_rule, c)
    }
    if(         
#line 4145 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
Assembler::operand_valid_for_logical_immediate(/*is32*/false, (unsigned long)n->get_long())
#line 4754 "../generated/adfiles/dfa_aarch64.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMLLOG, immLLog_rule, c)
    }
    if(         
#line 4135 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
Assembler::operand_valid_for_add_sub_immediate(_n_get_long__)
#line 4762 "../generated/adfiles/dfa_aarch64.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMLADDSUB, immLAddSub_rule, c)
    }
    if(         
#line 4123 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
_n_get_long__ == in_bytes(JavaThread::frame_anchor_offset()) +
                             in_bytes(JavaFrameAnchor::last_Java_pc_offset())
#line 4771 "../generated/adfiles/dfa_aarch64.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMML_PC_OFF, immL_pc_off_rule, c)
    }
    if(         
#line 4111 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
_n_get_long__ == -1
#line 4779 "../generated/adfiles/dfa_aarch64.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMML_M1, immL_M1_rule, c)
    }
    if(         
#line 4100 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
_n_get_long__ == 1
#line 4787 "../generated/adfiles/dfa_aarch64.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMML_1, immL_1_rule, c)
    }
    if(         
#line 4089 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
_n_get_long__ == 0
#line 4795 "../generated/adfiles/dfa_aarch64.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMML0, immL0_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMML, immL_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, loadConL_rule, c+INSN_COST)
        DFA_PRODUCTION__SET_VALID(IREGL, loadConL_rule, c+INSN_COST)
        DFA_PRODUCTION__SET_VALID(IREGL_R11, loadConL_rule, c+INSN_COST)
    }
    if(         
#line 4045 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
Address::offset_ok_for_immed(_n_get_long__, 4)
#line 4810 "../generated/adfiles/dfa_aarch64.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMLOFFSET16, immLoffset16_rule, c)
    }
    if(         
#line 4035 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
Address::offset_ok_for_immed(_n_get_long__, 3)
#line 4818 "../generated/adfiles/dfa_aarch64.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMLOFFSET8, immLoffset8_rule, c)
    }
    if(         
#line 4025 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
Address::offset_ok_for_immed(_n_get_long__, 2)
#line 4826 "../generated/adfiles/dfa_aarch64.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMLOFFSET4, immLoffset4_rule, c)
    }
    if(         
#line 4015 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
Address::offset_ok_for_immed(_n_get_long__)
#line 4834 "../generated/adfiles/dfa_aarch64.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMLOFFSET, immLoffset_rule, c)
    }
    if(         
#line 3964 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
(0 <= _n_get_long__) && (_n_get_long__ < (1 << 12))
#line 4842 "../generated/adfiles/dfa_aarch64.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMLU12, immLU12_rule, c)
    }
    if(         
#line 3896 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
(_n_get_long__ != 0)
            && ((_n_get_long__ & 0xc000000000000000l) == 0)
	    && is_power_of_2(_n_get_long__ + 1)
#line 4852 "../generated/adfiles/dfa_aarch64.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMML_BITMASK, immL_bitmask_rule, c)
    }
    if(         
#line 3886 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
_n_get_long__ == 4294967295L
#line 4860 "../generated/adfiles/dfa_aarch64.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMML_4294967295, immL_4294967295_rule, c)
    }
    if(         
#line 3876 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
_n_get_long__ == 65535L
#line 4868 "../generated/adfiles/dfa_aarch64.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMML_65535, immL_65535_rule, c)
    }
}
void  State::_sub_Op_ConP(const Node *n){
    if(         
#line 4236 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
n->get_ptr() == -2
#line 4878 "../generated/adfiles/dfa_aarch64.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMP_M2, immP_M2_rule, c)
    }
    if(         
#line 4224 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
n->get_ptr() == -1
#line 4886 "../generated/adfiles/dfa_aarch64.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMP_M1, immP_M1_rule, c)
    }
    if(         
#line 4211 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
!UseShenandoahGC && // TODO: Should really check for BS::is_a, see JDK-8193193
    (jbyte*)n->get_ptr() == ((CardTableModRefBS*)(Universe::heap()->barrier_set()))->byte_map_base
#line 4895 "../generated/adfiles/dfa_aarch64.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMBYTEMAPBASE, immByteMapBase_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGPNOSP, loadByteMapBase_rule, c+INSN_COST)
        DFA_PRODUCTION__SET_VALID(IREGP, loadByteMapBase_rule, c+INSN_COST)
        DFA_PRODUCTION__SET_VALID(INLINE_CACHE_REGP, loadByteMapBase_rule, c+INSN_COST)
        DFA_PRODUCTION__SET_VALID(INTERPRETER_METHOD_OOP_REGP, loadByteMapBase_rule, c+INSN_COST)
        DFA_PRODUCTION__SET_VALID(THREAD_REGP, loadByteMapBase_rule, c+INSN_COST)
        DFA_PRODUCTION__SET_VALID(LR_REGP, loadByteMapBase_rule, c+INSN_COST)
        DFA_PRODUCTION__SET_VALID(INDIRECT, loadByteMapBase_rule, c+INSN_COST)
        DFA_PRODUCTION__SET_VALID(VMEM4, indirect_rule, c+INSN_COST)
        DFA_PRODUCTION__SET_VALID(VMEM8, indirect_rule, c+INSN_COST)
        DFA_PRODUCTION__SET_VALID(VMEM16, indirect_rule, c+INSN_COST)
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c+INSN_COST)
        DFA_PRODUCTION__SET_VALID(IREGP_R0, loadByteMapBase_rule, c+INSN_COST)
        DFA_PRODUCTION__SET_VALID(IREGP_R1, loadByteMapBase_rule, c+INSN_COST)
        DFA_PRODUCTION__SET_VALID(IREGP_R2, loadByteMapBase_rule, c+INSN_COST)
        DFA_PRODUCTION__SET_VALID(IREGP_R3, loadByteMapBase_rule, c+INSN_COST)
        DFA_PRODUCTION__SET_VALID(IREGP_R4, loadByteMapBase_rule, c+INSN_COST)
        DFA_PRODUCTION__SET_VALID(IREGP_R5, loadByteMapBase_rule, c+INSN_COST)
        DFA_PRODUCTION__SET_VALID(IREGP_R10, loadByteMapBase_rule, c+INSN_COST)
    }
    if(         
#line 4199 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
(address)n->get_ptr() == os::get_polling_page()
#line 4921 "../generated/adfiles/dfa_aarch64.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMPOLLPAGE, immPollPage_rule, c)
      if (STATE__NOT_YET_VALID(IREGPNOSP) || _cost[IREGPNOSP] > c+INSN_COST) {
        DFA_PRODUCTION__SET_VALID(IREGPNOSP, loadConPollPage_rule, c+INSN_COST)
      }
      if (STATE__NOT_YET_VALID(IREGP) || _cost[IREGP] > c+INSN_COST) {
        DFA_PRODUCTION__SET_VALID(IREGP, loadConPollPage_rule, c+INSN_COST)
      }
      if (STATE__NOT_YET_VALID(INLINE_CACHE_REGP) || _cost[INLINE_CACHE_REGP] > c+INSN_COST) {
        DFA_PRODUCTION__SET_VALID(INLINE_CACHE_REGP, loadConPollPage_rule, c+INSN_COST)
      }
      if (STATE__NOT_YET_VALID(INTERPRETER_METHOD_OOP_REGP) || _cost[INTERPRETER_METHOD_OOP_REGP] > c+INSN_COST) {
        DFA_PRODUCTION__SET_VALID(INTERPRETER_METHOD_OOP_REGP, loadConPollPage_rule, c+INSN_COST)
      }
      if (STATE__NOT_YET_VALID(THREAD_REGP) || _cost[THREAD_REGP] > c+INSN_COST) {
        DFA_PRODUCTION__SET_VALID(THREAD_REGP, loadConPollPage_rule, c+INSN_COST)
      }
      if (STATE__NOT_YET_VALID(LR_REGP) || _cost[LR_REGP] > c+INSN_COST) {
        DFA_PRODUCTION__SET_VALID(LR_REGP, loadConPollPage_rule, c+INSN_COST)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c+INSN_COST) {
        DFA_PRODUCTION__SET_VALID(INDIRECT, loadConPollPage_rule, c+INSN_COST)
      }
      if (STATE__NOT_YET_VALID(VMEM4) || _cost[VMEM4] > c+INSN_COST) {
        DFA_PRODUCTION__SET_VALID(VMEM4, indirect_rule, c+INSN_COST)
      }
      if (STATE__NOT_YET_VALID(VMEM8) || _cost[VMEM8] > c+INSN_COST) {
        DFA_PRODUCTION__SET_VALID(VMEM8, indirect_rule, c+INSN_COST)
      }
      if (STATE__NOT_YET_VALID(VMEM16) || _cost[VMEM16] > c+INSN_COST) {
        DFA_PRODUCTION__SET_VALID(VMEM16, indirect_rule, c+INSN_COST)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c+INSN_COST) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c+INSN_COST)
      }
      if (STATE__NOT_YET_VALID(IREGP_R0) || _cost[IREGP_R0] > c+INSN_COST) {
        DFA_PRODUCTION__SET_VALID(IREGP_R0, loadConPollPage_rule, c+INSN_COST)
      }
      if (STATE__NOT_YET_VALID(IREGP_R1) || _cost[IREGP_R1] > c+INSN_COST) {
        DFA_PRODUCTION__SET_VALID(IREGP_R1, loadConPollPage_rule, c+INSN_COST)
      }
      if (STATE__NOT_YET_VALID(IREGP_R2) || _cost[IREGP_R2] > c+INSN_COST) {
        DFA_PRODUCTION__SET_VALID(IREGP_R2, loadConPollPage_rule, c+INSN_COST)
      }
      if (STATE__NOT_YET_VALID(IREGP_R3) || _cost[IREGP_R3] > c+INSN_COST) {
        DFA_PRODUCTION__SET_VALID(IREGP_R3, loadConPollPage_rule, c+INSN_COST)
      }
      if (STATE__NOT_YET_VALID(IREGP_R4) || _cost[IREGP_R4] > c+INSN_COST) {
        DFA_PRODUCTION__SET_VALID(IREGP_R4, loadConPollPage_rule, c+INSN_COST)
      }
      if (STATE__NOT_YET_VALID(IREGP_R5) || _cost[IREGP_R5] > c+INSN_COST) {
        DFA_PRODUCTION__SET_VALID(IREGP_R5, loadConPollPage_rule, c+INSN_COST)
      }
      if (STATE__NOT_YET_VALID(IREGP_R10) || _cost[IREGP_R10] > c+INSN_COST) {
        DFA_PRODUCTION__SET_VALID(IREGP_R10, loadConPollPage_rule, c+INSN_COST)
      }
    }
    if(         
#line 4188 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
n->get_ptr() == 1
#line 4983 "../generated/adfiles/dfa_aarch64.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMP_1, immP_1_rule, c)
      if (STATE__NOT_YET_VALID(IREGPNOSP) || _cost[IREGPNOSP] > c+INSN_COST) {
        DFA_PRODUCTION__SET_VALID(IREGPNOSP, loadConP1_rule, c+INSN_COST)
      }
      if (STATE__NOT_YET_VALID(IREGP) || _cost[IREGP] > c+INSN_COST) {
        DFA_PRODUCTION__SET_VALID(IREGP, loadConP1_rule, c+INSN_COST)
      }
      if (STATE__NOT_YET_VALID(INLINE_CACHE_REGP) || _cost[INLINE_CACHE_REGP] > c+INSN_COST) {
        DFA_PRODUCTION__SET_VALID(INLINE_CACHE_REGP, loadConP1_rule, c+INSN_COST)
      }
      if (STATE__NOT_YET_VALID(INTERPRETER_METHOD_OOP_REGP) || _cost[INTERPRETER_METHOD_OOP_REGP] > c+INSN_COST) {
        DFA_PRODUCTION__SET_VALID(INTERPRETER_METHOD_OOP_REGP, loadConP1_rule, c+INSN_COST)
      }
      if (STATE__NOT_YET_VALID(THREAD_REGP) || _cost[THREAD_REGP] > c+INSN_COST) {
        DFA_PRODUCTION__SET_VALID(THREAD_REGP, loadConP1_rule, c+INSN_COST)
      }
      if (STATE__NOT_YET_VALID(LR_REGP) || _cost[LR_REGP] > c+INSN_COST) {
        DFA_PRODUCTION__SET_VALID(LR_REGP, loadConP1_rule, c+INSN_COST)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c+INSN_COST) {
        DFA_PRODUCTION__SET_VALID(INDIRECT, loadConP1_rule, c+INSN_COST)
      }
      if (STATE__NOT_YET_VALID(VMEM4) || _cost[VMEM4] > c+INSN_COST) {
        DFA_PRODUCTION__SET_VALID(VMEM4, indirect_rule, c+INSN_COST)
      }
      if (STATE__NOT_YET_VALID(VMEM8) || _cost[VMEM8] > c+INSN_COST) {
        DFA_PRODUCTION__SET_VALID(VMEM8, indirect_rule, c+INSN_COST)
      }
      if (STATE__NOT_YET_VALID(VMEM16) || _cost[VMEM16] > c+INSN_COST) {
        DFA_PRODUCTION__SET_VALID(VMEM16, indirect_rule, c+INSN_COST)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c+INSN_COST) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c+INSN_COST)
      }
      if (STATE__NOT_YET_VALID(IREGP_R0) || _cost[IREGP_R0] > c+INSN_COST) {
        DFA_PRODUCTION__SET_VALID(IREGP_R0, loadConP1_rule, c+INSN_COST)
      }
      if (STATE__NOT_YET_VALID(IREGP_R1) || _cost[IREGP_R1] > c+INSN_COST) {
        DFA_PRODUCTION__SET_VALID(IREGP_R1, loadConP1_rule, c+INSN_COST)
      }
      if (STATE__NOT_YET_VALID(IREGP_R2) || _cost[IREGP_R2] > c+INSN_COST) {
        DFA_PRODUCTION__SET_VALID(IREGP_R2, loadConP1_rule, c+INSN_COST)
      }
      if (STATE__NOT_YET_VALID(IREGP_R3) || _cost[IREGP_R3] > c+INSN_COST) {
        DFA_PRODUCTION__SET_VALID(IREGP_R3, loadConP1_rule, c+INSN_COST)
      }
      if (STATE__NOT_YET_VALID(IREGP_R4) || _cost[IREGP_R4] > c+INSN_COST) {
        DFA_PRODUCTION__SET_VALID(IREGP_R4, loadConP1_rule, c+INSN_COST)
      }
      if (STATE__NOT_YET_VALID(IREGP_R5) || _cost[IREGP_R5] > c+INSN_COST) {
        DFA_PRODUCTION__SET_VALID(IREGP_R5, loadConP1_rule, c+INSN_COST)
      }
      if (STATE__NOT_YET_VALID(IREGP_R10) || _cost[IREGP_R10] > c+INSN_COST) {
        DFA_PRODUCTION__SET_VALID(IREGP_R10, loadConP1_rule, c+INSN_COST)
      }
    }
    if(         
#line 4176 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
n->get_ptr() == 0
#line 5045 "../generated/adfiles/dfa_aarch64.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMP0, immP0_rule, c)
      if (STATE__NOT_YET_VALID(IREGPNOSP) || _cost[IREGPNOSP] > c+INSN_COST) {
        DFA_PRODUCTION__SET_VALID(IREGPNOSP, loadConP0_rule, c+INSN_COST)
      }
      if (STATE__NOT_YET_VALID(IREGP) || _cost[IREGP] > c+INSN_COST) {
        DFA_PRODUCTION__SET_VALID(IREGP, loadConP0_rule, c+INSN_COST)
      }
      if (STATE__NOT_YET_VALID(INLINE_CACHE_REGP) || _cost[INLINE_CACHE_REGP] > c+INSN_COST) {
        DFA_PRODUCTION__SET_VALID(INLINE_CACHE_REGP, loadConP0_rule, c+INSN_COST)
      }
      if (STATE__NOT_YET_VALID(INTERPRETER_METHOD_OOP_REGP) || _cost[INTERPRETER_METHOD_OOP_REGP] > c+INSN_COST) {
        DFA_PRODUCTION__SET_VALID(INTERPRETER_METHOD_OOP_REGP, loadConP0_rule, c+INSN_COST)
      }
      if (STATE__NOT_YET_VALID(THREAD_REGP) || _cost[THREAD_REGP] > c+INSN_COST) {
        DFA_PRODUCTION__SET_VALID(THREAD_REGP, loadConP0_rule, c+INSN_COST)
      }
      if (STATE__NOT_YET_VALID(LR_REGP) || _cost[LR_REGP] > c+INSN_COST) {
        DFA_PRODUCTION__SET_VALID(LR_REGP, loadConP0_rule, c+INSN_COST)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c+INSN_COST) {
        DFA_PRODUCTION__SET_VALID(INDIRECT, loadConP0_rule, c+INSN_COST)
      }
      if (STATE__NOT_YET_VALID(VMEM4) || _cost[VMEM4] > c+INSN_COST) {
        DFA_PRODUCTION__SET_VALID(VMEM4, indirect_rule, c+INSN_COST)
      }
      if (STATE__NOT_YET_VALID(VMEM8) || _cost[VMEM8] > c+INSN_COST) {
        DFA_PRODUCTION__SET_VALID(VMEM8, indirect_rule, c+INSN_COST)
      }
      if (STATE__NOT_YET_VALID(VMEM16) || _cost[VMEM16] > c+INSN_COST) {
        DFA_PRODUCTION__SET_VALID(VMEM16, indirect_rule, c+INSN_COST)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c+INSN_COST) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c+INSN_COST)
      }
      if (STATE__NOT_YET_VALID(IREGP_R0) || _cost[IREGP_R0] > c+INSN_COST) {
        DFA_PRODUCTION__SET_VALID(IREGP_R0, loadConP0_rule, c+INSN_COST)
      }
      if (STATE__NOT_YET_VALID(IREGP_R1) || _cost[IREGP_R1] > c+INSN_COST) {
        DFA_PRODUCTION__SET_VALID(IREGP_R1, loadConP0_rule, c+INSN_COST)
      }
      if (STATE__NOT_YET_VALID(IREGP_R2) || _cost[IREGP_R2] > c+INSN_COST) {
        DFA_PRODUCTION__SET_VALID(IREGP_R2, loadConP0_rule, c+INSN_COST)
      }
      if (STATE__NOT_YET_VALID(IREGP_R3) || _cost[IREGP_R3] > c+INSN_COST) {
        DFA_PRODUCTION__SET_VALID(IREGP_R3, loadConP0_rule, c+INSN_COST)
      }
      if (STATE__NOT_YET_VALID(IREGP_R4) || _cost[IREGP_R4] > c+INSN_COST) {
        DFA_PRODUCTION__SET_VALID(IREGP_R4, loadConP0_rule, c+INSN_COST)
      }
      if (STATE__NOT_YET_VALID(IREGP_R5) || _cost[IREGP_R5] > c+INSN_COST) {
        DFA_PRODUCTION__SET_VALID(IREGP_R5, loadConP0_rule, c+INSN_COST)
      }
      if (STATE__NOT_YET_VALID(IREGP_R10) || _cost[IREGP_R10] > c+INSN_COST) {
        DFA_PRODUCTION__SET_VALID(IREGP_R10, loadConP0_rule, c+INSN_COST)
      }
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMP, immP_rule, c)
      if (STATE__NOT_YET_VALID(IREGPNOSP) || _cost[IREGPNOSP] > c+INSN_COST * 4) {
        DFA_PRODUCTION__SET_VALID(IREGPNOSP, loadConP_rule, c+INSN_COST * 4)
      }
      if (STATE__NOT_YET_VALID(IREGP) || _cost[IREGP] > c+INSN_COST * 4) {
        DFA_PRODUCTION__SET_VALID(IREGP, loadConP_rule, c+INSN_COST * 4)
      }
      if (STATE__NOT_YET_VALID(INLINE_CACHE_REGP) || _cost[INLINE_CACHE_REGP] > c+INSN_COST * 4) {
        DFA_PRODUCTION__SET_VALID(INLINE_CACHE_REGP, loadConP_rule, c+INSN_COST * 4)
      }
      if (STATE__NOT_YET_VALID(INTERPRETER_METHOD_OOP_REGP) || _cost[INTERPRETER_METHOD_OOP_REGP] > c+INSN_COST * 4) {
        DFA_PRODUCTION__SET_VALID(INTERPRETER_METHOD_OOP_REGP, loadConP_rule, c+INSN_COST * 4)
      }
      if (STATE__NOT_YET_VALID(THREAD_REGP) || _cost[THREAD_REGP] > c+INSN_COST * 4) {
        DFA_PRODUCTION__SET_VALID(THREAD_REGP, loadConP_rule, c+INSN_COST * 4)
      }
      if (STATE__NOT_YET_VALID(LR_REGP) || _cost[LR_REGP] > c+INSN_COST * 4) {
        DFA_PRODUCTION__SET_VALID(LR_REGP, loadConP_rule, c+INSN_COST * 4)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c+INSN_COST * 4) {
        DFA_PRODUCTION__SET_VALID(INDIRECT, loadConP_rule, c+INSN_COST * 4)
      }
      if (STATE__NOT_YET_VALID(VMEM4) || _cost[VMEM4] > c+INSN_COST * 4) {
        DFA_PRODUCTION__SET_VALID(VMEM4, indirect_rule, c+INSN_COST * 4)
      }
      if (STATE__NOT_YET_VALID(VMEM8) || _cost[VMEM8] > c+INSN_COST * 4) {
        DFA_PRODUCTION__SET_VALID(VMEM8, indirect_rule, c+INSN_COST * 4)
      }
      if (STATE__NOT_YET_VALID(VMEM16) || _cost[VMEM16] > c+INSN_COST * 4) {
        DFA_PRODUCTION__SET_VALID(VMEM16, indirect_rule, c+INSN_COST * 4)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c+INSN_COST * 4) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c+INSN_COST * 4)
      }
      if (STATE__NOT_YET_VALID(IREGP_R0) || _cost[IREGP_R0] > c+INSN_COST * 4) {
        DFA_PRODUCTION__SET_VALID(IREGP_R0, loadConP_rule, c+INSN_COST * 4)
      }
      if (STATE__NOT_YET_VALID(IREGP_R1) || _cost[IREGP_R1] > c+INSN_COST * 4) {
        DFA_PRODUCTION__SET_VALID(IREGP_R1, loadConP_rule, c+INSN_COST * 4)
      }
      if (STATE__NOT_YET_VALID(IREGP_R2) || _cost[IREGP_R2] > c+INSN_COST * 4) {
        DFA_PRODUCTION__SET_VALID(IREGP_R2, loadConP_rule, c+INSN_COST * 4)
      }
      if (STATE__NOT_YET_VALID(IREGP_R3) || _cost[IREGP_R3] > c+INSN_COST * 4) {
        DFA_PRODUCTION__SET_VALID(IREGP_R3, loadConP_rule, c+INSN_COST * 4)
      }
      if (STATE__NOT_YET_VALID(IREGP_R4) || _cost[IREGP_R4] > c+INSN_COST * 4) {
        DFA_PRODUCTION__SET_VALID(IREGP_R4, loadConP_rule, c+INSN_COST * 4)
      }
      if (STATE__NOT_YET_VALID(IREGP_R5) || _cost[IREGP_R5] > c+INSN_COST * 4) {
        DFA_PRODUCTION__SET_VALID(IREGP_R5, loadConP_rule, c+INSN_COST * 4)
      }
      if (STATE__NOT_YET_VALID(IREGP_R10) || _cost[IREGP_R10] > c+INSN_COST * 4) {
        DFA_PRODUCTION__SET_VALID(IREGP_R10, loadConP_rule, c+INSN_COST * 4)
      }
    }
   if ( /* IREGPNOSP KNOWN_VALID || */ _cost[IREGPNOSP] > INSN_COST * 4) {
     DFA_PRODUCTION(IREGPNOSP, loadConP_rule, INSN_COST * 4)
   }
   if ( /* IREGP KNOWN_VALID || */ _cost[IREGP] > INSN_COST * 4) {
     DFA_PRODUCTION(IREGP, loadConP_rule, INSN_COST * 4)
   }
   if ( /* INLINE_CACHE_REGP KNOWN_VALID || */ _cost[INLINE_CACHE_REGP] > INSN_COST * 4) {
     DFA_PRODUCTION(INLINE_CACHE_REGP, loadConP_rule, INSN_COST * 4)
   }
   if ( /* INTERPRETER_METHOD_OOP_REGP KNOWN_VALID || */ _cost[INTERPRETER_METHOD_OOP_REGP] > INSN_COST * 4) {
     DFA_PRODUCTION(INTERPRETER_METHOD_OOP_REGP, loadConP_rule, INSN_COST * 4)
   }
   if ( /* THREAD_REGP KNOWN_VALID || */ _cost[THREAD_REGP] > INSN_COST * 4) {
     DFA_PRODUCTION(THREAD_REGP, loadConP_rule, INSN_COST * 4)
   }
   if ( /* LR_REGP KNOWN_VALID || */ _cost[LR_REGP] > INSN_COST * 4) {
     DFA_PRODUCTION(LR_REGP, loadConP_rule, INSN_COST * 4)
   }
   if ( /* INDIRECT KNOWN_VALID || */ _cost[INDIRECT] > INSN_COST * 4) {
     DFA_PRODUCTION(INDIRECT, loadConP_rule, INSN_COST * 4)
   }
   if ( /* VMEM4 KNOWN_VALID || */ _cost[VMEM4] > INSN_COST * 4) {
     DFA_PRODUCTION(VMEM4, indirect_rule, INSN_COST * 4)
   }
   if ( /* VMEM8 KNOWN_VALID || */ _cost[VMEM8] > INSN_COST * 4) {
     DFA_PRODUCTION(VMEM8, indirect_rule, INSN_COST * 4)
   }
   if ( /* VMEM16 KNOWN_VALID || */ _cost[VMEM16] > INSN_COST * 4) {
     DFA_PRODUCTION(VMEM16, indirect_rule, INSN_COST * 4)
   }
   if ( /* MEMORY KNOWN_VALID || */ _cost[MEMORY] > INSN_COST * 4) {
     DFA_PRODUCTION(MEMORY, indirect_rule, INSN_COST * 4)
   }
   if ( /* IREGP_R0 KNOWN_VALID || */ _cost[IREGP_R0] > INSN_COST * 4) {
     DFA_PRODUCTION(IREGP_R0, loadConP_rule, INSN_COST * 4)
   }
   if ( /* IREGP_R1 KNOWN_VALID || */ _cost[IREGP_R1] > INSN_COST * 4) {
     DFA_PRODUCTION(IREGP_R1, loadConP_rule, INSN_COST * 4)
   }
   if ( /* IREGP_R2 KNOWN_VALID || */ _cost[IREGP_R2] > INSN_COST * 4) {
     DFA_PRODUCTION(IREGP_R2, loadConP_rule, INSN_COST * 4)
   }
   if ( /* IREGP_R3 KNOWN_VALID || */ _cost[IREGP_R3] > INSN_COST * 4) {
     DFA_PRODUCTION(IREGP_R3, loadConP_rule, INSN_COST * 4)
   }
   if ( /* IREGP_R4 KNOWN_VALID || */ _cost[IREGP_R4] > INSN_COST * 4) {
     DFA_PRODUCTION(IREGP_R4, loadConP_rule, INSN_COST * 4)
   }
   if ( /* IREGP_R5 KNOWN_VALID || */ _cost[IREGP_R5] > INSN_COST * 4) {
     DFA_PRODUCTION(IREGP_R5, loadConP_rule, INSN_COST * 4)
   }
   if ( /* IREGP_R10 KNOWN_VALID || */ _cost[IREGP_R10] > INSN_COST * 4) {
     DFA_PRODUCTION(IREGP_R10, loadConP_rule, INSN_COST * 4)
   }
}
void  State::_sub_Op_Conv2B(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGP) ) {
      unsigned int c = _kids[0]->_cost[IREGP] + INSN_COST;
        DFA_PRODUCTION__SET_VALID(IREGINOSP, convP2B_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI, convP2B_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R0, convP2B_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R2, convP2B_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R3, convP2B_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R4, convP2B_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I] + INSN_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, convI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, convI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R0) || _cost[IREGI_R0] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R0, convI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R2) || _cost[IREGI_R2] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R2, convI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R3) || _cost[IREGI_R3] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R3, convI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R4) || _cost[IREGI_R4] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R4, convI2B_rule, c)
      }
    }
}
void  State::_sub_Op_ConvD2F(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VREGD) ) {
      unsigned int c = _kids[0]->_cost[VREGD]+INSN_COST * 5;
        DFA_PRODUCTION__SET_VALID(VREGF, convD2F_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _SQRTD__CONVF2D_VREGF__) ) {
      unsigned int c = _kids[0]->_cost[_SQRTD__CONVF2D_VREGF__]+INSN_COST * 50;
      if (STATE__NOT_YET_VALID(VREGF) || _cost[VREGF] > c) {
        DFA_PRODUCTION__SET_VALID(VREGF, sqrtF_reg_rule, c)
      }
    }
}
void  State::_sub_Op_ConvD2I(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VREGD) ) {
      unsigned int c = _kids[0]->_cost[VREGD]+INSN_COST * 5;
        DFA_PRODUCTION__SET_VALID(IREGINOSP, convD2I_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI, convD2I_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R0, convD2I_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R2, convD2I_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R3, convD2I_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R4, convD2I_reg_reg_rule, c)
    }
}
void  State::_sub_Op_ConvD2L(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VREGD) ) {
      unsigned int c = _kids[0]->_cost[VREGD]+INSN_COST * 5;
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, convD2L_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL, convD2L_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL_R11, convD2L_reg_reg_rule, c)
    }
}
void  State::_sub_Op_ConvF2D(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VREGF) ) {
      unsigned int c = _kids[0]->_cost[VREGF]+INSN_COST * 5;
        DFA_PRODUCTION__SET_VALID(VREGD, convF2D_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VREGF) ) {
      unsigned int c = _kids[0]->_cost[VREGF];
        DFA_PRODUCTION__SET_VALID(_CONVF2D_VREGF_, _ConvF2D_vRegF__rule, c)
    }
}
void  State::_sub_Op_ConvF2I(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VREGF) ) {
      unsigned int c = _kids[0]->_cost[VREGF]+INSN_COST * 5;
        DFA_PRODUCTION__SET_VALID(IREGINOSP, convF2I_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI, convF2I_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R0, convF2I_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R2, convF2I_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R3, convF2I_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R4, convF2I_reg_reg_rule, c)
    }
}
void  State::_sub_Op_ConvF2L(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VREGF) ) {
      unsigned int c = _kids[0]->_cost[VREGF]+INSN_COST * 5;
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, convF2L_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL, convF2L_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL_R11, convF2L_reg_reg_rule, c)
    }
}
void  State::_sub_Op_ConvI2D(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I]+INSN_COST * 5;
        DFA_PRODUCTION__SET_VALID(VREGD, convI2D_reg_reg_rule, c)
    }
}
void  State::_sub_Op_ConvI2F(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I]+INSN_COST * 5;
        DFA_PRODUCTION__SET_VALID(VREGF, convI2F_reg_reg_rule, c)
    }
}
void  State::_sub_Op_ConvI2L(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I] + INSN_COST;
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, convI2L_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL, convI2L_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL_R11, convI2L_reg_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _ANDI__URSHIFTI_IREGIORL2I_IMMI_IMMI_BITMASK) &&
        (
#line 10948 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
(exact_log2(n->in(1)->in(2)->get_int() + 1) + (n->in(1)->in(1)->in(2)->get_int() & 31)) <= (31 + 1)
#line 5338 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_ANDI__URSHIFTI_IREGIORL2I_IMMI_IMMI_BITMASK]+INSN_COST * 2;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, ubfxIConvI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, ubfxIConvI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R11) || _cost[IREGL_R11] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R11, ubfxIConvI2L_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I];
        DFA_PRODUCTION__SET_VALID(_CONVI2L_IREGIORL2I_, _ConvI2L_iRegIorL2I__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_INDIRECT_) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_INDIRECT_];
        DFA_PRODUCTION__SET_VALID(_CONVI2L__LOADI_INDIRECT__, _ConvI2L__LoadI_indirect___rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADS_INDIRECT_) ) {
      unsigned int c = _kids[0]->_cost[_LOADS_INDIRECT_] + VOLATILE_REF_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, loadS2L_volatile_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, loadS2L_volatile_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R11) || _cost[IREGL_R11] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R11, loadS2L_volatile_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADUS_INDIRECT_) ) {
      unsigned int c = _kids[0]->_cost[_LOADUS_INDIRECT_] + VOLATILE_REF_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, loadUS2L_volatile_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, loadUS2L_volatile_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R11) || _cost[IREGL_R11] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R11, loadUS2L_volatile_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADUB_INDIRECT_) ) {
      unsigned int c = _kids[0]->_cost[_LOADUB_INDIRECT_] + VOLATILE_REF_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, loadUB2L_volatile_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, loadUB2L_volatile_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R11) || _cost[IREGL_R11] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R11, loadUB2L_volatile_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADB_INDIRECT_) ) {
      unsigned int c = _kids[0]->_cost[_LOADB_INDIRECT_] + VOLATILE_REF_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, loadB2L_volatile_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, loadB2L_volatile_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R11) || _cost[IREGL_R11] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R11, loadB2L_volatile_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_];
        DFA_PRODUCTION__SET_VALID(_CONVI2L__LOADI_MEMORY__, _ConvI2L__LoadI_memory___rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) &&
        (
#line 6428 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
!needs_acquiring_load(n->in(1))
#line 5415 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+4 * INSN_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, loadI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, loadI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R11) || _cost[IREGL_R11] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R11, loadI2L_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADUS_MEMORY_) &&
        (
#line 6400 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
!needs_acquiring_load(n->in(1))
#line 5432 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADUS_MEMORY_]+4 * INSN_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, loadUS2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, loadUS2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R11) || _cost[IREGL_R11] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R11, loadUS2L_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADS_MEMORY_) &&
        (
#line 6372 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
!needs_acquiring_load(n->in(1))
#line 5449 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADS_MEMORY_]+4 * INSN_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, loadS2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, loadS2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R11) || _cost[IREGL_R11] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R11, loadS2L_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADUB_MEMORY_) &&
        (
#line 6344 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
!needs_acquiring_load(n->in(1))
#line 5466 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADUB_MEMORY_]+4 * INSN_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, loadUB2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, loadUB2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R11) || _cost[IREGL_R11] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R11, loadUB2L_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADB_MEMORY_) &&
        (
#line 6316 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
!needs_acquiring_load(n->in(1))
#line 5483 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADB_MEMORY_]+4 * INSN_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, loadB2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, loadB2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R11) || _cost[IREGL_R11] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R11, loadB2L_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGI) ) {
      unsigned int c = _kids[0]->_cost[IREGI];
        DFA_PRODUCTION__SET_VALID(_CONVI2L_IREGI_, _ConvI2L_iRegI__rule, c)
    }
}
void  State::_sub_Op_ConvL2D(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGL) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+INSN_COST * 5;
        DFA_PRODUCTION__SET_VALID(VREGD, convL2D_reg_reg_rule, c)
    }
}
void  State::_sub_Op_ConvL2F(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGL) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+INSN_COST * 5;
        DFA_PRODUCTION__SET_VALID(VREGF, convL2F_reg_reg_rule, c)
    }
}
void  State::_sub_Op_ConvL2I(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGL) ) {
      unsigned int c = _kids[0]->_cost[IREGL] + INSN_COST;
        DFA_PRODUCTION__SET_VALID(IREGINOSP, convL2I_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI, convL2I_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R0, convL2I_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R2, convL2I_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R3, convL2I_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R4, convL2I_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) ) {
      unsigned int c = _kids[0]->_cost[IREGL];
        DFA_PRODUCTION__SET_VALID(_CONVL2I_IREGL_, _ConvL2I_iRegL__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _CASTP2X__DECODEN_IREGN__) &&
        (
#line 7801 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
Universe::narrow_oop_shift() == 0
#line 5532 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_CASTP2X__DECODEN_IREGN__] + INSN_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, convN2I_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, convN2I_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R0) || _cost[IREGI_R0] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R0, convN2I_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R2) || _cost[IREGI_R2] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R2, convN2I_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R3) || _cost[IREGI_R3] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R3, convN2I_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R4) || _cost[IREGI_R4] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R4, convN2I_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _CASTP2X_IREGP_) ) {
      unsigned int c = _kids[0]->_cost[_CASTP2X_IREGP_] + INSN_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, convP2I_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, convP2I_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R0) || _cost[IREGI_R0] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R0, convP2I_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R2) || _cost[IREGI_R2] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R2, convP2I_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R3) || _cost[IREGI_R3] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R3, convP2I_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R4) || _cost[IREGI_R4] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R4, convP2I_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) ) {
      unsigned int c = _kids[0]->_cost[IREGL];
        DFA_PRODUCTION__SET_VALID(IREGL2I, iRegL2I_rule, c)
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegL2I_rule, c)
      }
    }
}
void  State::_sub_Op_CountedLoopEnd(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], CMPOPU) && STATE__VALID_CHILD(_kids[1], RFLAGSREGU) ) {
      unsigned int c = _kids[0]->_cost[CMPOPU]+_kids[1]->_cost[RFLAGSREGU] + BRANCH_COST;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, branchLoopEndU_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOP) && STATE__VALID_CHILD(_kids[1], RFLAGSREG) ) {
      unsigned int c = _kids[0]->_cost[CMPOP]+_kids[1]->_cost[RFLAGSREG] + BRANCH_COST;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, branchLoopEnd_rule, c)
      }
    }
}
void  State::_sub_Op_CountLeadingZerosI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I] + INSN_COST;
        DFA_PRODUCTION__SET_VALID(IREGINOSP, countLeadingZerosI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI, countLeadingZerosI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R0, countLeadingZerosI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R2, countLeadingZerosI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R3, countLeadingZerosI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R4, countLeadingZerosI_rule, c)
    }
}
void  State::_sub_Op_CountLeadingZerosL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGL) ) {
      unsigned int c = _kids[0]->_cost[IREGL] + INSN_COST;
        DFA_PRODUCTION__SET_VALID(IREGINOSP, countLeadingZerosL_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI, countLeadingZerosL_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R0, countLeadingZerosL_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R2, countLeadingZerosL_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R3, countLeadingZerosL_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R4, countLeadingZerosL_rule, c)
    }
}
void  State::_sub_Op_CountTrailingZerosI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I]+INSN_COST * 2;
        DFA_PRODUCTION__SET_VALID(IREGINOSP, countTrailingZerosI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI, countTrailingZerosI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R0, countTrailingZerosI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R2, countTrailingZerosI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R3, countTrailingZerosI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R4, countTrailingZerosI_rule, c)
    }
}
void  State::_sub_Op_CountTrailingZerosL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGL) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+INSN_COST * 2;
        DFA_PRODUCTION__SET_VALID(IREGINOSP, countTrailingZerosL_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI, countTrailingZerosL_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R0, countTrailingZerosL_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R2, countTrailingZerosL_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R3, countTrailingZerosL_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R4, countTrailingZerosL_rule, c)
    }
}
void  State::_sub_Op_CreateEx(const Node *n){
    {
      unsigned int c = INSN_COST;
        DFA_PRODUCTION__SET_VALID(IREGP_R0, CreateException_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP, CreateException_rule, c)
        DFA_PRODUCTION__SET_VALID(INLINE_CACHE_REGP, CreateException_rule, c)
        DFA_PRODUCTION__SET_VALID(INTERPRETER_METHOD_OOP_REGP, CreateException_rule, c)
        DFA_PRODUCTION__SET_VALID(THREAD_REGP, CreateException_rule, c)
        DFA_PRODUCTION__SET_VALID(LR_REGP, CreateException_rule, c)
        DFA_PRODUCTION__SET_VALID(INDIRECT, CreateException_rule, c)
        DFA_PRODUCTION__SET_VALID(VMEM4, indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(VMEM8, indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(VMEM16, indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
    }
}
void  State::_sub_Op_DecodeN(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGN) &&
        (
#line 7854 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
n->bottom_type()->is_ptr()->ptr() == TypePtr::NotNull ||
            n->bottom_type()->is_ptr()->ptr() == TypePtr::Constant
#line 5671 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IREGN]+INSN_COST * 3;
        DFA_PRODUCTION__SET_VALID(IREGPNOSP, decodeHeapOop_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP, decodeHeapOop_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(INLINE_CACHE_REGP, decodeHeapOop_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(INTERPRETER_METHOD_OOP_REGP, decodeHeapOop_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(THREAD_REGP, decodeHeapOop_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(LR_REGP, decodeHeapOop_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(INDIRECT, decodeHeapOop_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(VMEM4, indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(VMEM8, indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(VMEM16, indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R0, decodeHeapOop_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R1, decodeHeapOop_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R2, decodeHeapOop_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R3, decodeHeapOop_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R4, decodeHeapOop_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R5, decodeHeapOop_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R10, decodeHeapOop_not_null_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGN) &&
        (
#line 7840 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
n->bottom_type()->is_ptr()->ptr() != TypePtr::NotNull &&
            n->bottom_type()->is_ptr()->ptr() != TypePtr::Constant
#line 5698 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IREGN]+INSN_COST * 3;
      if (STATE__NOT_YET_VALID(IREGPNOSP) || _cost[IREGPNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGPNOSP, decodeHeapOop_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP) || _cost[IREGP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGP, decodeHeapOop_rule, c)
      }
      if (STATE__NOT_YET_VALID(INLINE_CACHE_REGP) || _cost[INLINE_CACHE_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(INLINE_CACHE_REGP, decodeHeapOop_rule, c)
      }
      if (STATE__NOT_YET_VALID(INTERPRETER_METHOD_OOP_REGP) || _cost[INTERPRETER_METHOD_OOP_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(INTERPRETER_METHOD_OOP_REGP, decodeHeapOop_rule, c)
      }
      if (STATE__NOT_YET_VALID(THREAD_REGP) || _cost[THREAD_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(THREAD_REGP, decodeHeapOop_rule, c)
      }
      if (STATE__NOT_YET_VALID(LR_REGP) || _cost[LR_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(LR_REGP, decodeHeapOop_rule, c)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c) {
        DFA_PRODUCTION__SET_VALID(INDIRECT, decodeHeapOop_rule, c)
      }
      if (STATE__NOT_YET_VALID(VMEM4) || _cost[VMEM4] > c) {
        DFA_PRODUCTION__SET_VALID(VMEM4, indirect_rule, c)
      }
      if (STATE__NOT_YET_VALID(VMEM8) || _cost[VMEM8] > c) {
        DFA_PRODUCTION__SET_VALID(VMEM8, indirect_rule, c)
      }
      if (STATE__NOT_YET_VALID(VMEM16) || _cost[VMEM16] > c) {
        DFA_PRODUCTION__SET_VALID(VMEM16, indirect_rule, c)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R0) || _cost[IREGP_R0] > c) {
        DFA_PRODUCTION__SET_VALID(IREGP_R0, decodeHeapOop_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R1) || _cost[IREGP_R1] > c) {
        DFA_PRODUCTION__SET_VALID(IREGP_R1, decodeHeapOop_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R2) || _cost[IREGP_R2] > c) {
        DFA_PRODUCTION__SET_VALID(IREGP_R2, decodeHeapOop_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R3) || _cost[IREGP_R3] > c) {
        DFA_PRODUCTION__SET_VALID(IREGP_R3, decodeHeapOop_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R4) || _cost[IREGP_R4] > c) {
        DFA_PRODUCTION__SET_VALID(IREGP_R4, decodeHeapOop_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R5) || _cost[IREGP_R5] > c) {
        DFA_PRODUCTION__SET_VALID(IREGP_R5, decodeHeapOop_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R10) || _cost[IREGP_R10] > c) {
        DFA_PRODUCTION__SET_VALID(IREGP_R10, decodeHeapOop_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGN) ) {
      unsigned int c = _kids[0]->_cost[IREGN];
        DFA_PRODUCTION__SET_VALID(_DECODEN_IREGN_, _DecodeN_iRegN__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGN) &&
        
#line 4987 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
Universe::narrow_oop_shift() == 0
#line 5764 "../generated/adfiles/dfa_aarch64.cpp"
 ) {
      unsigned int c = _kids[0]->_cost[IREGN];
        DFA_PRODUCTION__SET_VALID(INDIRECTN, indirectN_rule, c)
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indirectN_rule, c)
      }
    }
}
void  State::_sub_Op_DecodeNKlass(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGN) ) {
      unsigned int c = _kids[0]->_cost[IREGN]+INSN_COST * 3;
        DFA_PRODUCTION__SET_VALID(IREGPNOSP, decodeKlass_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP, decodeKlass_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(INLINE_CACHE_REGP, decodeKlass_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(INTERPRETER_METHOD_OOP_REGP, decodeKlass_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(THREAD_REGP, decodeKlass_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(LR_REGP, decodeKlass_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(INDIRECT, decodeKlass_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(VMEM4, indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(VMEM8, indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(VMEM16, indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R0, decodeKlass_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R1, decodeKlass_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R2, decodeKlass_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R3, decodeKlass_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R4, decodeKlass_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R5, decodeKlass_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R10, decodeKlass_not_null_rule, c)
    }
}
void  State::_sub_Op_DivD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VREGD) && STATE__VALID_CHILD(_kids[1], VREGD) ) {
      unsigned int c = _kids[0]->_cost[VREGD]+_kids[1]->_cost[VREGD]+INSN_COST * 32;
        DFA_PRODUCTION__SET_VALID(VREGD, divD_reg_reg_rule, c)
    }
}
void  State::_sub_Op_DivF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VREGF) && STATE__VALID_CHILD(_kids[1], VREGF) ) {
      unsigned int c = _kids[0]->_cost[VREGF]+_kids[1]->_cost[VREGF]+INSN_COST * 18;
        DFA_PRODUCTION__SET_VALID(VREGF, divF_reg_reg_rule, c)
    }
}
void  State::_sub_Op_DivI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) && STATE__VALID_CHILD(_kids[1], IREGIORL2I) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I]+_kids[1]->_cost[IREGIORL2I]+INSN_COST * 19;
        DFA_PRODUCTION__SET_VALID(IREGINOSP, divI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI, divI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R0, divI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R2, divI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R3, divI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R4, divI_rule, c)
    }
}
void  State::_sub_Op_DivL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IREGL) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IREGL]+INSN_COST * 35;
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, divL_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL, divL_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL_R11, divL_rule, c)
    }
}
void  State::_sub_Op_EncodeISOArray(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGP_R2) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGP_R1_IREGI_R3) ) {
      unsigned int c = _kids[0]->_cost[IREGP_R2]+_kids[1]->_cost[_BINARY_IREGP_R1_IREGI_R3] + INSN_COST;
        DFA_PRODUCTION__SET_VALID(IREGI_R0, encode_iso_array_rule, c)
    }
}
void  State::_sub_Op_EncodeP(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGP) &&
        (
#line 7829 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
n->bottom_type()->make_ptr()->ptr() == TypePtr::NotNull
#line 5839 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IREGP]+INSN_COST * 3;
        DFA_PRODUCTION__SET_VALID(IREGNNOSP, encodeHeapOop_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGN, encodeHeapOop_not_null_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGP) &&
        (
#line 7815 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
n->bottom_type()->make_ptr()->ptr() != TypePtr::NotNull
#line 5849 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IREGP]+INSN_COST * 3;
      if (STATE__NOT_YET_VALID(IREGNNOSP) || _cost[IREGNNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGNNOSP, encodeHeapOop_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGN) || _cost[IREGN] > c) {
        DFA_PRODUCTION__SET_VALID(IREGN, encodeHeapOop_rule, c)
      }
    }
}
void  State::_sub_Op_EncodePKlass(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGP) ) {
      unsigned int c = _kids[0]->_cost[IREGP]+INSN_COST * 3;
        DFA_PRODUCTION__SET_VALID(IREGNNOSP, encodeKlass_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGN, encodeKlass_not_null_rule, c)
    }
}
void  State::_sub_Op_FastLock(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGP) && STATE__VALID_CHILD(_kids[1], IREGP) ) {
      unsigned int c = _kids[0]->_cost[IREGP]+_kids[1]->_cost[IREGP]+5 * INSN_COST;
        DFA_PRODUCTION__SET_VALID(RFLAGSREG, cmpFastLock_rule, c)
    }
}
void  State::_sub_Op_FastUnlock(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGP) && STATE__VALID_CHILD(_kids[1], IREGP) ) {
      unsigned int c = _kids[0]->_cost[IREGP]+_kids[1]->_cost[IREGP]+5 * INSN_COST;
        DFA_PRODUCTION__SET_VALID(RFLAGSREG, cmpFastUnlock_rule, c)
    }
}
void  State::_sub_Op_Goto(const Node *n){
    {
      unsigned int c = BRANCH_COST;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, branch_rule, c)
    }
}
void  State::_sub_Op_Halt(const Node *n){
    {
      unsigned int c = CALL_COST;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, ShouldNotReachHere_rule, c)
    }
}
void  State::_sub_Op_If(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], CMPOP) && STATE__VALID_CHILD(_kids[1], _CMPI__ANDI_IREGIORL2I_IMMI_IMMI0) &&
        (
#line 13530 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
(n->in(1)->as_Bool()->_test._test == BoolTest::ne
            || n->in(1)->as_Bool()->_test._test == BoolTest::eq)
            && is_power_of_2(n->in(2)->in(1)->in(2)->get_int())
#line 5898 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[CMPOP]+_kids[1]->_cost[_CMPI__ANDI_IREGIORL2I_IMMI_IMMI0] + BRANCH_COST;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, far_cmpI_branch_bit_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOP) && STATE__VALID_CHILD(_kids[1], _CMPL__ANDL_IREGL_IMML_IMML0) &&
        (
#line 13512 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
(n->in(1)->as_Bool()->_test._test == BoolTest::ne
            || n->in(1)->as_Bool()->_test._test == BoolTest::eq)
            && is_power_of_2(n->in(2)->in(1)->in(2)->get_long())
#line 5909 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[CMPOP]+_kids[1]->_cost[_CMPL__ANDL_IREGL_IMML_IMML0] + BRANCH_COST;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, far_cmpL_branch_bit_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOP) && STATE__VALID_CHILD(_kids[1], _CMPI_IREGIORL2I_IMMI0) &&
        (
#line 13495 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
n->in(1)->as_Bool()->_test._test == BoolTest::lt
            || n->in(1)->as_Bool()->_test._test == BoolTest::ge
#line 5921 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[CMPOP]+_kids[1]->_cost[_CMPI_IREGIORL2I_IMMI0] + BRANCH_COST;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, far_cmpI_branch_sign_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOP) && STATE__VALID_CHILD(_kids[1], _CMPL_IREGL_IMML0) &&
        (
#line 13478 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
n->in(1)->as_Bool()->_test._test == BoolTest::lt
            || n->in(1)->as_Bool()->_test._test == BoolTest::ge
#line 5933 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[CMPOP]+_kids[1]->_cost[_CMPL_IREGL_IMML0] + BRANCH_COST;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, far_cmpL_branch_sign_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOPU) && STATE__VALID_CHILD(_kids[1], _CMPUL_IREGL_IMML0) &&
        (
#line 13379 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
n->in(1)->as_Bool()->_test._test == BoolTest::ne
            || n->in(1)->as_Bool()->_test._test == BoolTest::eq
            || n->in(1)->as_Bool()->_test._test == BoolTest::gt
            || n->in(1)->as_Bool()->_test._test == BoolTest::le
#line 5947 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[CMPOPU]+_kids[1]->_cost[_CMPUL_IREGL_IMML0] + BRANCH_COST;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, cmpUL_imm0_branch_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOPU) && STATE__VALID_CHILD(_kids[1], _CMPU_IREGIORL2I_IMMI0) &&
        (
#line 13358 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
n->in(1)->as_Bool()->_test._test == BoolTest::ne
            || n->in(1)->as_Bool()->_test._test == BoolTest::eq
            || n->in(1)->as_Bool()->_test._test == BoolTest::gt
            ||  n->in(1)->as_Bool()->_test._test == BoolTest::le
#line 5961 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[CMPOPU]+_kids[1]->_cost[_CMPU_IREGIORL2I_IMMI0] + BRANCH_COST;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, cmpUI_imm0_branch_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOP) && STATE__VALID_CHILD(_kids[1], _CMPP__DECODEN_IREGN__IMMP0) &&
        (
#line 13339 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
n->in(1)->as_Bool()->_test._test == BoolTest::ne
            || n->in(1)->as_Bool()->_test._test == BoolTest::eq
#line 5973 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[CMPOP]+_kids[1]->_cost[_CMPP__DECODEN_IREGN__IMMP0] + BRANCH_COST;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, cmpP_narrowOop_imm0_branch_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOP) && STATE__VALID_CHILD(_kids[1], _CMPN_IREGN_IMMN0) &&
        (
#line 13320 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
n->in(1)->as_Bool()->_test._test == BoolTest::ne
	    || n->in(1)->as_Bool()->_test._test == BoolTest::eq
#line 5985 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[CMPOP]+_kids[1]->_cost[_CMPN_IREGN_IMMN0] + BRANCH_COST;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, cmpN_imm0_branch_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOP) && STATE__VALID_CHILD(_kids[1], _CMPP_IREGP_IMMP0) &&
        (
#line 13301 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
n->in(1)->as_Bool()->_test._test == BoolTest::ne
	    || n->in(1)->as_Bool()->_test._test == BoolTest::eq
#line 5997 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[CMPOP]+_kids[1]->_cost[_CMPP_IREGP_IMMP0] + BRANCH_COST;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, cmpP_imm0_branch_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOP) && STATE__VALID_CHILD(_kids[1], _CMPL_IREGL_IMML0) &&
        (
#line 13282 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
n->in(1)->as_Bool()->_test._test == BoolTest::ne
	    || n->in(1)->as_Bool()->_test._test == BoolTest::eq
#line 6009 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[CMPOP]+_kids[1]->_cost[_CMPL_IREGL_IMML0] + BRANCH_COST;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, cmpL_imm0_branch_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOP) && STATE__VALID_CHILD(_kids[1], _CMPI_IREGIORL2I_IMMI0) &&
        (
#line 13263 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
n->in(1)->as_Bool()->_test._test == BoolTest::ne
	    || n->in(1)->as_Bool()->_test._test == BoolTest::eq
#line 6021 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[CMPOP]+_kids[1]->_cost[_CMPI_IREGIORL2I_IMMI0] + BRANCH_COST;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, cmpI_imm0_branch_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOPU) && STATE__VALID_CHILD(_kids[1], RFLAGSREGU) ) {
      unsigned int c = _kids[0]->_cost[CMPOPU]+_kids[1]->_cost[RFLAGSREGU] + BRANCH_COST;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, branchConU_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOP) && STATE__VALID_CHILD(_kids[1], RFLAGSREG) ) {
      unsigned int c = _kids[0]->_cost[CMPOP]+_kids[1]->_cost[RFLAGSREG] + BRANCH_COST;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, branchCon_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOP) && STATE__VALID_CHILD(_kids[1], _OVERFLOWMULL_IREGL_IREGL) &&
        (
#line 12605 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
n->in(1)->as_Bool()->_test._test == BoolTest::overflow
	    || n->in(1)->as_Bool()->_test._test == BoolTest::no_overflow
#line 6045 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[CMPOP]+_kids[1]->_cost[_OVERFLOWMULL_IREGL_IREGL]+4 * INSN_COST;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, overflowMulL_reg_branch_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOP) && STATE__VALID_CHILD(_kids[1], _OVERFLOWMULI_IREGIORL2I_IREGIORL2I) &&
        (
#line 12560 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
n->in(1)->as_Bool()->_test._test == BoolTest::overflow
	    || n->in(1)->as_Bool()->_test._test == BoolTest::no_overflow
#line 6057 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[CMPOP]+_kids[1]->_cost[_OVERFLOWMULI_IREGIORL2I_IREGIORL2I]+3 * INSN_COST;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, overflowMulI_reg_branch_rule, c)
      }
    }
}
void  State::_sub_Op_LShiftI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) && STATE__VALID_CHILD(_kids[1], IMMI_24) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I]+_kids[1]->_cost[IMMI_24];
        DFA_PRODUCTION__SET_VALID(_LSHIFTI_IREGIORL2I_IMMI_24, _LShiftI_iRegIorL2I_immI_24_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) && STATE__VALID_CHILD(_kids[1], IMMI_16) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I]+_kids[1]->_cost[IMMI_16];
        DFA_PRODUCTION__SET_VALID(_LSHIFTI_IREGIORL2I_IMMI_16, _LShiftI_iRegIorL2I_immI_16_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGI) && STATE__VALID_CHILD(_kids[1], _SUBI_IMMI0_IREGI) ) {
      unsigned int c = _kids[0]->_cost[IREGI]+_kids[1]->_cost[_SUBI_IMMI0_IREGI];
        DFA_PRODUCTION__SET_VALID(_LSHIFTI_IREGI__SUBI_IMMI0_IREGI, _LShiftI_iRegI__SubI_immI0_iRegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGI) && STATE__VALID_CHILD(_kids[1], _SUBI_IMMI_32_IREGI) ) {
      unsigned int c = _kids[0]->_cost[IREGI]+_kids[1]->_cost[_SUBI_IMMI_32_IREGI];
        DFA_PRODUCTION__SET_VALID(_LSHIFTI_IREGI__SUBI_IMMI_32_IREGI, _LShiftI_iRegI__SubI_immI_32_iRegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGI) && STATE__VALID_CHILD(_kids[1], IREGI) ) {
      unsigned int c = _kids[0]->_cost[IREGI]+_kids[1]->_cost[IREGI];
        DFA_PRODUCTION__SET_VALID(_LSHIFTI_IREGI_IREGI, _LShiftI_iRegI_iRegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I]+_kids[1]->_cost[IMMI];
        DFA_PRODUCTION__SET_VALID(_LSHIFTI_IREGIORL2I_IMMI, _LShiftI_iRegIorL2I_immI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I]+_kids[1]->_cost[IMMI] + INSN_COST;
        DFA_PRODUCTION__SET_VALID(IREGINOSP, lShiftI_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI, lShiftI_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R0, lShiftI_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R2, lShiftI_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R3, lShiftI_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R4, lShiftI_reg_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) && STATE__VALID_CHILD(_kids[1], IREGIORL2I) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I]+_kids[1]->_cost[IREGIORL2I]+INSN_COST * 2;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, lShiftI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, lShiftI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R0) || _cost[IREGI_R0] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R0, lShiftI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R2) || _cost[IREGI_R2] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R2, lShiftI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R3) || _cost[IREGI_R3] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R3, lShiftI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R4) || _cost[IREGI_R4] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R4, lShiftI_reg_reg_rule, c)
      }
    }
}
void  State::_sub_Op_LShiftL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IMMI_56) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IMMI_56];
        DFA_PRODUCTION__SET_VALID(_LSHIFTL_IREGL_IMMI_56, _LShiftL_iRegL_immI_56_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IMMI_32) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IMMI_32];
        DFA_PRODUCTION__SET_VALID(_LSHIFTL_IREGL_IMMI_32, _LShiftL_iRegL_immI_32_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IMMI_48) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IMMI_48];
        DFA_PRODUCTION__SET_VALID(_LSHIFTL_IREGL_IMMI_48, _LShiftL_iRegL_immI_48_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], _SUBI_IMMI0_IREGI) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[_SUBI_IMMI0_IREGI];
        DFA_PRODUCTION__SET_VALID(_LSHIFTL_IREGL__SUBI_IMMI0_IREGI, _LShiftL_iRegL__SubI_immI0_iRegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], _SUBI_IMMI_64_IREGI) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[_SUBI_IMMI_64_IREGI];
        DFA_PRODUCTION__SET_VALID(_LSHIFTL_IREGL__SUBI_IMMI_64_IREGI, _LShiftL_iRegL__SubI_immI_64_iRegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IREGI) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IREGI];
        DFA_PRODUCTION__SET_VALID(_LSHIFTL_IREGL_IREGI, _LShiftL_iRegL_iRegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IMMI];
        DFA_PRODUCTION__SET_VALID(_LSHIFTL_IREGL_IMMI, _LShiftL_iRegL_immI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IMMI] + INSN_COST;
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, lShiftL_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL, lShiftL_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL_R11, lShiftL_reg_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IREGIORL2I) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IREGIORL2I]+INSN_COST * 2;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, lShiftL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, lShiftL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R11) || _cost[IREGL_R11] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R11, lShiftL_reg_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _CONVI2L_IREGIORL2I_) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[_CONVI2L_IREGIORL2I_]+_kids[1]->_cost[IMMI] + INSN_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, lshift_ext_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, lshift_ext_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R11) || _cost[IREGL_R11] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R11, lshift_ext_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _CONVI2L_IREGIORL2I_) && STATE__VALID_CHILD(_kids[1], IMMISCALE) ) {
      unsigned int c = _kids[0]->_cost[_CONVI2L_IREGIORL2I_]+_kids[1]->_cost[IMMISCALE];
        DFA_PRODUCTION__SET_VALID(_LSHIFTL__CONVI2L_IREGIORL2I__IMMISCALE, _LShiftL__ConvI2L_iRegIorL2I__immIScale_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _CONVI2L_IREGI_) && STATE__VALID_CHILD(_kids[1], IMMISCALE) ) {
      unsigned int c = _kids[0]->_cost[_CONVI2L_IREGI_]+_kids[1]->_cost[IMMISCALE];
        DFA_PRODUCTION__SET_VALID(_LSHIFTL__CONVI2L_IREGI__IMMISCALE, _LShiftL__ConvI2L_iRegI__immIScale_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IMMISCALE) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IMMISCALE];
        DFA_PRODUCTION__SET_VALID(_LSHIFTL_IREGL_IMMISCALE, _LShiftL_iRegL_immIScale_rule, c)
    }
}
void  State::_sub_Op_LoadB(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT];
        DFA_PRODUCTION__SET_VALID(_LOADB_INDIRECT_, _LoadB_indirect__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT] + VOLATILE_REF_COST;
        DFA_PRODUCTION__SET_VALID(IREGINOSP, loadB_volatile_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI, loadB_volatile_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R0, loadB_volatile_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R2, loadB_volatile_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R3, loadB_volatile_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R4, loadB_volatile_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY];
        DFA_PRODUCTION__SET_VALID(_LOADB_MEMORY_, _LoadB_memory__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) &&
        (
#line 6302 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
!needs_acquiring_load(n)
#line 6220 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+4 * INSN_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, loadB_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, loadB_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R0) || _cost[IREGI_R0] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R0, loadB_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R2) || _cost[IREGI_R2] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R2, loadB_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R3) || _cost[IREGI_R3] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R3, loadB_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R4) || _cost[IREGI_R4] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R4, loadB_rule, c)
      }
    }
}
void  State::_sub_Op_LoadUB(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT];
        DFA_PRODUCTION__SET_VALID(_LOADUB_INDIRECT_, _LoadUB_indirect__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT] + VOLATILE_REF_COST;
        DFA_PRODUCTION__SET_VALID(IREGINOSP, loadUB_volatile_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI, loadUB_volatile_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R0, loadUB_volatile_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R2, loadUB_volatile_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R3, loadUB_volatile_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R4, loadUB_volatile_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY];
        DFA_PRODUCTION__SET_VALID(_LOADUB_MEMORY_, _LoadUB_memory__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) &&
        (
#line 6330 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
!needs_acquiring_load(n)
#line 6269 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+4 * INSN_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, loadUB_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, loadUB_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R0) || _cost[IREGI_R0] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R0, loadUB_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R2) || _cost[IREGI_R2] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R2, loadUB_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R3) || _cost[IREGI_R3] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R3, loadUB_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R4) || _cost[IREGI_R4] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R4, loadUB_rule, c)
      }
    }
}
void  State::_sub_Op_LoadUS(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT];
        DFA_PRODUCTION__SET_VALID(_LOADUS_INDIRECT_, _LoadUS_indirect__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT] + VOLATILE_REF_COST;
        DFA_PRODUCTION__SET_VALID(IREGINOSP, loadUS_volatile_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI, loadUS_volatile_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R0, loadUS_volatile_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R2, loadUS_volatile_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R3, loadUS_volatile_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R4, loadUS_volatile_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY];
        DFA_PRODUCTION__SET_VALID(_LOADUS_MEMORY_, _LoadUS_memory__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) &&
        (
#line 6386 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
!needs_acquiring_load(n)
#line 6318 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+4 * INSN_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, loadUS_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, loadUS_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R0) || _cost[IREGI_R0] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R0, loadUS_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R2) || _cost[IREGI_R2] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R2, loadUS_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R3) || _cost[IREGI_R3] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R3, loadUS_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R4) || _cost[IREGI_R4] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R4, loadUS_rule, c)
      }
    }
}
void  State::_sub_Op_LoadD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT] + VOLATILE_REF_COST;
        DFA_PRODUCTION__SET_VALID(VREGD, loadD_volatile_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) &&
        (
#line 6553 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
!needs_acquiring_load(n)
#line 6353 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+4 * INSN_COST;
      if (STATE__NOT_YET_VALID(VREGD) || _cost[VREGD] > c) {
        DFA_PRODUCTION__SET_VALID(VREGD, loadD_rule, c)
      }
    }
}
void  State::_sub_Op_LoadF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT] + VOLATILE_REF_COST;
        DFA_PRODUCTION__SET_VALID(VREGF, loadF_volatile_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) &&
        (
#line 6539 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
!needs_acquiring_load(n)
#line 6370 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+4 * INSN_COST;
      if (STATE__NOT_YET_VALID(VREGF) || _cost[VREGF] > c) {
        DFA_PRODUCTION__SET_VALID(VREGF, loadF_rule, c)
      }
    }
}
void  State::_sub_Op_LoadI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT];
        DFA_PRODUCTION__SET_VALID(_LOADI_INDIRECT_, _LoadI_indirect__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT] + VOLATILE_REF_COST;
        DFA_PRODUCTION__SET_VALID(IREGINOSP, loadI_volatile_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI, loadI_volatile_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R0, loadI_volatile_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R2, loadI_volatile_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R3, loadI_volatile_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R4, loadI_volatile_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY];
        DFA_PRODUCTION__SET_VALID(_LOADI_MEMORY_, _LoadI_memory__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) &&
        (
#line 6414 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
!needs_acquiring_load(n)
#line 6401 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+4 * INSN_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, loadI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, loadI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R0) || _cost[IREGI_R0] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R0, loadI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R2) || _cost[IREGI_R2] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R2, loadI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R3) || _cost[IREGI_R3] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R3, loadI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R4) || _cost[IREGI_R4] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R4, loadI_rule, c)
      }
    }
}
void  State::_sub_Op_LoadKlass(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) &&
        (
#line 6511 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
!needs_acquiring_load(n)
#line 6432 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+4 * INSN_COST;
        DFA_PRODUCTION__SET_VALID(IREGPNOSP, loadKlass_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP, loadKlass_rule, c)
        DFA_PRODUCTION__SET_VALID(INLINE_CACHE_REGP, loadKlass_rule, c)
        DFA_PRODUCTION__SET_VALID(INTERPRETER_METHOD_OOP_REGP, loadKlass_rule, c)
        DFA_PRODUCTION__SET_VALID(THREAD_REGP, loadKlass_rule, c)
        DFA_PRODUCTION__SET_VALID(LR_REGP, loadKlass_rule, c)
        DFA_PRODUCTION__SET_VALID(INDIRECT, loadKlass_rule, c)
        DFA_PRODUCTION__SET_VALID(VMEM4, indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(VMEM8, indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(VMEM16, indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R0, loadKlass_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R1, loadKlass_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R2, loadKlass_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R3, loadKlass_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R4, loadKlass_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R5, loadKlass_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R10, loadKlass_rule, c)
    }
}
void  State::_sub_Op_LoadNKlass(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) &&
        (
#line 6525 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
!needs_acquiring_load(n)
#line 6460 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+4 * INSN_COST;
        DFA_PRODUCTION__SET_VALID(IREGNNOSP, loadNKlass_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGN, loadNKlass_rule, c)
    }
}
void  State::_sub_Op_LoadL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY];
        DFA_PRODUCTION__SET_VALID(_LOADL_MEMORY_, _LoadL_memory__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT] + VOLATILE_REF_COST;
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, loadL_volatile_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL, loadL_volatile_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL_R11, loadL_volatile_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) &&
        (
#line 6456 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
!needs_acquiring_load(n)
#line 6482 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+4 * INSN_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, loadL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, loadL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R11) || _cost[IREGL_R11] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R11, loadL_rule, c)
      }
    }
}
void  State::_sub_Op_LoadPLocked(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT] + VOLATILE_REF_COST;
        DFA_PRODUCTION__SET_VALID(IREGPNOSP, loadPLocked_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP, loadPLocked_rule, c)
        DFA_PRODUCTION__SET_VALID(INLINE_CACHE_REGP, loadPLocked_rule, c)
        DFA_PRODUCTION__SET_VALID(INTERPRETER_METHOD_OOP_REGP, loadPLocked_rule, c)
        DFA_PRODUCTION__SET_VALID(THREAD_REGP, loadPLocked_rule, c)
        DFA_PRODUCTION__SET_VALID(LR_REGP, loadPLocked_rule, c)
        DFA_PRODUCTION__SET_VALID(INDIRECT, loadPLocked_rule, c)
        DFA_PRODUCTION__SET_VALID(VMEM4, indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(VMEM8, indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(VMEM16, indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R0, loadPLocked_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R1, loadPLocked_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R2, loadPLocked_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R3, loadPLocked_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R4, loadPLocked_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R5, loadPLocked_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R10, loadPLocked_rule, c)
    }
}
void  State::_sub_Op_LoadP(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT] + VOLATILE_REF_COST;
        DFA_PRODUCTION__SET_VALID(IREGPNOSP, loadP_volatile_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP, loadP_volatile_rule, c)
        DFA_PRODUCTION__SET_VALID(INLINE_CACHE_REGP, loadP_volatile_rule, c)
        DFA_PRODUCTION__SET_VALID(INTERPRETER_METHOD_OOP_REGP, loadP_volatile_rule, c)
        DFA_PRODUCTION__SET_VALID(THREAD_REGP, loadP_volatile_rule, c)
        DFA_PRODUCTION__SET_VALID(LR_REGP, loadP_volatile_rule, c)
        DFA_PRODUCTION__SET_VALID(INDIRECT, loadP_volatile_rule, c)
        DFA_PRODUCTION__SET_VALID(VMEM4, indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(VMEM8, indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(VMEM16, indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R0, loadP_volatile_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R1, loadP_volatile_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R2, loadP_volatile_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R3, loadP_volatile_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R4, loadP_volatile_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R5, loadP_volatile_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP_R10, loadP_volatile_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) &&
        (
#line 6483 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
!needs_acquiring_load(n)
#line 6545 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+4 * INSN_COST;
      if (STATE__NOT_YET_VALID(IREGPNOSP) || _cost[IREGPNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGPNOSP, loadP_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP) || _cost[IREGP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGP, loadP_rule, c)
      }
      if (STATE__NOT_YET_VALID(INLINE_CACHE_REGP) || _cost[INLINE_CACHE_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(INLINE_CACHE_REGP, loadP_rule, c)
      }
      if (STATE__NOT_YET_VALID(INTERPRETER_METHOD_OOP_REGP) || _cost[INTERPRETER_METHOD_OOP_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(INTERPRETER_METHOD_OOP_REGP, loadP_rule, c)
      }
      if (STATE__NOT_YET_VALID(THREAD_REGP) || _cost[THREAD_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(THREAD_REGP, loadP_rule, c)
      }
      if (STATE__NOT_YET_VALID(LR_REGP) || _cost[LR_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(LR_REGP, loadP_rule, c)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c) {
        DFA_PRODUCTION__SET_VALID(INDIRECT, loadP_rule, c)
      }
      if (STATE__NOT_YET_VALID(VMEM4) || _cost[VMEM4] > c) {
        DFA_PRODUCTION__SET_VALID(VMEM4, indirect_rule, c)
      }
      if (STATE__NOT_YET_VALID(VMEM8) || _cost[VMEM8] > c) {
        DFA_PRODUCTION__SET_VALID(VMEM8, indirect_rule, c)
      }
      if (STATE__NOT_YET_VALID(VMEM16) || _cost[VMEM16] > c) {
        DFA_PRODUCTION__SET_VALID(VMEM16, indirect_rule, c)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R0) || _cost[IREGP_R0] > c) {
        DFA_PRODUCTION__SET_VALID(IREGP_R0, loadP_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R1) || _cost[IREGP_R1] > c) {
        DFA_PRODUCTION__SET_VALID(IREGP_R1, loadP_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R2) || _cost[IREGP_R2] > c) {
        DFA_PRODUCTION__SET_VALID(IREGP_R2, loadP_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R3) || _cost[IREGP_R3] > c) {
        DFA_PRODUCTION__SET_VALID(IREGP_R3, loadP_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R4) || _cost[IREGP_R4] > c) {
        DFA_PRODUCTION__SET_VALID(IREGP_R4, loadP_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R5) || _cost[IREGP_R5] > c) {
        DFA_PRODUCTION__SET_VALID(IREGP_R5, loadP_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R10) || _cost[IREGP_R10] > c) {
        DFA_PRODUCTION__SET_VALID(IREGP_R10, loadP_rule, c)
      }
    }
}
void  State::_sub_Op_LoadN(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT] + VOLATILE_REF_COST;
        DFA_PRODUCTION__SET_VALID(IREGNNOSP, loadN_volatile_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGN, loadN_volatile_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) &&
        (
#line 6497 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
!needs_acquiring_load(n)
#line 6614 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+4 * INSN_COST;
      if (STATE__NOT_YET_VALID(IREGNNOSP) || _cost[IREGNNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGNNOSP, loadN_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGN) || _cost[IREGN] > c) {
        DFA_PRODUCTION__SET_VALID(IREGN, loadN_rule, c)
      }
    }
}
void  State::_sub_Op_LoadRange(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+4 * INSN_COST;
        DFA_PRODUCTION__SET_VALID(IREGINOSP, loadRange_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI, loadRange_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R0, loadRange_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R2, loadRange_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R3, loadRange_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R4, loadRange_rule, c)
    }
}
void  State::_sub_Op_LoadS(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT];
        DFA_PRODUCTION__SET_VALID(_LOADS_INDIRECT_, _LoadS_indirect__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT] + VOLATILE_REF_COST;
        DFA_PRODUCTION__SET_VALID(IREGINOSP, loadS_volatile_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI, loadS_volatile_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R0, loadS_volatile_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R2, loadS_volatile_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R3, loadS_volatile_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R4, loadS_volatile_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY];
        DFA_PRODUCTION__SET_VALID(_LOADS_MEMORY_, _LoadS_memory__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) &&
        (
#line 6358 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
!needs_acquiring_load(n)
#line 6660 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+4 * INSN_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, loadS_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, loadS_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R0) || _cost[IREGI_R0] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R0, loadS_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R2) || _cost[IREGI_R2] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R2, loadS_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R3) || _cost[IREGI_R3] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R3, loadS_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R4) || _cost[IREGI_R4] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R4, loadS_rule, c)
      }
    }
}
void  State::_sub_Op_MaxI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGI) && STATE__VALID_CHILD(_kids[1], IREGI) ) {
      unsigned int c = _kids[0]->_cost[IREGI]+_kids[1]->_cost[IREGI]+INSN_COST * 3;
        DFA_PRODUCTION__SET_VALID(IREGINOSP, maxI_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI, maxI_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R0, maxI_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R2, maxI_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R3, maxI_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R4, maxI_rReg_rule, c)
    }
}
void  State::_sub_Op_MemBarAcquire(const Node *n){
    {
      unsigned int c = VOLATILE_REF_COST;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, membar_acquire_rule, c)
    }
    if(         (
#line 7619 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
unnecessary_acquire(n)
#line 6706 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = 0;
        DFA_PRODUCTION(UNIVERSE, unnecessary_membar_acquire_rule, c)	  // overwrites higher cost rule
    }
}
void  State::_sub_Op_LoadFence(const Node *n){
    {
      unsigned int c = VOLATILE_REF_COST;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, load_fence_rule, c)
    }
}
void  State::_sub_Op_MemBarAcquireLock(const Node *n){
    {
      unsigned int c = VOLATILE_REF_COST;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, membar_acquire_lock_rule, c)
    }
}
void  State::_sub_Op_MemBarRelease(const Node *n){
    {
      unsigned int c = VOLATILE_REF_COST;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, membar_release_rule, c)
    }
    if(         (
#line 7673 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
unnecessary_release(n)
#line 6732 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = 0;
        DFA_PRODUCTION(UNIVERSE, unnecessary_membar_release_rule, c)	  // overwrites higher cost rule
    }
}
void  State::_sub_Op_StoreFence(const Node *n){
    {
      unsigned int c = VOLATILE_REF_COST;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, store_fence_rule, c)
    }
}
void  State::_sub_Op_MemBarReleaseLock(const Node *n){
    {
      unsigned int c = VOLATILE_REF_COST;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, membar_release_lock_rule, c)
    }
}
void  State::_sub_Op_MemBarVolatile(const Node *n){
    {
      unsigned int c = VOLATILE_REF_COST*100;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, membar_volatile_rule, c)
    }
    if(         (
#line 7724 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
unnecessary_volatile(n)
#line 6758 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = 0;
        DFA_PRODUCTION(UNIVERSE, unnecessary_membar_volatile_rule, c)	  // overwrites higher cost rule
    }
}
void  State::_sub_Op_MemBarStoreStore(const Node *n){
    {
      unsigned int c = VOLATILE_REF_COST;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, membar_storestore_rule, c)
    }
}
void  State::_sub_Op_MinI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGI) && STATE__VALID_CHILD(_kids[1], IREGI) ) {
      unsigned int c = _kids[0]->_cost[IREGI]+_kids[1]->_cost[IREGI]+INSN_COST * 3;
        DFA_PRODUCTION__SET_VALID(IREGINOSP, minI_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI, minI_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R0, minI_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R2, minI_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R3, minI_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R4, minI_rReg_rule, c)
    }
}
void  State::_sub_Op_ModI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) && STATE__VALID_CHILD(_kids[1], IREGIORL2I) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I]+_kids[1]->_cost[IREGIORL2I]+INSN_COST * 22;
        DFA_PRODUCTION__SET_VALID(IREGINOSP, modI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI, modI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R0, modI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R2, modI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R3, modI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R4, modI_rule, c)
    }
}
void  State::_sub_Op_ModL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IREGL) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IREGL]+INSN_COST * 38;
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, modL_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL, modL_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL_R11, modL_rule, c)
    }
}
void  State::_sub_Op_MoveI2F(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGI) ) {
      unsigned int c = _kids[0]->_cost[IREGI] + INSN_COST;
        DFA_PRODUCTION__SET_VALID(VREGF, MoveI2F_reg_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGI) ) {
      unsigned int c = _kids[0]->_cost[IREGI] + INSN_COST;
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, MoveI2F_reg_stack_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], STACKSLOTI) ) {
      unsigned int c = _kids[0]->_cost[STACKSLOTI]+4 * INSN_COST;
      if (STATE__NOT_YET_VALID(VREGF) || _cost[VREGF] > c) {
        DFA_PRODUCTION__SET_VALID(VREGF, MoveI2F_stack_reg_rule, c)
      }
    }
}
void  State::_sub_Op_MoveF2I(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VREGF) ) {
      unsigned int c = _kids[0]->_cost[VREGF] + INSN_COST;
        DFA_PRODUCTION__SET_VALID(IREGINOSP, MoveF2I_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI, MoveF2I_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R0, MoveF2I_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R2, MoveF2I_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R3, MoveF2I_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R4, MoveF2I_reg_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VREGF) ) {
      unsigned int c = _kids[0]->_cost[VREGF] + INSN_COST;
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, MoveF2I_reg_stack_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], STACKSLOTF) ) {
      unsigned int c = _kids[0]->_cost[STACKSLOTF]+4 * INSN_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, MoveF2I_stack_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, MoveF2I_stack_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R0) || _cost[IREGI_R0] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R0, MoveF2I_stack_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R2) || _cost[IREGI_R2] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R2, MoveF2I_stack_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R3) || _cost[IREGI_R3] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R3, MoveF2I_stack_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R4) || _cost[IREGI_R4] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R4, MoveF2I_stack_reg_rule, c)
      }
    }
}
void  State::_sub_Op_MoveL2D(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGL) ) {
      unsigned int c = _kids[0]->_cost[IREGL] + INSN_COST;
        DFA_PRODUCTION__SET_VALID(VREGD, MoveL2D_reg_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) ) {
      unsigned int c = _kids[0]->_cost[IREGL] + INSN_COST;
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, MoveL2D_reg_stack_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], STACKSLOTL) ) {
      unsigned int c = _kids[0]->_cost[STACKSLOTL]+4 * INSN_COST;
      if (STATE__NOT_YET_VALID(VREGD) || _cost[VREGD] > c) {
        DFA_PRODUCTION__SET_VALID(VREGD, MoveL2D_stack_reg_rule, c)
      }
    }
}
void  State::_sub_Op_MoveD2L(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VREGD) ) {
      unsigned int c = _kids[0]->_cost[VREGD] + INSN_COST;
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, MoveD2L_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL, MoveD2L_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL_R11, MoveD2L_reg_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VREGD) ) {
      unsigned int c = _kids[0]->_cost[VREGD] + INSN_COST;
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, MoveD2L_reg_stack_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], STACKSLOTD) ) {
      unsigned int c = _kids[0]->_cost[STACKSLOTD]+4 * INSN_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, MoveD2L_stack_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, MoveD2L_stack_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R11) || _cost[IREGL_R11] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R11, MoveD2L_stack_reg_rule, c)
      }
    }
}
void  State::_sub_Op_MulD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VREGD) && STATE__VALID_CHILD(_kids[1], VREGD) ) {
      unsigned int c = _kids[0]->_cost[VREGD]+_kids[1]->_cost[VREGD]+INSN_COST * 6;
        DFA_PRODUCTION__SET_VALID(VREGD, mulD_reg_reg_rule, c)
    }
}
void  State::_sub_Op_MulF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VREGF) && STATE__VALID_CHILD(_kids[1], VREGF) ) {
      unsigned int c = _kids[0]->_cost[VREGF]+_kids[1]->_cost[VREGF]+INSN_COST * 6;
        DFA_PRODUCTION__SET_VALID(VREGF, mulF_reg_reg_rule, c)
    }
}
void  State::_sub_Op_MulHiL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IREGL) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IREGL]+INSN_COST * 7;
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, mulHiL_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL, mulHiL_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL_R11, mulHiL_rReg_rule, c)
    }
}
void  State::_sub_Op_MulI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) && STATE__VALID_CHILD(_kids[1], IREGIORL2I) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I]+_kids[1]->_cost[IREGIORL2I];
        DFA_PRODUCTION__SET_VALID(_MULI_IREGIORL2I_IREGIORL2I, _MulI_iRegIorL2I_iRegIorL2I_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) && STATE__VALID_CHILD(_kids[1], IREGIORL2I) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I]+_kids[1]->_cost[IREGIORL2I]+INSN_COST * 3;
        DFA_PRODUCTION__SET_VALID(IREGINOSP, mulI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI, mulI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R0, mulI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R2, mulI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R3, mulI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R4, mulI_rule, c)
    }
}
void  State::_sub_Op_MulL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IREGL) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IREGL];
        DFA_PRODUCTION__SET_VALID(_MULL_IREGL_IREGL, _MulL_iRegL_iRegL_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IREGL) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IREGL]+INSN_COST * 5;
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, mulL_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL, mulL_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL_R11, mulL_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _CONVI2L_IREGIORL2I_) && STATE__VALID_CHILD(_kids[1], _CONVI2L_IREGIORL2I_) ) {
      unsigned int c = _kids[0]->_cost[_CONVI2L_IREGIORL2I_]+_kids[1]->_cost[_CONVI2L_IREGIORL2I_]+INSN_COST * 3;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, smulI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, smulI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R11) || _cost[IREGL_R11] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R11, smulI_rule, c)
      }
    }
}
void  State::_sub_Op_NegD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VREGD) ) {
      unsigned int c = _kids[0]->_cost[VREGD]+INSN_COST * 3;
        DFA_PRODUCTION__SET_VALID(VREGD, negD_reg_reg_rule, c)
    }
}
void  State::_sub_Op_NegF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VREGF) ) {
      unsigned int c = _kids[0]->_cost[VREGF]+INSN_COST * 3;
        DFA_PRODUCTION__SET_VALID(VREGF, negF_reg_reg_rule, c)
    }
}
void  State::_sub_Op_OrI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) && STATE__VALID_CHILD(_kids[1], IMMILOG) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I]+_kids[1]->_cost[IMMILOG] + INSN_COST;
        DFA_PRODUCTION__SET_VALID(IREGINOSP, orI_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI, orI_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R0, orI_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R2, orI_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R3, orI_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R4, orI_reg_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) && STATE__VALID_CHILD(_kids[1], IREGIORL2I) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I]+_kids[1]->_cost[IREGIORL2I] + INSN_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, orI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, orI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R0) || _cost[IREGI_R0] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R0, orI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R2) || _cost[IREGI_R2] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R2, orI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R3) || _cost[IREGI_R3] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R3, orI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R4) || _cost[IREGI_R4] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R4, orI_reg_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LSHIFTI_IREGI__SUBI_IMMI0_IREGI) && STATE__VALID_CHILD(_kids[1], _URSHIFTI_IREGI_IREGI) &&
        /*src*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) && /*shift*/(_kids[0]->_kids[1]->_kids[1]->_leaf == _kids[1]->_kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_LSHIFTI_IREGI__SUBI_IMMI0_IREGI]+_kids[1]->_cost[_URSHIFTI_IREGI_IREGI] + INSN_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, rorI_rReg_Var_C0_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, rorI_rReg_Var_C0_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R0) || _cost[IREGI_R0] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R0, rorI_rReg_Var_C0_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R2) || _cost[IREGI_R2] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R2, rorI_rReg_Var_C0_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R3) || _cost[IREGI_R3] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R3, rorI_rReg_Var_C0_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R4) || _cost[IREGI_R4] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R4, rorI_rReg_Var_C0_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _URSHIFTI_IREGI_IREGI) && STATE__VALID_CHILD(_kids[1], _LSHIFTI_IREGI__SUBI_IMMI0_IREGI) &&
        /*src*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) && /*shift*/(_kids[0]->_kids[1]->_leaf == _kids[1]->_kids[1]->_kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_URSHIFTI_IREGI_IREGI]+_kids[1]->_cost[_LSHIFTI_IREGI__SUBI_IMMI0_IREGI] + INSN_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, rorI_rReg_Var_C0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, rorI_rReg_Var_C0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R0) || _cost[IREGI_R0] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R0, rorI_rReg_Var_C0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R2) || _cost[IREGI_R2] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R2, rorI_rReg_Var_C0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R3) || _cost[IREGI_R3] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R3, rorI_rReg_Var_C0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R4) || _cost[IREGI_R4] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R4, rorI_rReg_Var_C0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LSHIFTI_IREGI__SUBI_IMMI_32_IREGI) && STATE__VALID_CHILD(_kids[1], _URSHIFTI_IREGI_IREGI) &&
        /*src*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) && /*shift*/(_kids[0]->_kids[1]->_kids[1]->_leaf == _kids[1]->_kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_LSHIFTI_IREGI__SUBI_IMMI_32_IREGI]+_kids[1]->_cost[_URSHIFTI_IREGI_IREGI] + INSN_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, rorI_rReg_Var_C_32_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, rorI_rReg_Var_C_32_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R0) || _cost[IREGI_R0] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R0, rorI_rReg_Var_C_32_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R2) || _cost[IREGI_R2] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R2, rorI_rReg_Var_C_32_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R3) || _cost[IREGI_R3] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R3, rorI_rReg_Var_C_32_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R4) || _cost[IREGI_R4] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R4, rorI_rReg_Var_C_32_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _URSHIFTI_IREGI_IREGI) && STATE__VALID_CHILD(_kids[1], _LSHIFTI_IREGI__SUBI_IMMI_32_IREGI) &&
        /*src*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) && /*shift*/(_kids[0]->_kids[1]->_leaf == _kids[1]->_kids[1]->_kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_URSHIFTI_IREGI_IREGI]+_kids[1]->_cost[_LSHIFTI_IREGI__SUBI_IMMI_32_IREGI] + INSN_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, rorI_rReg_Var_C_32_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, rorI_rReg_Var_C_32_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R0) || _cost[IREGI_R0] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R0, rorI_rReg_Var_C_32_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R2) || _cost[IREGI_R2] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R2, rorI_rReg_Var_C_32_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R3) || _cost[IREGI_R3] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R3, rorI_rReg_Var_C_32_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R4) || _cost[IREGI_R4] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R4, rorI_rReg_Var_C_32_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _URSHIFTI_IREGI__SUBI_IMMI0_IREGI) && STATE__VALID_CHILD(_kids[1], _LSHIFTI_IREGI_IREGI) &&
        /*src*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) && /*shift*/(_kids[0]->_kids[1]->_kids[1]->_leaf == _kids[1]->_kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_URSHIFTI_IREGI__SUBI_IMMI0_IREGI]+_kids[1]->_cost[_LSHIFTI_IREGI_IREGI] + INSN_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, rolI_rReg_Var_C0_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, rolI_rReg_Var_C0_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R0) || _cost[IREGI_R0] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R0, rolI_rReg_Var_C0_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R2) || _cost[IREGI_R2] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R2, rolI_rReg_Var_C0_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R3) || _cost[IREGI_R3] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R3, rolI_rReg_Var_C0_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R4) || _cost[IREGI_R4] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R4, rolI_rReg_Var_C0_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LSHIFTI_IREGI_IREGI) && STATE__VALID_CHILD(_kids[1], _URSHIFTI_IREGI__SUBI_IMMI0_IREGI) &&
        /*src*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) && /*shift*/(_kids[0]->_kids[1]->_leaf == _kids[1]->_kids[1]->_kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_LSHIFTI_IREGI_IREGI]+_kids[1]->_cost[_URSHIFTI_IREGI__SUBI_IMMI0_IREGI] + INSN_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, rolI_rReg_Var_C0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, rolI_rReg_Var_C0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R0) || _cost[IREGI_R0] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R0, rolI_rReg_Var_C0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R2) || _cost[IREGI_R2] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R2, rolI_rReg_Var_C0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R3) || _cost[IREGI_R3] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R3, rolI_rReg_Var_C0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R4) || _cost[IREGI_R4] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R4, rolI_rReg_Var_C0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _URSHIFTI_IREGI__SUBI_IMMI_32_IREGI) && STATE__VALID_CHILD(_kids[1], _LSHIFTI_IREGI_IREGI) &&
        /*src*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) && /*shift*/(_kids[0]->_kids[1]->_kids[1]->_leaf == _kids[1]->_kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_URSHIFTI_IREGI__SUBI_IMMI_32_IREGI]+_kids[1]->_cost[_LSHIFTI_IREGI_IREGI] + INSN_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, rolI_rReg_Var_C_32_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, rolI_rReg_Var_C_32_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R0) || _cost[IREGI_R0] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R0, rolI_rReg_Var_C_32_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R2) || _cost[IREGI_R2] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R2, rolI_rReg_Var_C_32_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R3) || _cost[IREGI_R3] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R3, rolI_rReg_Var_C_32_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R4) || _cost[IREGI_R4] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R4, rolI_rReg_Var_C_32_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LSHIFTI_IREGI_IREGI) && STATE__VALID_CHILD(_kids[1], _URSHIFTI_IREGI__SUBI_IMMI_32_IREGI) &&
        /*src*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) && /*shift*/(_kids[0]->_kids[1]->_leaf == _kids[1]->_kids[1]->_kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_LSHIFTI_IREGI_IREGI]+_kids[1]->_cost[_URSHIFTI_IREGI__SUBI_IMMI_32_IREGI] + INSN_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, rolI_rReg_Var_C_32_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, rolI_rReg_Var_C_32_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R0) || _cost[IREGI_R0] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R0, rolI_rReg_Var_C_32_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R2) || _cost[IREGI_R2] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R2, rolI_rReg_Var_C_32_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R3) || _cost[IREGI_R3] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R3, rolI_rReg_Var_C_32_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R4) || _cost[IREGI_R4] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R4, rolI_rReg_Var_C_32_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _URSHIFTI_IREGIORL2I_IMMI) && STATE__VALID_CHILD(_kids[1], _LSHIFTI_IREGIORL2I_IMMI) &&
        (
#line 10982 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
0 == ((n->in(1)->in(2)->get_int() + n->in(2)->in(2)->get_int()) & 31)
#line 7209 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_URSHIFTI_IREGIORL2I_IMMI]+_kids[1]->_cost[_LSHIFTI_IREGIORL2I_IMMI] + INSN_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, extrOrI_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, extrOrI_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R0) || _cost[IREGI_R0] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R0, extrOrI_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R2) || _cost[IREGI_R2] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R2, extrOrI_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R3) || _cost[IREGI_R3] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R3, extrOrI_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R4) || _cost[IREGI_R4] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R4, extrOrI_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LSHIFTI_IREGIORL2I_IMMI) && STATE__VALID_CHILD(_kids[1], _URSHIFTI_IREGIORL2I_IMMI) &&
        (
#line 10982 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
0 == ((n->in(1)->in(2)->get_int() + n->in(2)->in(2)->get_int()) & 31)
#line 7238 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LSHIFTI_IREGIORL2I_IMMI]+_kids[1]->_cost[_URSHIFTI_IREGIORL2I_IMMI] + INSN_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, extrOrI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, extrOrI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R0) || _cost[IREGI_R0] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R0, extrOrI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R2) || _cost[IREGI_R2] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R2, extrOrI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R3) || _cost[IREGI_R3] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R3, extrOrI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R4) || _cost[IREGI_R4] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R4, extrOrI_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LSHIFTI_IREGIORL2I_IMMI) && STATE__VALID_CHILD(_kids[1], IREGIORL2I) ) {
      unsigned int c = _kids[0]->_cost[_LSHIFTI_IREGIORL2I_IMMI]+_kids[1]->_cost[IREGIORL2I]+1.9 * INSN_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, OrI_reg_LShift_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, OrI_reg_LShift_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R0) || _cost[IREGI_R0] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R0, OrI_reg_LShift_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R2) || _cost[IREGI_R2] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R2, OrI_reg_LShift_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R3) || _cost[IREGI_R3] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R3, OrI_reg_LShift_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R4) || _cost[IREGI_R4] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R4, OrI_reg_LShift_reg_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) && STATE__VALID_CHILD(_kids[1], _LSHIFTI_IREGIORL2I_IMMI) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I]+_kids[1]->_cost[_LSHIFTI_IREGIORL2I_IMMI]+1.9 * INSN_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, OrI_reg_LShift_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, OrI_reg_LShift_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R0) || _cost[IREGI_R0] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R0, OrI_reg_LShift_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R2) || _cost[IREGI_R2] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R2, OrI_reg_LShift_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R3) || _cost[IREGI_R3] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R3, OrI_reg_LShift_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R4) || _cost[IREGI_R4] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R4, OrI_reg_LShift_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _RSHIFTI_IREGIORL2I_IMMI) && STATE__VALID_CHILD(_kids[1], IREGIORL2I) ) {
      unsigned int c = _kids[0]->_cost[_RSHIFTI_IREGIORL2I_IMMI]+_kids[1]->_cost[IREGIORL2I]+1.9 * INSN_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, OrI_reg_RShift_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, OrI_reg_RShift_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R0) || _cost[IREGI_R0] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R0, OrI_reg_RShift_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R2) || _cost[IREGI_R2] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R2, OrI_reg_RShift_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R3) || _cost[IREGI_R3] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R3, OrI_reg_RShift_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R4) || _cost[IREGI_R4] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R4, OrI_reg_RShift_reg_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) && STATE__VALID_CHILD(_kids[1], _RSHIFTI_IREGIORL2I_IMMI) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I]+_kids[1]->_cost[_RSHIFTI_IREGIORL2I_IMMI]+1.9 * INSN_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, OrI_reg_RShift_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, OrI_reg_RShift_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R0) || _cost[IREGI_R0] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R0, OrI_reg_RShift_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R2) || _cost[IREGI_R2] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R2, OrI_reg_RShift_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R3) || _cost[IREGI_R3] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R3, OrI_reg_RShift_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R4) || _cost[IREGI_R4] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R4, OrI_reg_RShift_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _URSHIFTI_IREGIORL2I_IMMI) && STATE__VALID_CHILD(_kids[1], IREGIORL2I) ) {
      unsigned int c = _kids[0]->_cost[_URSHIFTI_IREGIORL2I_IMMI]+_kids[1]->_cost[IREGIORL2I]+1.9 * INSN_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, OrI_reg_URShift_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, OrI_reg_URShift_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R0) || _cost[IREGI_R0] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R0, OrI_reg_URShift_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R2) || _cost[IREGI_R2] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R2, OrI_reg_URShift_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R3) || _cost[IREGI_R3] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R3, OrI_reg_URShift_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R4) || _cost[IREGI_R4] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R4, OrI_reg_URShift_reg_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) && STATE__VALID_CHILD(_kids[1], _URSHIFTI_IREGIORL2I_IMMI) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I]+_kids[1]->_cost[_URSHIFTI_IREGIORL2I_IMMI]+1.9 * INSN_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, OrI_reg_URShift_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, OrI_reg_URShift_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R0) || _cost[IREGI_R0] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R0, OrI_reg_URShift_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R2) || _cost[IREGI_R2] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R2, OrI_reg_URShift_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R3) || _cost[IREGI_R3] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R3, OrI_reg_URShift_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R4) || _cost[IREGI_R4] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R4, OrI_reg_URShift_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _XORI__LSHIFTI_IREGIORL2I_IMMI_IMMI_M1) && STATE__VALID_CHILD(_kids[1], IREGIORL2I) ) {
      unsigned int c = _kids[0]->_cost[_XORI__LSHIFTI_IREGIORL2I_IMMI_IMMI_M1]+_kids[1]->_cost[IREGIORL2I]+1.9 * INSN_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, OrI_reg_LShift_not_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, OrI_reg_LShift_not_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R0) || _cost[IREGI_R0] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R0, OrI_reg_LShift_not_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R2) || _cost[IREGI_R2] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R2, OrI_reg_LShift_not_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R3) || _cost[IREGI_R3] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R3, OrI_reg_LShift_not_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R4) || _cost[IREGI_R4] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R4, OrI_reg_LShift_not_reg_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) && STATE__VALID_CHILD(_kids[1], _XORI__LSHIFTI_IREGIORL2I_IMMI_IMMI_M1) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I]+_kids[1]->_cost[_XORI__LSHIFTI_IREGIORL2I_IMMI_IMMI_M1]+1.9 * INSN_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, OrI_reg_LShift_not_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, OrI_reg_LShift_not_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R0) || _cost[IREGI_R0] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R0, OrI_reg_LShift_not_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R2) || _cost[IREGI_R2] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R2, OrI_reg_LShift_not_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R3) || _cost[IREGI_R3] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R3, OrI_reg_LShift_not_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R4) || _cost[IREGI_R4] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R4, OrI_reg_LShift_not_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _XORI__RSHIFTI_IREGIORL2I_IMMI_IMMI_M1) && STATE__VALID_CHILD(_kids[1], IREGIORL2I) ) {
      unsigned int c = _kids[0]->_cost[_XORI__RSHIFTI_IREGIORL2I_IMMI_IMMI_M1]+_kids[1]->_cost[IREGIORL2I]+1.9 * INSN_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, OrI_reg_RShift_not_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, OrI_reg_RShift_not_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R0) || _cost[IREGI_R0] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R0, OrI_reg_RShift_not_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R2) || _cost[IREGI_R2] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R2, OrI_reg_RShift_not_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R3) || _cost[IREGI_R3] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R3, OrI_reg_RShift_not_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R4) || _cost[IREGI_R4] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R4, OrI_reg_RShift_not_reg_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) && STATE__VALID_CHILD(_kids[1], _XORI__RSHIFTI_IREGIORL2I_IMMI_IMMI_M1) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I]+_kids[1]->_cost[_XORI__RSHIFTI_IREGIORL2I_IMMI_IMMI_M1]+1.9 * INSN_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, OrI_reg_RShift_not_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, OrI_reg_RShift_not_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R0) || _cost[IREGI_R0] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R0, OrI_reg_RShift_not_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R2) || _cost[IREGI_R2] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R2, OrI_reg_RShift_not_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R3) || _cost[IREGI_R3] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R3, OrI_reg_RShift_not_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R4) || _cost[IREGI_R4] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R4, OrI_reg_RShift_not_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _XORI__URSHIFTI_IREGIORL2I_IMMI_IMMI_M1) && STATE__VALID_CHILD(_kids[1], IREGIORL2I) ) {
      unsigned int c = _kids[0]->_cost[_XORI__URSHIFTI_IREGIORL2I_IMMI_IMMI_M1]+_kids[1]->_cost[IREGIORL2I]+1.9 * INSN_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, OrI_reg_URShift_not_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, OrI_reg_URShift_not_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R0) || _cost[IREGI_R0] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R0, OrI_reg_URShift_not_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R2) || _cost[IREGI_R2] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R2, OrI_reg_URShift_not_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R3) || _cost[IREGI_R3] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R3, OrI_reg_URShift_not_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R4) || _cost[IREGI_R4] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R4, OrI_reg_URShift_not_reg_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) && STATE__VALID_CHILD(_kids[1], _XORI__URSHIFTI_IREGIORL2I_IMMI_IMMI_M1) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I]+_kids[1]->_cost[_XORI__URSHIFTI_IREGIORL2I_IMMI_IMMI_M1]+1.9 * INSN_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, OrI_reg_URShift_not_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, OrI_reg_URShift_not_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R0) || _cost[IREGI_R0] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R0, OrI_reg_URShift_not_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R2) || _cost[IREGI_R2] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R2, OrI_reg_URShift_not_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R3) || _cost[IREGI_R3] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R3, OrI_reg_URShift_not_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R4) || _cost[IREGI_R4] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R4, OrI_reg_URShift_not_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _XORI_IREGIORL2I_IMMI_M1) && STATE__VALID_CHILD(_kids[1], IREGIORL2I) ) {
      unsigned int c = _kids[0]->_cost[_XORI_IREGIORL2I_IMMI_M1]+_kids[1]->_cost[IREGIORL2I] + INSN_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, OrI_reg_not_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, OrI_reg_not_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R0) || _cost[IREGI_R0] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R0, OrI_reg_not_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R2) || _cost[IREGI_R2] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R2, OrI_reg_not_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R3) || _cost[IREGI_R3] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R3, OrI_reg_not_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R4) || _cost[IREGI_R4] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R4, OrI_reg_not_reg_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) && STATE__VALID_CHILD(_kids[1], _XORI_IREGIORL2I_IMMI_M1) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I]+_kids[1]->_cost[_XORI_IREGIORL2I_IMMI_M1] + INSN_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, OrI_reg_not_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, OrI_reg_not_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R0) || _cost[IREGI_R0] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R0, OrI_reg_not_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R2) || _cost[IREGI_R2] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R2, OrI_reg_not_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R3) || _cost[IREGI_R3] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R3, OrI_reg_not_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R4) || _cost[IREGI_R4] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R4, OrI_reg_not_reg_rule, c)
      }
    }
}
void  State::_sub_Op_OrL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IMMLLOG) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IMMLLOG] + INSN_COST;
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, orL_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL, orL_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL_R11, orL_reg_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IREGL) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IREGL] + INSN_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, orL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, orL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R11) || _cost[IREGL_R11] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R11, orL_reg_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LSHIFTL_IREGL__SUBI_IMMI0_IREGI) && STATE__VALID_CHILD(_kids[1], _URSHIFTL_IREGL_IREGI) &&
        /*src*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) && /*shift*/(_kids[0]->_kids[1]->_kids[1]->_leaf == _kids[1]->_kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_LSHIFTL_IREGL__SUBI_IMMI0_IREGI]+_kids[1]->_cost[_URSHIFTL_IREGL_IREGI] + INSN_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, rorL_rReg_Var_C0_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, rorL_rReg_Var_C0_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R11) || _cost[IREGL_R11] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R11, rorL_rReg_Var_C0_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _URSHIFTL_IREGL_IREGI) && STATE__VALID_CHILD(_kids[1], _LSHIFTL_IREGL__SUBI_IMMI0_IREGI) &&
        /*src*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) && /*shift*/(_kids[0]->_kids[1]->_leaf == _kids[1]->_kids[1]->_kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_URSHIFTL_IREGL_IREGI]+_kids[1]->_cost[_LSHIFTL_IREGL__SUBI_IMMI0_IREGI] + INSN_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, rorL_rReg_Var_C0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, rorL_rReg_Var_C0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R11) || _cost[IREGL_R11] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R11, rorL_rReg_Var_C0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LSHIFTL_IREGL__SUBI_IMMI_64_IREGI) && STATE__VALID_CHILD(_kids[1], _URSHIFTL_IREGL_IREGI) &&
        /*src*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) && /*shift*/(_kids[0]->_kids[1]->_kids[1]->_leaf == _kids[1]->_kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_LSHIFTL_IREGL__SUBI_IMMI_64_IREGI]+_kids[1]->_cost[_URSHIFTL_IREGL_IREGI] + INSN_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, rorL_rReg_Var_C_64_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, rorL_rReg_Var_C_64_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R11) || _cost[IREGL_R11] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R11, rorL_rReg_Var_C_64_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _URSHIFTL_IREGL_IREGI) && STATE__VALID_CHILD(_kids[1], _LSHIFTL_IREGL__SUBI_IMMI_64_IREGI) &&
        /*src*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) && /*shift*/(_kids[0]->_kids[1]->_leaf == _kids[1]->_kids[1]->_kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_URSHIFTL_IREGL_IREGI]+_kids[1]->_cost[_LSHIFTL_IREGL__SUBI_IMMI_64_IREGI] + INSN_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, rorL_rReg_Var_C_64_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, rorL_rReg_Var_C_64_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R11) || _cost[IREGL_R11] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R11, rorL_rReg_Var_C_64_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _URSHIFTL_IREGL__SUBI_IMMI0_IREGI) && STATE__VALID_CHILD(_kids[1], _LSHIFTL_IREGL_IREGI) &&
        /*src*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) && /*shift*/(_kids[0]->_kids[1]->_kids[1]->_leaf == _kids[1]->_kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_URSHIFTL_IREGL__SUBI_IMMI0_IREGI]+_kids[1]->_cost[_LSHIFTL_IREGL_IREGI] + INSN_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, rolL_rReg_Var_C0_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, rolL_rReg_Var_C0_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R11) || _cost[IREGL_R11] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R11, rolL_rReg_Var_C0_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LSHIFTL_IREGL_IREGI) && STATE__VALID_CHILD(_kids[1], _URSHIFTL_IREGL__SUBI_IMMI0_IREGI) &&
        /*src*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) && /*shift*/(_kids[0]->_kids[1]->_leaf == _kids[1]->_kids[1]->_kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_LSHIFTL_IREGL_IREGI]+_kids[1]->_cost[_URSHIFTL_IREGL__SUBI_IMMI0_IREGI] + INSN_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, rolL_rReg_Var_C0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, rolL_rReg_Var_C0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R11) || _cost[IREGL_R11] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R11, rolL_rReg_Var_C0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _URSHIFTL_IREGL__SUBI_IMMI_64_IREGI) && STATE__VALID_CHILD(_kids[1], _LSHIFTL_IREGL_IREGI) &&
        /*src*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) && /*shift*/(_kids[0]->_kids[1]->_kids[1]->_leaf == _kids[1]->_kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_URSHIFTL_IREGL__SUBI_IMMI_64_IREGI]+_kids[1]->_cost[_LSHIFTL_IREGL_IREGI] + INSN_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, rolL_rReg_Var_C_64_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, rolL_rReg_Var_C_64_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R11) || _cost[IREGL_R11] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R11, rolL_rReg_Var_C_64_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LSHIFTL_IREGL_IREGI) && STATE__VALID_CHILD(_kids[1], _URSHIFTL_IREGL__SUBI_IMMI_64_IREGI) &&
        /*src*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) && /*shift*/(_kids[0]->_kids[1]->_leaf == _kids[1]->_kids[1]->_kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_LSHIFTL_IREGL_IREGI]+_kids[1]->_cost[_URSHIFTL_IREGL__SUBI_IMMI_64_IREGI] + INSN_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, rolL_rReg_Var_C_64_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, rolL_rReg_Var_C_64_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R11) || _cost[IREGL_R11] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R11, rolL_rReg_Var_C_64_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _URSHIFTL_IREGL_IMMI) && STATE__VALID_CHILD(_kids[1], _LSHIFTL_IREGL_IMMI) &&
        (
#line 10967 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
0 == ((n->in(1)->in(2)->get_int() + n->in(2)->in(2)->get_int()) & 63)
#line 7727 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_URSHIFTL_IREGL_IMMI]+_kids[1]->_cost[_LSHIFTL_IREGL_IMMI] + INSN_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, extrOrL_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, extrOrL_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R11) || _cost[IREGL_R11] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R11, extrOrL_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LSHIFTL_IREGL_IMMI) && STATE__VALID_CHILD(_kids[1], _URSHIFTL_IREGL_IMMI) &&
        (
#line 10967 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
0 == ((n->in(1)->in(2)->get_int() + n->in(2)->in(2)->get_int()) & 63)
#line 7744 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LSHIFTL_IREGL_IMMI]+_kids[1]->_cost[_URSHIFTL_IREGL_IMMI] + INSN_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, extrOrL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, extrOrL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R11) || _cost[IREGL_R11] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R11, extrOrL_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LSHIFTL_IREGL_IMMI) && STATE__VALID_CHILD(_kids[1], IREGL) ) {
      unsigned int c = _kids[0]->_cost[_LSHIFTL_IREGL_IMMI]+_kids[1]->_cost[IREGL]+1.9 * INSN_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, OrL_reg_LShift_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, OrL_reg_LShift_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R11) || _cost[IREGL_R11] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R11, OrL_reg_LShift_reg_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], _LSHIFTL_IREGL_IMMI) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[_LSHIFTL_IREGL_IMMI]+1.9 * INSN_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, OrL_reg_LShift_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, OrL_reg_LShift_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R11) || _cost[IREGL_R11] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R11, OrL_reg_LShift_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _RSHIFTL_IREGL_IMMI) && STATE__VALID_CHILD(_kids[1], IREGL) ) {
      unsigned int c = _kids[0]->_cost[_RSHIFTL_IREGL_IMMI]+_kids[1]->_cost[IREGL]+1.9 * INSN_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, OrL_reg_RShift_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, OrL_reg_RShift_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R11) || _cost[IREGL_R11] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R11, OrL_reg_RShift_reg_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], _RSHIFTL_IREGL_IMMI) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[_RSHIFTL_IREGL_IMMI]+1.9 * INSN_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, OrL_reg_RShift_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, OrL_reg_RShift_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R11) || _cost[IREGL_R11] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R11, OrL_reg_RShift_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _URSHIFTL_IREGL_IMMI) && STATE__VALID_CHILD(_kids[1], IREGL) ) {
      unsigned int c = _kids[0]->_cost[_URSHIFTL_IREGL_IMMI]+_kids[1]->_cost[IREGL]+1.9 * INSN_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, OrL_reg_URShift_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, OrL_reg_URShift_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R11) || _cost[IREGL_R11] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R11, OrL_reg_URShift_reg_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], _URSHIFTL_IREGL_IMMI) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[_URSHIFTL_IREGL_IMMI]+1.9 * INSN_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, OrL_reg_URShift_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, OrL_reg_URShift_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R11) || _cost[IREGL_R11] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R11, OrL_reg_URShift_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _XORL__LSHIFTL_IREGL_IMMI_IMML_M1) && STATE__VALID_CHILD(_kids[1], IREGL) ) {
      unsigned int c = _kids[0]->_cost[_XORL__LSHIFTL_IREGL_IMMI_IMML_M1]+_kids[1]->_cost[IREGL]+1.9 * INSN_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, OrL_reg_LShift_not_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, OrL_reg_LShift_not_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R11) || _cost[IREGL_R11] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R11, OrL_reg_LShift_not_reg_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], _XORL__LSHIFTL_IREGL_IMMI_IMML_M1) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[_XORL__LSHIFTL_IREGL_IMMI_IMML_M1]+1.9 * INSN_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, OrL_reg_LShift_not_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, OrL_reg_LShift_not_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R11) || _cost[IREGL_R11] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R11, OrL_reg_LShift_not_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _XORL__RSHIFTL_IREGL_IMMI_IMML_M1) && STATE__VALID_CHILD(_kids[1], IREGL) ) {
      unsigned int c = _kids[0]->_cost[_XORL__RSHIFTL_IREGL_IMMI_IMML_M1]+_kids[1]->_cost[IREGL]+1.9 * INSN_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, OrL_reg_RShift_not_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, OrL_reg_RShift_not_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R11) || _cost[IREGL_R11] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R11, OrL_reg_RShift_not_reg_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], _XORL__RSHIFTL_IREGL_IMMI_IMML_M1) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[_XORL__RSHIFTL_IREGL_IMMI_IMML_M1]+1.9 * INSN_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, OrL_reg_RShift_not_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, OrL_reg_RShift_not_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R11) || _cost[IREGL_R11] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R11, OrL_reg_RShift_not_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _XORL__URSHIFTL_IREGL_IMMI_IMML_M1) && STATE__VALID_CHILD(_kids[1], IREGL) ) {
      unsigned int c = _kids[0]->_cost[_XORL__URSHIFTL_IREGL_IMMI_IMML_M1]+_kids[1]->_cost[IREGL]+1.9 * INSN_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, OrL_reg_URShift_not_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, OrL_reg_URShift_not_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R11) || _cost[IREGL_R11] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R11, OrL_reg_URShift_not_reg_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], _XORL__URSHIFTL_IREGL_IMMI_IMML_M1) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[_XORL__URSHIFTL_IREGL_IMMI_IMML_M1]+1.9 * INSN_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, OrL_reg_URShift_not_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, OrL_reg_URShift_not_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R11) || _cost[IREGL_R11] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R11, OrL_reg_URShift_not_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _XORL_IREGL_IMML_M1) && STATE__VALID_CHILD(_kids[1], IREGL) ) {
      unsigned int c = _kids[0]->_cost[_XORL_IREGL_IMML_M1]+_kids[1]->_cost[IREGL] + INSN_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, OrL_reg_not_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, OrL_reg_not_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R11) || _cost[IREGL_R11] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R11, OrL_reg_not_reg_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], _XORL_IREGL_IMML_M1) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[_XORL_IREGL_IMML_M1] + INSN_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, OrL_reg_not_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, OrL_reg_not_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R11) || _cost[IREGL_R11] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R11, OrL_reg_not_reg_rule, c)
      }
    }
}
void  State::_sub_Op_OverflowAddI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) && STATE__VALID_CHILD(_kids[1], IMMIADDSUB) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I]+_kids[1]->_cost[IMMIADDSUB] + INSN_COST;
        DFA_PRODUCTION__SET_VALID(RFLAGSREG, overflowAddI_reg_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) && STATE__VALID_CHILD(_kids[1], IREGIORL2I) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I]+_kids[1]->_cost[IREGIORL2I] + INSN_COST;
      if (STATE__NOT_YET_VALID(RFLAGSREG) || _cost[RFLAGSREG] > c) {
        DFA_PRODUCTION__SET_VALID(RFLAGSREG, overflowAddI_reg_reg_rule, c)
      }
    }
}
void  State::_sub_Op_OverflowSubI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IMMI0) && STATE__VALID_CHILD(_kids[1], IREGIORL2I) ) {
      unsigned int c = _kids[0]->_cost[IMMI0]+_kids[1]->_cost[IREGIORL2I] + INSN_COST;
        DFA_PRODUCTION__SET_VALID(RFLAGSREG, overflowNegI_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) && STATE__VALID_CHILD(_kids[1], IMMIADDSUB) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I]+_kids[1]->_cost[IMMIADDSUB] + INSN_COST;
      if (STATE__NOT_YET_VALID(RFLAGSREG) || _cost[RFLAGSREG] > c) {
        DFA_PRODUCTION__SET_VALID(RFLAGSREG, overflowSubI_reg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) && STATE__VALID_CHILD(_kids[1], IREGIORL2I) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I]+_kids[1]->_cost[IREGIORL2I] + INSN_COST;
      if (STATE__NOT_YET_VALID(RFLAGSREG) || _cost[RFLAGSREG] > c) {
        DFA_PRODUCTION__SET_VALID(RFLAGSREG, overflowSubI_reg_reg_rule, c)
      }
    }
}
void  State::_sub_Op_OverflowMulI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) && STATE__VALID_CHILD(_kids[1], IREGIORL2I) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I]+_kids[1]->_cost[IREGIORL2I];
        DFA_PRODUCTION__SET_VALID(_OVERFLOWMULI_IREGIORL2I_IREGIORL2I, _OverflowMulI_iRegIorL2I_iRegIorL2I_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) && STATE__VALID_CHILD(_kids[1], IREGIORL2I) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I]+_kids[1]->_cost[IREGIORL2I]+5 * INSN_COST;
        DFA_PRODUCTION__SET_VALID(RFLAGSREG, overflowMulI_reg_rule, c)
    }
}
void  State::_sub_Op_OverflowAddL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IMMLADDSUB) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IMMLADDSUB] + INSN_COST;
        DFA_PRODUCTION__SET_VALID(RFLAGSREG, overflowAddL_reg_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IREGL) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IREGL] + INSN_COST;
      if (STATE__NOT_YET_VALID(RFLAGSREG) || _cost[RFLAGSREG] > c) {
        DFA_PRODUCTION__SET_VALID(RFLAGSREG, overflowAddL_reg_reg_rule, c)
      }
    }
}
void  State::_sub_Op_OverflowSubL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IMMI0) && STATE__VALID_CHILD(_kids[1], IREGL) ) {
      unsigned int c = _kids[0]->_cost[IMMI0]+_kids[1]->_cost[IREGL] + INSN_COST;
        DFA_PRODUCTION__SET_VALID(RFLAGSREG, overflowNegL_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IMMLADDSUB) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IMMLADDSUB] + INSN_COST;
      if (STATE__NOT_YET_VALID(RFLAGSREG) || _cost[RFLAGSREG] > c) {
        DFA_PRODUCTION__SET_VALID(RFLAGSREG, overflowSubL_reg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IREGL) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IREGL] + INSN_COST;
      if (STATE__NOT_YET_VALID(RFLAGSREG) || _cost[RFLAGSREG] > c) {
        DFA_PRODUCTION__SET_VALID(RFLAGSREG, overflowSubL_reg_reg_rule, c)
      }
    }
}
void  State::_sub_Op_OverflowMulL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IREGL) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IREGL];
        DFA_PRODUCTION__SET_VALID(_OVERFLOWMULL_IREGL_IREGL, _OverflowMulL_iRegL_iRegL_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IREGL) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IREGL]+6 * INSN_COST;
        DFA_PRODUCTION__SET_VALID(RFLAGSREG, overflowMulL_reg_rule, c)
    }
}
void  State::_sub_Op_PartialSubtypeCheck(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGP_R4) && STATE__VALID_CHILD(_kids[1], IREGP_R0) ) {
      unsigned int c = _kids[0]->_cost[IREGP_R4]+_kids[1]->_cost[IREGP_R0];
        DFA_PRODUCTION__SET_VALID(_PARTIALSUBTYPECHECK_IREGP_R4_IREGP_R0, _PartialSubtypeCheck_iRegP_R4_iRegP_R0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGP_R4) && STATE__VALID_CHILD(_kids[1], IREGP_R0) ) {
      unsigned int c = _kids[0]->_cost[IREGP_R4]+_kids[1]->_cost[IREGP_R0]+1100;
        DFA_PRODUCTION__SET_VALID(IREGP_R5, partialSubtypeCheck_rule, c)
    }
}
void  State::_sub_Op_PopCountI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) &&
        (
#line 7539 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
UsePopCountInstruction
#line 8021 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+INSN_COST * 13;
        DFA_PRODUCTION__SET_VALID(IREGINOSP, popCountI_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI, popCountI_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R0, popCountI_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R2, popCountI_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R3, popCountI_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R4, popCountI_mem_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) &&
        (
#line 7517 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
UsePopCountInstruction
#line 8036 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I]+INSN_COST * 13;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, popCountI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, popCountI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R0) || _cost[IREGI_R0] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R0, popCountI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R2) || _cost[IREGI_R2] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R2, popCountI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R3) || _cost[IREGI_R3] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R3, popCountI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R4) || _cost[IREGI_R4] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R4, popCountI_rule, c)
      }
    }
}
void  State::_sub_Op_PopCountL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _LOADL_MEMORY_) &&
        (
#line 7582 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
UsePopCountInstruction
#line 8067 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADL_MEMORY_]+INSN_COST * 13;
        DFA_PRODUCTION__SET_VALID(IREGINOSP, popCountL_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI, popCountL_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R0, popCountL_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R2, popCountL_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R3, popCountL_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R4, popCountL_mem_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) &&
        (
#line 7562 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
UsePopCountInstruction
#line 8082 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+INSN_COST * 13;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, popCountL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, popCountL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R0) || _cost[IREGI_R0] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R0, popCountL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R2) || _cost[IREGI_R2] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R2, popCountL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R3) || _cost[IREGI_R3] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R3, popCountL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R4) || _cost[IREGI_R4] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R4, popCountL_rule, c)
      }
    }
}
void  State::_sub_Op_PrefetchAllocation(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY] + INSN_COST;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, prefetchw_rule, c)
    }
}
void  State::_sub_Op_PrefetchRead(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY] + INSN_COST;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, prefetchr_rule, c)
    }
}
void  State::_sub_Op_PrefetchWrite(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY] + INSN_COST;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, prefetchnta_rule, c)
    }
}
void  State::_sub_Op_RShiftI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _LSHIFTI_IREGIORL2I_IMMI_24) && STATE__VALID_CHILD(_kids[1], IMMI_24) ) {
      unsigned int c = _kids[0]->_cost[_LSHIFTI_IREGIORL2I_IMMI_24]+_kids[1]->_cost[IMMI_24];
        DFA_PRODUCTION__SET_VALID(_RSHIFTI__LSHIFTI_IREGIORL2I_IMMI_24_IMMI_24, _RShiftI__LShiftI_iRegIorL2I_immI_24_immI_24_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LSHIFTI_IREGIORL2I_IMMI_16) && STATE__VALID_CHILD(_kids[1], IMMI_16) ) {
      unsigned int c = _kids[0]->_cost[_LSHIFTI_IREGIORL2I_IMMI_16]+_kids[1]->_cost[IMMI_16];
        DFA_PRODUCTION__SET_VALID(_RSHIFTI__LSHIFTI_IREGIORL2I_IMMI_16_IMMI_16, _RShiftI__LShiftI_iRegIorL2I_immI_16_immI_16_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LSHIFTI_IREGIORL2I_IMMI) && STATE__VALID_CHILD(_kids[1], IMMI) &&
        (
#line 10843 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
(unsigned int)n->in(2)->get_int() <= 31
            && (unsigned int)n->in(1)->in(2)->get_int() <= 31
#line 8140 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LSHIFTI_IREGIORL2I_IMMI]+_kids[1]->_cost[IMMI]+INSN_COST * 2;
        DFA_PRODUCTION__SET_VALID(IREGINOSP, sbfmwI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI, sbfmwI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R0, sbfmwI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R2, sbfmwI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R3, sbfmwI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R4, sbfmwI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I]+_kids[1]->_cost[IMMI];
        DFA_PRODUCTION__SET_VALID(_RSHIFTI_IREGIORL2I_IMMI, _RShiftI_iRegIorL2I_immI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I]+_kids[1]->_cost[IMMI] + INSN_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, rShiftI_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, rShiftI_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R0) || _cost[IREGI_R0] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R0, rShiftI_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R2) || _cost[IREGI_R2] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R2, rShiftI_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R3) || _cost[IREGI_R3] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R3, rShiftI_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R4) || _cost[IREGI_R4] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R4, rShiftI_reg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) && STATE__VALID_CHILD(_kids[1], IREGIORL2I) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I]+_kids[1]->_cost[IREGIORL2I]+INSN_COST * 2;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, rShiftI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, rShiftI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R0) || _cost[IREGI_R0] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R0, rShiftI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R2) || _cost[IREGI_R2] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R2, rShiftI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R3) || _cost[IREGI_R3] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R3, rShiftI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R4) || _cost[IREGI_R4] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R4, rShiftI_reg_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) && STATE__VALID_CHILD(_kids[1], IMMI_31) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I]+_kids[1]->_cost[IMMI_31];
        DFA_PRODUCTION__SET_VALID(_RSHIFTI_IREGIORL2I_IMMI_31, _RShiftI_iRegIorL2I_immI_31_rule, c)
    }
}
void  State::_sub_Op_RShiftL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _LSHIFTL_IREGL_IMMI_56) && STATE__VALID_CHILD(_kids[1], IMMI_56) ) {
      unsigned int c = _kids[0]->_cost[_LSHIFTL_IREGL_IMMI_56]+_kids[1]->_cost[IMMI_56];
        DFA_PRODUCTION__SET_VALID(_RSHIFTL__LSHIFTL_IREGL_IMMI_56_IMMI_56, _RShiftL__LShiftL_iRegL_immI_56_immI_56_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LSHIFTL_IREGL_IMMI_32) && STATE__VALID_CHILD(_kids[1], IMMI_32) ) {
      unsigned int c = _kids[0]->_cost[_LSHIFTL_IREGL_IMMI_32]+_kids[1]->_cost[IMMI_32];
        DFA_PRODUCTION__SET_VALID(_RSHIFTL__LSHIFTL_IREGL_IMMI_32_IMMI_32, _RShiftL__LShiftL_iRegL_immI_32_immI_32_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LSHIFTL_IREGL_IMMI_48) && STATE__VALID_CHILD(_kids[1], IMMI_48) ) {
      unsigned int c = _kids[0]->_cost[_LSHIFTL_IREGL_IMMI_48]+_kids[1]->_cost[IMMI_48];
        DFA_PRODUCTION__SET_VALID(_RSHIFTL__LSHIFTL_IREGL_IMMI_48_IMMI_48, _RShiftL__LShiftL_iRegL_immI_48_immI_48_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LSHIFTL_IREGL_IMMI) && STATE__VALID_CHILD(_kids[1], IMMI) &&
        (
#line 10820 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
(unsigned int)n->in(2)->get_int() <= 63
            && (unsigned int)n->in(1)->in(2)->get_int() <= 63
#line 8226 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LSHIFTL_IREGL_IMMI]+_kids[1]->_cost[IMMI]+INSN_COST * 2;
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, sbfmL_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL, sbfmL_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL_R11, sbfmL_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IMMI];
        DFA_PRODUCTION__SET_VALID(_RSHIFTL_IREGL_IMMI, _RShiftL_iRegL_immI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IMMI] + INSN_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, rShiftL_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, rShiftL_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R11) || _cost[IREGL_R11] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R11, rShiftL_reg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IREGIORL2I) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IREGIORL2I]+INSN_COST * 2;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, rShiftL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, rShiftL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R11) || _cost[IREGL_R11] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R11, rShiftL_reg_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IMML_63) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IMML_63];
        DFA_PRODUCTION__SET_VALID(_RSHIFTL_IREGL_IMML_63, _RShiftL_iRegL_immL_63_rule, c)
    }
}
void  State::_sub_Op_Rethrow(const Node *n){
    {
      unsigned int c = CALL_COST;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, RethrowException_rule, c)
    }
}
void  State::_sub_Op_Return(const Node *n){
    {
      unsigned int c = INSN_COST;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, Ret_rule, c)
    }
}
void  State::_sub_Op_SafePoint(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGP) ) {
      unsigned int c = _kids[0]->_cost[IREGP] + INSN_COST;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, safePoint_rule, c)
    }
}
void  State::_sub_Op_SqrtD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _CONVF2D_VREGF_) ) {
      unsigned int c = _kids[0]->_cost[_CONVF2D_VREGF_];
        DFA_PRODUCTION__SET_VALID(_SQRTD__CONVF2D_VREGF__, _SqrtD__ConvF2D_vRegF___rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VREGD) ) {
      unsigned int c = _kids[0]->_cost[VREGD]+INSN_COST * 50;
        DFA_PRODUCTION__SET_VALID(VREGD, sqrtD_reg_rule, c)
    }
}
void  State::_sub_Op_StoreB(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], IREGIORL2I) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[IREGIORL2I] + VOLATILE_REF_COST;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeB_volatile_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], IMMI0) &&
        (
#line 6814 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
!needs_releasing_store(n)
#line 8303 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[IMMI0] + INSN_COST;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeimmB0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], IREGIORL2I) &&
        (
#line 6800 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
!needs_releasing_store(n)
#line 8314 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[IREGIORL2I] + INSN_COST;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeB_rule, c)
      }
    }
}
void  State::_sub_Op_StoreC(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], IREGIORL2I) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[IREGIORL2I] + VOLATILE_REF_COST;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeC_volatile_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], IMMI0) &&
        (
#line 6841 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
!needs_releasing_store(n)
#line 8331 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[IMMI0] + INSN_COST;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeimmC0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], IREGIORL2I) &&
        (
#line 6828 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
!needs_releasing_store(n)
#line 8342 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[IREGIORL2I] + INSN_COST;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeC_rule, c)
      }
    }
}
void  State::_sub_Op_StoreCM(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], IMMI0) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[IMMI0]+INSN_COST * 2;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeimmCM0_ordered_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], IMMI0) &&
        (
#line 6771 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
unnecessary_storestore(n)
#line 8359 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[IMMI0] + INSN_COST;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeimmCM0_rule, c)
      }
    }
}
void  State::_sub_Op_StorePConditional(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGP_IREGP) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_BINARY_IREGP_IREGP] + VOLATILE_REF_COST;
        DFA_PRODUCTION__SET_VALID(RFLAGSREG, storePConditional_rule, c)
    }
}
void  State::_sub_Op_StoreIConditional(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGINOSP_IREGINOSP) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[_BINARY_IREGINOSP_IREGINOSP] + VOLATILE_REF_COST;
        DFA_PRODUCTION__SET_VALID(RFLAGSREG, storeIConditional_rule, c)
    }
}
void  State::_sub_Op_StoreLConditional(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGLNOSP_IREGLNOSP) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[_BINARY_IREGLNOSP_IREGLNOSP] + VOLATILE_REF_COST;
        DFA_PRODUCTION__SET_VALID(RFLAGSREG, storeLConditional_rule, c)
    }
}
void  State::_sub_Op_StoreD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], VREGD) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[VREGD] + VOLATILE_REF_COST;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeD_volatile_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], VREGD) &&
        (
#line 7032 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
!needs_releasing_store(n)
#line 8394 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[VREGD] + INSN_COST;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeD_rule, c)
      }
    }
}
void  State::_sub_Op_StoreF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], VREGF) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[VREGF] + VOLATILE_REF_COST;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeF_volatile_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], VREGF) &&
        (
#line 7015 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
!needs_releasing_store(n)
#line 8411 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[VREGF] + INSN_COST;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeF_rule, c)
      }
    }
}
void  State::_sub_Op_StoreI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], IREGIORL2I) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[IREGIORL2I] + VOLATILE_REF_COST;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeI_volatile_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], IMMI0) &&
        (
#line 6869 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
!needs_releasing_store(n)
#line 8428 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[IMMI0] + INSN_COST;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeimmI0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], IREGIORL2I) &&
        (
#line 6856 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
!needs_releasing_store(n)
#line 8439 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[IREGIORL2I] + INSN_COST;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeI_rule, c)
      }
    }
}
void  State::_sub_Op_StoreL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], IREGL) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[IREGL] + VOLATILE_REF_COST;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeL_volatile_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], IMML0) &&
        (
#line 6897 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
!needs_releasing_store(n)
#line 8456 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[IMML0] + INSN_COST;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeimmL0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], IREGL) &&
        (
#line 6883 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
!needs_releasing_store(n)
#line 8467 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[IREGL] + INSN_COST;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeL_rule, c)
      }
    }
}
void  State::_sub_Op_StoreP(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], IREGP) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[IREGP] + VOLATILE_REF_COST;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeP_volatile_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], IMMP0) &&
        (
#line 6972 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
!needs_releasing_store(n)
#line 8484 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[IMMP0] + INSN_COST;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeimmP0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], IREGP) &&
        (
#line 6911 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
!needs_releasing_store(n)
#line 8495 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[IREGP] + INSN_COST;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeP_rule, c)
      }
    }
}
void  State::_sub_Op_StoreN(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], IREGN) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[IREGN] + VOLATILE_REF_COST;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeN_volatile_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], IMMN0) &&
        (
#line 6999 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
Universe::narrow_oop_base() == NULL &&
            Universe::narrow_klass_base() == NULL  &&
            (!needs_releasing_store(n))
#line 8514 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[IMMN0] + INSN_COST;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeImmN0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], IREGN) &&
        (
#line 6986 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
!needs_releasing_store(n)
#line 8525 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[IREGN] + INSN_COST;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeN_rule, c)
      }
    }
}
void  State::_sub_Op_StoreNKlass(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], IREGN) &&
        (
#line 7045 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
!needs_releasing_store(n)
#line 8538 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[IREGN] + INSN_COST;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeNKlass_rule, c)
    }
}
void  State::_sub_Op_StrComp(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _BINARY_IREGP_R1_IREGI_R2) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGP_R3_IREGI_R4) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_IREGP_R1_IREGI_R2]+_kids[1]->_cost[_BINARY_IREGP_R3_IREGI_R4] + INSN_COST;
        DFA_PRODUCTION__SET_VALID(IREGI_R0, string_compare_rule, c)
    }
}
void  State::_sub_Op_StrEquals(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _BINARY_IREGP_R1_IREGP_R3) && STATE__VALID_CHILD(_kids[1], IREGI_R4) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_IREGP_R1_IREGP_R3]+_kids[1]->_cost[IREGI_R4] + INSN_COST;
        DFA_PRODUCTION__SET_VALID(IREGI_R0, string_equals_rule, c)
    }
}
void  State::_sub_Op_StrIndexOf(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _BINARY_IREGP_R1_IREGI_R4) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGP_R3_IMMI_LE_4) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_IREGP_R1_IREGI_R4]+_kids[1]->_cost[_BINARY_IREGP_R3_IMMI_LE_4] + INSN_COST;
        DFA_PRODUCTION__SET_VALID(IREGI_R0, string_indexof_con_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_IREGP_R1_IREGI_R4) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGP_R3_IREGI_R2) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_IREGP_R1_IREGI_R4]+_kids[1]->_cost[_BINARY_IREGP_R3_IREGI_R2] + INSN_COST;
      if (STATE__NOT_YET_VALID(IREGI_R0) || _cost[IREGI_R0] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R0, string_indexof_rule, c)
      }
    }
}
void  State::_sub_Op_SubD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VREGD) && STATE__VALID_CHILD(_kids[1], VREGD) ) {
      unsigned int c = _kids[0]->_cost[VREGD]+_kids[1]->_cost[VREGD]+INSN_COST * 5;
        DFA_PRODUCTION__SET_VALID(VREGD, subD_reg_reg_rule, c)
    }
}
void  State::_sub_Op_SubF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VREGF) && STATE__VALID_CHILD(_kids[1], VREGF) ) {
      unsigned int c = _kids[0]->_cost[VREGF]+_kids[1]->_cost[VREGF]+INSN_COST * 5;
        DFA_PRODUCTION__SET_VALID(VREGF, subF_reg_reg_rule, c)
    }
}
void  State::_sub_Op_SubI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) && STATE__VALID_CHILD(_kids[1], _ANDI_IREGIORL2I_IMMI_65535) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I]+_kids[1]->_cost[_ANDI_IREGIORL2I_IMMI_65535] + INSN_COST;
        DFA_PRODUCTION__SET_VALID(IREGINOSP, SubExtI_uxth_and_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI, SubExtI_uxth_and_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R0, SubExtI_uxth_and_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R2, SubExtI_uxth_and_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R3, SubExtI_uxth_and_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R4, SubExtI_uxth_and_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) && STATE__VALID_CHILD(_kids[1], _ANDI_IREGIORL2I_IMMI_255) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I]+_kids[1]->_cost[_ANDI_IREGIORL2I_IMMI_255] + INSN_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, SubExtI_uxtb_and_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, SubExtI_uxtb_and_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R0) || _cost[IREGI_R0] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R0, SubExtI_uxtb_and_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R2) || _cost[IREGI_R2] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R2, SubExtI_uxtb_and_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R3) || _cost[IREGI_R3] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R3, SubExtI_uxtb_and_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R4) || _cost[IREGI_R4] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R4, SubExtI_uxtb_and_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI_32) && STATE__VALID_CHILD(_kids[1], IREGI) ) {
      unsigned int c = _kids[0]->_cost[IMMI_32]+_kids[1]->_cost[IREGI];
        DFA_PRODUCTION__SET_VALID(_SUBI_IMMI_32_IREGI, _SubI_immI_32_iRegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI0) && STATE__VALID_CHILD(_kids[1], IREGI) ) {
      unsigned int c = _kids[0]->_cost[IMMI0]+_kids[1]->_cost[IREGI];
        DFA_PRODUCTION__SET_VALID(_SUBI_IMMI0_IREGI, _SubI_immI0_iRegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI_64) && STATE__VALID_CHILD(_kids[1], IREGI) ) {
      unsigned int c = _kids[0]->_cost[IMMI_64]+_kids[1]->_cost[IREGI];
        DFA_PRODUCTION__SET_VALID(_SUBI_IMMI_64_IREGI, _SubI_immI_64_iRegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) && STATE__VALID_CHILD(_kids[1], _LSHIFTI_IREGIORL2I_IMMI) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I]+_kids[1]->_cost[_LSHIFTI_IREGIORL2I_IMMI]+1.9 * INSN_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, SubI_reg_LShift_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, SubI_reg_LShift_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R0) || _cost[IREGI_R0] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R0, SubI_reg_LShift_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R2) || _cost[IREGI_R2] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R2, SubI_reg_LShift_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R3) || _cost[IREGI_R3] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R3, SubI_reg_LShift_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R4) || _cost[IREGI_R4] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R4, SubI_reg_LShift_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) && STATE__VALID_CHILD(_kids[1], _RSHIFTI_IREGIORL2I_IMMI) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I]+_kids[1]->_cost[_RSHIFTI_IREGIORL2I_IMMI]+1.9 * INSN_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, SubI_reg_RShift_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, SubI_reg_RShift_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R0) || _cost[IREGI_R0] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R0, SubI_reg_RShift_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R2) || _cost[IREGI_R2] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R2, SubI_reg_RShift_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R3) || _cost[IREGI_R3] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R3, SubI_reg_RShift_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R4) || _cost[IREGI_R4] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R4, SubI_reg_RShift_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) && STATE__VALID_CHILD(_kids[1], _URSHIFTI_IREGIORL2I_IMMI) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I]+_kids[1]->_cost[_URSHIFTI_IREGIORL2I_IMMI]+1.9 * INSN_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, SubI_reg_URShift_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, SubI_reg_URShift_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R0) || _cost[IREGI_R0] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R0, SubI_reg_URShift_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R2) || _cost[IREGI_R2] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R2, SubI_reg_URShift_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R3) || _cost[IREGI_R3] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R3, SubI_reg_URShift_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R4) || _cost[IREGI_R4] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R4, SubI_reg_URShift_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) && STATE__VALID_CHILD(_kids[1], _MULI_IREGIORL2I_IREGIORL2I) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I]+_kids[1]->_cost[_MULI_IREGIORL2I_IREGIORL2I]+INSN_COST * 3;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, msubI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, msubI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R0) || _cost[IREGI_R0] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R0, msubI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R2) || _cost[IREGI_R2] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R2, msubI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R3) || _cost[IREGI_R3] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R3, msubI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R4) || _cost[IREGI_R4] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R4, msubI_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI0) && STATE__VALID_CHILD(_kids[1], IREGIORL2I) ) {
      unsigned int c = _kids[0]->_cost[IMMI0]+_kids[1]->_cost[IREGIORL2I] + INSN_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, negI_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, negI_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R0) || _cost[IREGI_R0] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R0, negI_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R2) || _cost[IREGI_R2] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R2, negI_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R3) || _cost[IREGI_R3] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R3, negI_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R4) || _cost[IREGI_R4] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R4, negI_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) && STATE__VALID_CHILD(_kids[1], IMMIADDSUB) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I]+_kids[1]->_cost[IMMIADDSUB] + INSN_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, subI_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, subI_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R0) || _cost[IREGI_R0] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R0, subI_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R2) || _cost[IREGI_R2] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R2, subI_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R3) || _cost[IREGI_R3] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R3, subI_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R4) || _cost[IREGI_R4] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R4, subI_reg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) && STATE__VALID_CHILD(_kids[1], IREGIORL2I) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I]+_kids[1]->_cost[IREGIORL2I] + INSN_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, subI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, subI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R0) || _cost[IREGI_R0] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R0, subI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R2) || _cost[IREGI_R2] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R2, subI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R3) || _cost[IREGI_R3] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R3, subI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R4) || _cost[IREGI_R4] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R4, subI_reg_reg_rule, c)
      }
    }
}
void  State::_sub_Op_SubL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], _ANDL_IREGL_IMML_4294967295) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[_ANDL_IREGL_IMML_4294967295] + INSN_COST;
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, SubExtL_uxtw_and_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL, SubExtL_uxtw_and_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL_R11, SubExtL_uxtw_and_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], _ANDL_IREGL_IMML_65535) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[_ANDL_IREGL_IMML_65535] + INSN_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, SubExtL_uxth_and_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, SubExtL_uxth_and_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R11) || _cost[IREGL_R11] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R11, SubExtL_uxth_and_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], _ANDL_IREGL_IMML_255) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[_ANDL_IREGL_IMML_255] + INSN_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, SubExtL_uxtb_and_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, SubExtL_uxtb_and_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R11) || _cost[IREGL_R11] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R11, SubExtL_uxtb_and_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], _CONVI2L_IREGIORL2I_) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[_CONVI2L_IREGIORL2I_] + INSN_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, SubExtI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, SubExtI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R11) || _cost[IREGL_R11] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R11, SubExtI_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], _LSHIFTL_IREGL_IMMI) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[_LSHIFTL_IREGL_IMMI]+1.9 * INSN_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, SubL_reg_LShift_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, SubL_reg_LShift_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R11) || _cost[IREGL_R11] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R11, SubL_reg_LShift_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], _RSHIFTL_IREGL_IMMI) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[_RSHIFTL_IREGL_IMMI]+1.9 * INSN_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, SubL_reg_RShift_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, SubL_reg_RShift_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R11) || _cost[IREGL_R11] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R11, SubL_reg_RShift_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], _URSHIFTL_IREGL_IMMI) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[_URSHIFTL_IREGL_IMMI]+1.9 * INSN_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, SubL_reg_URShift_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, SubL_reg_URShift_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R11) || _cost[IREGL_R11] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R11, SubL_reg_URShift_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], _MULL_IREGL_IREGL) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[_MULL_IREGL_IREGL]+INSN_COST * 5;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, msubL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, msubL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R11) || _cost[IREGL_R11] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R11, msubL_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IMML0) && STATE__VALID_CHILD(_kids[1], IREGIORL2I) ) {
      unsigned int c = _kids[0]->_cost[IMML0]+_kids[1]->_cost[IREGIORL2I] + INSN_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, negL_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, negL_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R11) || _cost[IREGL_R11] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R11, negL_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IMMLADDSUB) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IMMLADDSUB] + INSN_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, subL_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, subL_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R11) || _cost[IREGL_R11] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R11, subL_reg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IREGL) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IREGL] + INSN_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, subL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, subL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R11) || _cost[IREGL_R11] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R11, subL_reg_reg_rule, c)
      }
    }
}
void  State::_sub_Op_TailCall(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGPNOSP) && STATE__VALID_CHILD(_kids[1], INLINE_CACHE_REGP) ) {
      unsigned int c = _kids[0]->_cost[IREGPNOSP]+_kids[1]->_cost[INLINE_CACHE_REGP] + CALL_COST;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, TailCalljmpInd_rule, c)
    }
}
void  State::_sub_Op_TailJump(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGPNOSP) && STATE__VALID_CHILD(_kids[1], IREGP_R0) ) {
      unsigned int c = _kids[0]->_cost[IREGPNOSP]+_kids[1]->_cost[IREGP_R0] + CALL_COST;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, TailjmpInd_rule, c)
    }
}
void  State::_sub_Op_ThreadLocal(const Node *n){
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(THREAD_REGP, tlsLoadP_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGP, tlsLoadP_rule, c)
        DFA_PRODUCTION__SET_VALID(INLINE_CACHE_REGP, tlsLoadP_rule, c)
        DFA_PRODUCTION__SET_VALID(INTERPRETER_METHOD_OOP_REGP, tlsLoadP_rule, c)
        DFA_PRODUCTION__SET_VALID(LR_REGP, tlsLoadP_rule, c)
        DFA_PRODUCTION__SET_VALID(INDIRECT, tlsLoadP_rule, c)
        DFA_PRODUCTION__SET_VALID(VMEM4, indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(VMEM8, indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(VMEM16, indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
    }
}
void  State::_sub_Op_URShiftI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _LSHIFTI_IREGIORL2I_IMMI_24) && STATE__VALID_CHILD(_kids[1], IMMI_24) ) {
      unsigned int c = _kids[0]->_cost[_LSHIFTI_IREGIORL2I_IMMI_24]+_kids[1]->_cost[IMMI_24];
        DFA_PRODUCTION__SET_VALID(_URSHIFTI__LSHIFTI_IREGIORL2I_IMMI_24_IMMI_24, _URShiftI__LShiftI_iRegIorL2I_immI_24_immI_24_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGI) && STATE__VALID_CHILD(_kids[1], IREGI) ) {
      unsigned int c = _kids[0]->_cost[IREGI]+_kids[1]->_cost[IREGI];
        DFA_PRODUCTION__SET_VALID(_URSHIFTI_IREGI_IREGI, _URShiftI_iRegI_iRegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGI) && STATE__VALID_CHILD(_kids[1], _SUBI_IMMI0_IREGI) ) {
      unsigned int c = _kids[0]->_cost[IREGI]+_kids[1]->_cost[_SUBI_IMMI0_IREGI];
        DFA_PRODUCTION__SET_VALID(_URSHIFTI_IREGI__SUBI_IMMI0_IREGI, _URShiftI_iRegI__SubI_immI0_iRegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGI) && STATE__VALID_CHILD(_kids[1], _SUBI_IMMI_32_IREGI) ) {
      unsigned int c = _kids[0]->_cost[IREGI]+_kids[1]->_cost[_SUBI_IMMI_32_IREGI];
        DFA_PRODUCTION__SET_VALID(_URSHIFTI_IREGI__SUBI_IMMI_32_IREGI, _URShiftI_iRegI__SubI_immI_32_iRegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LSHIFTI_IREGIORL2I_IMMI) && STATE__VALID_CHILD(_kids[1], IMMI) &&
        (
#line 10889 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
(unsigned int)n->in(2)->get_int() <= 31
            && (unsigned int)n->in(1)->in(2)->get_int() <= 31
#line 8973 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LSHIFTI_IREGIORL2I_IMMI]+_kids[1]->_cost[IMMI]+INSN_COST * 2;
        DFA_PRODUCTION__SET_VALID(IREGINOSP, ubfmwI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI, ubfmwI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R0, ubfmwI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R2, ubfmwI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R3, ubfmwI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R4, ubfmwI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I]+_kids[1]->_cost[IMMI];
        DFA_PRODUCTION__SET_VALID(_URSHIFTI_IREGIORL2I_IMMI, _URShiftI_iRegIorL2I_immI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I]+_kids[1]->_cost[IMMI] + INSN_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, urShiftI_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, urShiftI_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R0) || _cost[IREGI_R0] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R0, urShiftI_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R2) || _cost[IREGI_R2] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R2, urShiftI_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R3) || _cost[IREGI_R3] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R3, urShiftI_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R4) || _cost[IREGI_R4] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R4, urShiftI_reg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) && STATE__VALID_CHILD(_kids[1], IREGIORL2I) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I]+_kids[1]->_cost[IREGIORL2I]+INSN_COST * 2;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, urShiftI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, urShiftI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R0) || _cost[IREGI_R0] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R0, urShiftI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R2) || _cost[IREGI_R2] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R2, urShiftI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R3) || _cost[IREGI_R3] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R3, urShiftI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R4) || _cost[IREGI_R4] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R4, urShiftI_reg_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _RSHIFTI_IREGIORL2I_IMMI_31) && STATE__VALID_CHILD(_kids[1], IMMI_31) ) {
      unsigned int c = _kids[0]->_cost[_RSHIFTI_IREGIORL2I_IMMI_31]+_kids[1]->_cost[IMMI_31];
        DFA_PRODUCTION__SET_VALID(_URSHIFTI__RSHIFTI_IREGIORL2I_IMMI_31_IMMI_31, _URShiftI__RShiftI_iRegIorL2I_immI_31_immI_31_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _RSHIFTI_IREGIORL2I_IMMI_31) && STATE__VALID_CHILD(_kids[1], IMMI_31) ) {
      unsigned int c = _kids[0]->_cost[_RSHIFTI_IREGIORL2I_IMMI_31]+_kids[1]->_cost[IMMI_31] + INSN_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, signExtract_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, signExtract_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R0) || _cost[IREGI_R0] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R0, signExtract_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R2) || _cost[IREGI_R2] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R2, signExtract_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R3) || _cost[IREGI_R3] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R3, signExtract_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R4) || _cost[IREGI_R4] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R4, signExtract_rule, c)
      }
    }
}
void  State::_sub_Op_URShiftL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _LSHIFTL_IREGL_IMMI_56) && STATE__VALID_CHILD(_kids[1], IMMI_56) ) {
      unsigned int c = _kids[0]->_cost[_LSHIFTL_IREGL_IMMI_56]+_kids[1]->_cost[IMMI_56];
        DFA_PRODUCTION__SET_VALID(_URSHIFTL__LSHIFTL_IREGL_IMMI_56_IMMI_56, _URShiftL__LShiftL_iRegL_immI_56_immI_56_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IREGI) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IREGI];
        DFA_PRODUCTION__SET_VALID(_URSHIFTL_IREGL_IREGI, _URShiftL_iRegL_iRegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], _SUBI_IMMI0_IREGI) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[_SUBI_IMMI0_IREGI];
        DFA_PRODUCTION__SET_VALID(_URSHIFTL_IREGL__SUBI_IMMI0_IREGI, _URShiftL_iRegL__SubI_immI0_iRegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], _SUBI_IMMI_64_IREGI) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[_SUBI_IMMI_64_IREGI];
        DFA_PRODUCTION__SET_VALID(_URSHIFTL_IREGL__SUBI_IMMI_64_IREGI, _URShiftL_iRegL__SubI_immI_64_iRegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LSHIFTL_IREGL_IMMI) && STATE__VALID_CHILD(_kids[1], IMMI) &&
        (
#line 10866 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
(unsigned int)n->in(2)->get_int() <= 63
            && (unsigned int)n->in(1)->in(2)->get_int() <= 63
#line 9087 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LSHIFTL_IREGL_IMMI]+_kids[1]->_cost[IMMI]+INSN_COST * 2;
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, ubfmL_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL, ubfmL_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL_R11, ubfmL_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IMMI];
        DFA_PRODUCTION__SET_VALID(_URSHIFTL_IREGL_IMMI, _URShiftL_iRegL_immI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _CASTP2X_IREGP_) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[_CASTP2X_IREGP_]+_kids[1]->_cost[IMMI] + INSN_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, urShiftP_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, urShiftP_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R11) || _cost[IREGL_R11] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R11, urShiftP_reg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IMMI] + INSN_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, urShiftL_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, urShiftL_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R11) || _cost[IREGL_R11] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R11, urShiftL_reg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IREGIORL2I) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IREGIORL2I]+INSN_COST * 2;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, urShiftL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, urShiftL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R11) || _cost[IREGL_R11] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R11, urShiftL_reg_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _RSHIFTL_IREGL_IMML_63) && STATE__VALID_CHILD(_kids[1], IMML_63) ) {
      unsigned int c = _kids[0]->_cost[_RSHIFTL_IREGL_IMML_63]+_kids[1]->_cost[IMML_63];
        DFA_PRODUCTION__SET_VALID(_URSHIFTL__RSHIFTL_IREGL_IMML_63_IMML_63, _URShiftL__RShiftL_iRegL_immL_63_immL_63_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _RSHIFTL_IREGL_IMML_63) && STATE__VALID_CHILD(_kids[1], IMML_63) ) {
      unsigned int c = _kids[0]->_cost[_RSHIFTL_IREGL_IMML_63]+_kids[1]->_cost[IMML_63] + INSN_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, signExtractL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, signExtractL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R11) || _cost[IREGL_R11] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R11, signExtractL_rule, c)
      }
    }
}
void  State::_sub_Op_XorI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) && STATE__VALID_CHILD(_kids[1], IMMILOG) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I]+_kids[1]->_cost[IMMILOG] + INSN_COST;
        DFA_PRODUCTION__SET_VALID(IREGINOSP, xorI_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI, xorI_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R0, xorI_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R2, xorI_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R3, xorI_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGI_R4, xorI_reg_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) && STATE__VALID_CHILD(_kids[1], IREGIORL2I) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I]+_kids[1]->_cost[IREGIORL2I] + INSN_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, xorI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, xorI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R0) || _cost[IREGI_R0] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R0, xorI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R2) || _cost[IREGI_R2] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R2, xorI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R3) || _cost[IREGI_R3] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R3, xorI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R4) || _cost[IREGI_R4] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R4, xorI_reg_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LSHIFTI_IREGIORL2I_IMMI) && STATE__VALID_CHILD(_kids[1], IREGIORL2I) ) {
      unsigned int c = _kids[0]->_cost[_LSHIFTI_IREGIORL2I_IMMI]+_kids[1]->_cost[IREGIORL2I]+1.9 * INSN_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, XorI_reg_LShift_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, XorI_reg_LShift_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R0) || _cost[IREGI_R0] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R0, XorI_reg_LShift_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R2) || _cost[IREGI_R2] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R2, XorI_reg_LShift_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R3) || _cost[IREGI_R3] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R3, XorI_reg_LShift_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R4) || _cost[IREGI_R4] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R4, XorI_reg_LShift_reg_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) && STATE__VALID_CHILD(_kids[1], _LSHIFTI_IREGIORL2I_IMMI) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I]+_kids[1]->_cost[_LSHIFTI_IREGIORL2I_IMMI]+1.9 * INSN_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, XorI_reg_LShift_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, XorI_reg_LShift_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R0) || _cost[IREGI_R0] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R0, XorI_reg_LShift_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R2) || _cost[IREGI_R2] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R2, XorI_reg_LShift_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R3) || _cost[IREGI_R3] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R3, XorI_reg_LShift_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R4) || _cost[IREGI_R4] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R4, XorI_reg_LShift_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _RSHIFTI_IREGIORL2I_IMMI) && STATE__VALID_CHILD(_kids[1], IREGIORL2I) ) {
      unsigned int c = _kids[0]->_cost[_RSHIFTI_IREGIORL2I_IMMI]+_kids[1]->_cost[IREGIORL2I]+1.9 * INSN_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, XorI_reg_RShift_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, XorI_reg_RShift_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R0) || _cost[IREGI_R0] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R0, XorI_reg_RShift_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R2) || _cost[IREGI_R2] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R2, XorI_reg_RShift_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R3) || _cost[IREGI_R3] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R3, XorI_reg_RShift_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R4) || _cost[IREGI_R4] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R4, XorI_reg_RShift_reg_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) && STATE__VALID_CHILD(_kids[1], _RSHIFTI_IREGIORL2I_IMMI) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I]+_kids[1]->_cost[_RSHIFTI_IREGIORL2I_IMMI]+1.9 * INSN_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, XorI_reg_RShift_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, XorI_reg_RShift_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R0) || _cost[IREGI_R0] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R0, XorI_reg_RShift_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R2) || _cost[IREGI_R2] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R2, XorI_reg_RShift_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R3) || _cost[IREGI_R3] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R3, XorI_reg_RShift_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R4) || _cost[IREGI_R4] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R4, XorI_reg_RShift_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _URSHIFTI_IREGIORL2I_IMMI) && STATE__VALID_CHILD(_kids[1], IREGIORL2I) ) {
      unsigned int c = _kids[0]->_cost[_URSHIFTI_IREGIORL2I_IMMI]+_kids[1]->_cost[IREGIORL2I]+1.9 * INSN_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, XorI_reg_URShift_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, XorI_reg_URShift_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R0) || _cost[IREGI_R0] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R0, XorI_reg_URShift_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R2) || _cost[IREGI_R2] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R2, XorI_reg_URShift_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R3) || _cost[IREGI_R3] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R3, XorI_reg_URShift_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R4) || _cost[IREGI_R4] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R4, XorI_reg_URShift_reg_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) && STATE__VALID_CHILD(_kids[1], _URSHIFTI_IREGIORL2I_IMMI) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I]+_kids[1]->_cost[_URSHIFTI_IREGIORL2I_IMMI]+1.9 * INSN_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, XorI_reg_URShift_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, XorI_reg_URShift_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R0) || _cost[IREGI_R0] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R0, XorI_reg_URShift_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R2) || _cost[IREGI_R2] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R2, XorI_reg_URShift_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R3) || _cost[IREGI_R3] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R3, XorI_reg_URShift_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R4) || _cost[IREGI_R4] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R4, XorI_reg_URShift_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _XORI_IREGIORL2I__LSHIFTI_IREGIORL2I_IMMI) && STATE__VALID_CHILD(_kids[1], IMMI_M1) ) {
      unsigned int c = _kids[0]->_cost[_XORI_IREGIORL2I__LSHIFTI_IREGIORL2I_IMMI]+_kids[1]->_cost[IMMI_M1]+1.9 * INSN_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, XorI_reg_LShift_not_reg_2_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, XorI_reg_LShift_not_reg_2_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R0) || _cost[IREGI_R0] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R0, XorI_reg_LShift_not_reg_2_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R2) || _cost[IREGI_R2] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R2, XorI_reg_LShift_not_reg_2_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R3) || _cost[IREGI_R3] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R3, XorI_reg_LShift_not_reg_2_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R4) || _cost[IREGI_R4] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R4, XorI_reg_LShift_not_reg_2_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI_M1) && STATE__VALID_CHILD(_kids[1], _XORI_IREGIORL2I__LSHIFTI_IREGIORL2I_IMMI) ) {
      unsigned int c = _kids[0]->_cost[IMMI_M1]+_kids[1]->_cost[_XORI_IREGIORL2I__LSHIFTI_IREGIORL2I_IMMI]+1.9 * INSN_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, XorI_reg_LShift_not_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, XorI_reg_LShift_not_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R0) || _cost[IREGI_R0] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R0, XorI_reg_LShift_not_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R2) || _cost[IREGI_R2] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R2, XorI_reg_LShift_not_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R3) || _cost[IREGI_R3] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R3, XorI_reg_LShift_not_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R4) || _cost[IREGI_R4] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R4, XorI_reg_LShift_not_reg_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) && STATE__VALID_CHILD(_kids[1], _LSHIFTI_IREGIORL2I_IMMI) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I]+_kids[1]->_cost[_LSHIFTI_IREGIORL2I_IMMI];
        DFA_PRODUCTION__SET_VALID(_XORI_IREGIORL2I__LSHIFTI_IREGIORL2I_IMMI, _XorI_iRegIorL2I__LShiftI_iRegIorL2I_immI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _XORI__LSHIFTI_IREGIORL2I_IMMI_IREGIORL2I) && STATE__VALID_CHILD(_kids[1], IMMI_M1) ) {
      unsigned int c = _kids[0]->_cost[_XORI__LSHIFTI_IREGIORL2I_IMMI_IREGIORL2I]+_kids[1]->_cost[IMMI_M1]+1.9 * INSN_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, XorI_reg_LShift_not_reg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, XorI_reg_LShift_not_reg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R0) || _cost[IREGI_R0] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R0, XorI_reg_LShift_not_reg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R2) || _cost[IREGI_R2] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R2, XorI_reg_LShift_not_reg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R3) || _cost[IREGI_R3] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R3, XorI_reg_LShift_not_reg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R4) || _cost[IREGI_R4] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R4, XorI_reg_LShift_not_reg_1_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI_M1) && STATE__VALID_CHILD(_kids[1], _XORI__LSHIFTI_IREGIORL2I_IMMI_IREGIORL2I) ) {
      unsigned int c = _kids[0]->_cost[IMMI_M1]+_kids[1]->_cost[_XORI__LSHIFTI_IREGIORL2I_IMMI_IREGIORL2I]+1.9 * INSN_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, XorI_reg_LShift_not_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, XorI_reg_LShift_not_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R0) || _cost[IREGI_R0] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R0, XorI_reg_LShift_not_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R2) || _cost[IREGI_R2] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R2, XorI_reg_LShift_not_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R3) || _cost[IREGI_R3] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R3, XorI_reg_LShift_not_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R4) || _cost[IREGI_R4] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R4, XorI_reg_LShift_not_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LSHIFTI_IREGIORL2I_IMMI) && STATE__VALID_CHILD(_kids[1], IREGIORL2I) ) {
      unsigned int c = _kids[0]->_cost[_LSHIFTI_IREGIORL2I_IMMI]+_kids[1]->_cost[IREGIORL2I];
        DFA_PRODUCTION__SET_VALID(_XORI__LSHIFTI_IREGIORL2I_IMMI_IREGIORL2I, _XorI__LShiftI_iRegIorL2I_immI_iRegIorL2I_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _XORI_IREGIORL2I__RSHIFTI_IREGIORL2I_IMMI) && STATE__VALID_CHILD(_kids[1], IMMI_M1) ) {
      unsigned int c = _kids[0]->_cost[_XORI_IREGIORL2I__RSHIFTI_IREGIORL2I_IMMI]+_kids[1]->_cost[IMMI_M1]+1.9 * INSN_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, XorI_reg_RShift_not_reg_2_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, XorI_reg_RShift_not_reg_2_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R0) || _cost[IREGI_R0] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R0, XorI_reg_RShift_not_reg_2_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R2) || _cost[IREGI_R2] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R2, XorI_reg_RShift_not_reg_2_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R3) || _cost[IREGI_R3] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R3, XorI_reg_RShift_not_reg_2_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R4) || _cost[IREGI_R4] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R4, XorI_reg_RShift_not_reg_2_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI_M1) && STATE__VALID_CHILD(_kids[1], _XORI_IREGIORL2I__RSHIFTI_IREGIORL2I_IMMI) ) {
      unsigned int c = _kids[0]->_cost[IMMI_M1]+_kids[1]->_cost[_XORI_IREGIORL2I__RSHIFTI_IREGIORL2I_IMMI]+1.9 * INSN_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, XorI_reg_RShift_not_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, XorI_reg_RShift_not_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R0) || _cost[IREGI_R0] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R0, XorI_reg_RShift_not_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R2) || _cost[IREGI_R2] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R2, XorI_reg_RShift_not_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R3) || _cost[IREGI_R3] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R3, XorI_reg_RShift_not_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R4) || _cost[IREGI_R4] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R4, XorI_reg_RShift_not_reg_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) && STATE__VALID_CHILD(_kids[1], _RSHIFTI_IREGIORL2I_IMMI) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I]+_kids[1]->_cost[_RSHIFTI_IREGIORL2I_IMMI];
        DFA_PRODUCTION__SET_VALID(_XORI_IREGIORL2I__RSHIFTI_IREGIORL2I_IMMI, _XorI_iRegIorL2I__RShiftI_iRegIorL2I_immI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _XORI__RSHIFTI_IREGIORL2I_IMMI_IREGIORL2I) && STATE__VALID_CHILD(_kids[1], IMMI_M1) ) {
      unsigned int c = _kids[0]->_cost[_XORI__RSHIFTI_IREGIORL2I_IMMI_IREGIORL2I]+_kids[1]->_cost[IMMI_M1]+1.9 * INSN_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, XorI_reg_RShift_not_reg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, XorI_reg_RShift_not_reg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R0) || _cost[IREGI_R0] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R0, XorI_reg_RShift_not_reg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R2) || _cost[IREGI_R2] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R2, XorI_reg_RShift_not_reg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R3) || _cost[IREGI_R3] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R3, XorI_reg_RShift_not_reg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R4) || _cost[IREGI_R4] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R4, XorI_reg_RShift_not_reg_1_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI_M1) && STATE__VALID_CHILD(_kids[1], _XORI__RSHIFTI_IREGIORL2I_IMMI_IREGIORL2I) ) {
      unsigned int c = _kids[0]->_cost[IMMI_M1]+_kids[1]->_cost[_XORI__RSHIFTI_IREGIORL2I_IMMI_IREGIORL2I]+1.9 * INSN_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, XorI_reg_RShift_not_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, XorI_reg_RShift_not_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R0) || _cost[IREGI_R0] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R0, XorI_reg_RShift_not_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R2) || _cost[IREGI_R2] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R2, XorI_reg_RShift_not_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R3) || _cost[IREGI_R3] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R3, XorI_reg_RShift_not_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R4) || _cost[IREGI_R4] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R4, XorI_reg_RShift_not_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _RSHIFTI_IREGIORL2I_IMMI) && STATE__VALID_CHILD(_kids[1], IREGIORL2I) ) {
      unsigned int c = _kids[0]->_cost[_RSHIFTI_IREGIORL2I_IMMI]+_kids[1]->_cost[IREGIORL2I];
        DFA_PRODUCTION__SET_VALID(_XORI__RSHIFTI_IREGIORL2I_IMMI_IREGIORL2I, _XorI__RShiftI_iRegIorL2I_immI_iRegIorL2I_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _XORI_IREGIORL2I__URSHIFTI_IREGIORL2I_IMMI) && STATE__VALID_CHILD(_kids[1], IMMI_M1) ) {
      unsigned int c = _kids[0]->_cost[_XORI_IREGIORL2I__URSHIFTI_IREGIORL2I_IMMI]+_kids[1]->_cost[IMMI_M1]+1.9 * INSN_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, XorI_reg_URShift_not_reg_2_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, XorI_reg_URShift_not_reg_2_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R0) || _cost[IREGI_R0] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R0, XorI_reg_URShift_not_reg_2_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R2) || _cost[IREGI_R2] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R2, XorI_reg_URShift_not_reg_2_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R3) || _cost[IREGI_R3] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R3, XorI_reg_URShift_not_reg_2_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R4) || _cost[IREGI_R4] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R4, XorI_reg_URShift_not_reg_2_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI_M1) && STATE__VALID_CHILD(_kids[1], _XORI_IREGIORL2I__URSHIFTI_IREGIORL2I_IMMI) ) {
      unsigned int c = _kids[0]->_cost[IMMI_M1]+_kids[1]->_cost[_XORI_IREGIORL2I__URSHIFTI_IREGIORL2I_IMMI]+1.9 * INSN_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, XorI_reg_URShift_not_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, XorI_reg_URShift_not_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R0) || _cost[IREGI_R0] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R0, XorI_reg_URShift_not_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R2) || _cost[IREGI_R2] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R2, XorI_reg_URShift_not_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R3) || _cost[IREGI_R3] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R3, XorI_reg_URShift_not_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R4) || _cost[IREGI_R4] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R4, XorI_reg_URShift_not_reg_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) && STATE__VALID_CHILD(_kids[1], _URSHIFTI_IREGIORL2I_IMMI) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I]+_kids[1]->_cost[_URSHIFTI_IREGIORL2I_IMMI];
        DFA_PRODUCTION__SET_VALID(_XORI_IREGIORL2I__URSHIFTI_IREGIORL2I_IMMI, _XorI_iRegIorL2I__URShiftI_iRegIorL2I_immI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _XORI__URSHIFTI_IREGIORL2I_IMMI_IREGIORL2I) && STATE__VALID_CHILD(_kids[1], IMMI_M1) ) {
      unsigned int c = _kids[0]->_cost[_XORI__URSHIFTI_IREGIORL2I_IMMI_IREGIORL2I]+_kids[1]->_cost[IMMI_M1]+1.9 * INSN_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, XorI_reg_URShift_not_reg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, XorI_reg_URShift_not_reg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R0) || _cost[IREGI_R0] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R0, XorI_reg_URShift_not_reg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R2) || _cost[IREGI_R2] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R2, XorI_reg_URShift_not_reg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R3) || _cost[IREGI_R3] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R3, XorI_reg_URShift_not_reg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R4) || _cost[IREGI_R4] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R4, XorI_reg_URShift_not_reg_1_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI_M1) && STATE__VALID_CHILD(_kids[1], _XORI__URSHIFTI_IREGIORL2I_IMMI_IREGIORL2I) ) {
      unsigned int c = _kids[0]->_cost[IMMI_M1]+_kids[1]->_cost[_XORI__URSHIFTI_IREGIORL2I_IMMI_IREGIORL2I]+1.9 * INSN_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, XorI_reg_URShift_not_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, XorI_reg_URShift_not_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R0) || _cost[IREGI_R0] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R0, XorI_reg_URShift_not_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R2) || _cost[IREGI_R2] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R2, XorI_reg_URShift_not_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R3) || _cost[IREGI_R3] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R3, XorI_reg_URShift_not_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R4) || _cost[IREGI_R4] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R4, XorI_reg_URShift_not_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _URSHIFTI_IREGIORL2I_IMMI) && STATE__VALID_CHILD(_kids[1], IREGIORL2I) ) {
      unsigned int c = _kids[0]->_cost[_URSHIFTI_IREGIORL2I_IMMI]+_kids[1]->_cost[IREGIORL2I];
        DFA_PRODUCTION__SET_VALID(_XORI__URSHIFTI_IREGIORL2I_IMMI_IREGIORL2I, _XorI__URShiftI_iRegIorL2I_immI_iRegIorL2I_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LSHIFTI_IREGIORL2I_IMMI) && STATE__VALID_CHILD(_kids[1], IMMI_M1) ) {
      unsigned int c = _kids[0]->_cost[_LSHIFTI_IREGIORL2I_IMMI]+_kids[1]->_cost[IMMI_M1];
        DFA_PRODUCTION__SET_VALID(_XORI__LSHIFTI_IREGIORL2I_IMMI_IMMI_M1, _XorI__LShiftI_iRegIorL2I_immI_immI_M1_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _RSHIFTI_IREGIORL2I_IMMI) && STATE__VALID_CHILD(_kids[1], IMMI_M1) ) {
      unsigned int c = _kids[0]->_cost[_RSHIFTI_IREGIORL2I_IMMI]+_kids[1]->_cost[IMMI_M1];
        DFA_PRODUCTION__SET_VALID(_XORI__RSHIFTI_IREGIORL2I_IMMI_IMMI_M1, _XorI__RShiftI_iRegIorL2I_immI_immI_M1_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _URSHIFTI_IREGIORL2I_IMMI) && STATE__VALID_CHILD(_kids[1], IMMI_M1) ) {
      unsigned int c = _kids[0]->_cost[_URSHIFTI_IREGIORL2I_IMMI]+_kids[1]->_cost[IMMI_M1];
        DFA_PRODUCTION__SET_VALID(_XORI__URSHIFTI_IREGIORL2I_IMMI_IMMI_M1, _XorI__URShiftI_iRegIorL2I_immI_immI_M1_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _XORI_IREGIORL2I_IREGIORL2I) && STATE__VALID_CHILD(_kids[1], IMMI_M1) ) {
      unsigned int c = _kids[0]->_cost[_XORI_IREGIORL2I_IREGIORL2I]+_kids[1]->_cost[IMMI_M1] + INSN_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, XorI_reg_not_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, XorI_reg_not_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R0) || _cost[IREGI_R0] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R0, XorI_reg_not_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R2) || _cost[IREGI_R2] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R2, XorI_reg_not_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R3) || _cost[IREGI_R3] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R3, XorI_reg_not_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R4) || _cost[IREGI_R4] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R4, XorI_reg_not_reg_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI_M1) && STATE__VALID_CHILD(_kids[1], _XORI_IREGIORL2I_IREGIORL2I) ) {
      unsigned int c = _kids[0]->_cost[IMMI_M1]+_kids[1]->_cost[_XORI_IREGIORL2I_IREGIORL2I] + INSN_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, XorI_reg_not_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, XorI_reg_not_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R0) || _cost[IREGI_R0] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R0, XorI_reg_not_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R2) || _cost[IREGI_R2] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R2, XorI_reg_not_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R3) || _cost[IREGI_R3] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R3, XorI_reg_not_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R4) || _cost[IREGI_R4] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R4, XorI_reg_not_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) && STATE__VALID_CHILD(_kids[1], IREGIORL2I) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I]+_kids[1]->_cost[IREGIORL2I];
        DFA_PRODUCTION__SET_VALID(_XORI_IREGIORL2I_IREGIORL2I, _XorI_iRegIorL2I_iRegIorL2I_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) && STATE__VALID_CHILD(_kids[1], IMMI_M1) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I]+_kids[1]->_cost[IMMI_M1];
        DFA_PRODUCTION__SET_VALID(_XORI_IREGIORL2I_IMMI_M1, _XorI_iRegIorL2I_immI_M1_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) && STATE__VALID_CHILD(_kids[1], IMMI_M1) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I]+_kids[1]->_cost[IMMI_M1] + INSN_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGINOSP, regI_not_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI, regI_not_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION__SET_VALID(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R0) || _cost[IREGI_R0] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R0, regI_not_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R2) || _cost[IREGI_R2] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R2, regI_not_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R3) || _cost[IREGI_R3] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R3, regI_not_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R4) || _cost[IREGI_R4] > c) {
        DFA_PRODUCTION__SET_VALID(IREGI_R4, regI_not_reg_rule, c)
      }
    }
}
void  State::_sub_Op_XorL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IMMLLOG) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IMMLLOG] + INSN_COST;
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, xorL_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL, xorL_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(IREGL_R11, xorL_reg_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IREGL) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IREGL] + INSN_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, xorL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, xorL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R11) || _cost[IREGL_R11] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R11, xorL_reg_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LSHIFTL_IREGL_IMMI) && STATE__VALID_CHILD(_kids[1], IREGL) ) {
      unsigned int c = _kids[0]->_cost[_LSHIFTL_IREGL_IMMI]+_kids[1]->_cost[IREGL]+1.9 * INSN_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, XorL_reg_LShift_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, XorL_reg_LShift_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R11) || _cost[IREGL_R11] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R11, XorL_reg_LShift_reg_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], _LSHIFTL_IREGL_IMMI) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[_LSHIFTL_IREGL_IMMI]+1.9 * INSN_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, XorL_reg_LShift_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, XorL_reg_LShift_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R11) || _cost[IREGL_R11] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R11, XorL_reg_LShift_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _RSHIFTL_IREGL_IMMI) && STATE__VALID_CHILD(_kids[1], IREGL) ) {
      unsigned int c = _kids[0]->_cost[_RSHIFTL_IREGL_IMMI]+_kids[1]->_cost[IREGL]+1.9 * INSN_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, XorL_reg_RShift_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, XorL_reg_RShift_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R11) || _cost[IREGL_R11] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R11, XorL_reg_RShift_reg_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], _RSHIFTL_IREGL_IMMI) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[_RSHIFTL_IREGL_IMMI]+1.9 * INSN_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, XorL_reg_RShift_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, XorL_reg_RShift_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R11) || _cost[IREGL_R11] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R11, XorL_reg_RShift_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _URSHIFTL_IREGL_IMMI) && STATE__VALID_CHILD(_kids[1], IREGL) ) {
      unsigned int c = _kids[0]->_cost[_URSHIFTL_IREGL_IMMI]+_kids[1]->_cost[IREGL]+1.9 * INSN_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, XorL_reg_URShift_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, XorL_reg_URShift_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R11) || _cost[IREGL_R11] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R11, XorL_reg_URShift_reg_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], _URSHIFTL_IREGL_IMMI) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[_URSHIFTL_IREGL_IMMI]+1.9 * INSN_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, XorL_reg_URShift_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, XorL_reg_URShift_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R11) || _cost[IREGL_R11] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R11, XorL_reg_URShift_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _XORL_IREGL__LSHIFTL_IREGL_IMMI) && STATE__VALID_CHILD(_kids[1], IMML_M1) ) {
      unsigned int c = _kids[0]->_cost[_XORL_IREGL__LSHIFTL_IREGL_IMMI]+_kids[1]->_cost[IMML_M1]+1.9 * INSN_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, XorL_reg_LShift_not_reg_2_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, XorL_reg_LShift_not_reg_2_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R11) || _cost[IREGL_R11] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R11, XorL_reg_LShift_not_reg_2_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IMML_M1) && STATE__VALID_CHILD(_kids[1], _XORL_IREGL__LSHIFTL_IREGL_IMMI) ) {
      unsigned int c = _kids[0]->_cost[IMML_M1]+_kids[1]->_cost[_XORL_IREGL__LSHIFTL_IREGL_IMMI]+1.9 * INSN_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, XorL_reg_LShift_not_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, XorL_reg_LShift_not_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R11) || _cost[IREGL_R11] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R11, XorL_reg_LShift_not_reg_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], _LSHIFTL_IREGL_IMMI) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[_LSHIFTL_IREGL_IMMI];
        DFA_PRODUCTION__SET_VALID(_XORL_IREGL__LSHIFTL_IREGL_IMMI, _XorL_iRegL__LShiftL_iRegL_immI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _XORL__LSHIFTL_IREGL_IMMI_IREGL) && STATE__VALID_CHILD(_kids[1], IMML_M1) ) {
      unsigned int c = _kids[0]->_cost[_XORL__LSHIFTL_IREGL_IMMI_IREGL]+_kids[1]->_cost[IMML_M1]+1.9 * INSN_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, XorL_reg_LShift_not_reg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, XorL_reg_LShift_not_reg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R11) || _cost[IREGL_R11] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R11, XorL_reg_LShift_not_reg_1_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IMML_M1) && STATE__VALID_CHILD(_kids[1], _XORL__LSHIFTL_IREGL_IMMI_IREGL) ) {
      unsigned int c = _kids[0]->_cost[IMML_M1]+_kids[1]->_cost[_XORL__LSHIFTL_IREGL_IMMI_IREGL]+1.9 * INSN_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, XorL_reg_LShift_not_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, XorL_reg_LShift_not_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R11) || _cost[IREGL_R11] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R11, XorL_reg_LShift_not_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LSHIFTL_IREGL_IMMI) && STATE__VALID_CHILD(_kids[1], IREGL) ) {
      unsigned int c = _kids[0]->_cost[_LSHIFTL_IREGL_IMMI]+_kids[1]->_cost[IREGL];
        DFA_PRODUCTION__SET_VALID(_XORL__LSHIFTL_IREGL_IMMI_IREGL, _XorL__LShiftL_iRegL_immI_iRegL_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _XORL_IREGL__RSHIFTL_IREGL_IMMI) && STATE__VALID_CHILD(_kids[1], IMML_M1) ) {
      unsigned int c = _kids[0]->_cost[_XORL_IREGL__RSHIFTL_IREGL_IMMI]+_kids[1]->_cost[IMML_M1]+1.9 * INSN_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, XorL_reg_RShift_not_reg_2_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, XorL_reg_RShift_not_reg_2_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R11) || _cost[IREGL_R11] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R11, XorL_reg_RShift_not_reg_2_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IMML_M1) && STATE__VALID_CHILD(_kids[1], _XORL_IREGL__RSHIFTL_IREGL_IMMI) ) {
      unsigned int c = _kids[0]->_cost[IMML_M1]+_kids[1]->_cost[_XORL_IREGL__RSHIFTL_IREGL_IMMI]+1.9 * INSN_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, XorL_reg_RShift_not_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, XorL_reg_RShift_not_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R11) || _cost[IREGL_R11] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R11, XorL_reg_RShift_not_reg_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], _RSHIFTL_IREGL_IMMI) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[_RSHIFTL_IREGL_IMMI];
        DFA_PRODUCTION__SET_VALID(_XORL_IREGL__RSHIFTL_IREGL_IMMI, _XorL_iRegL__RShiftL_iRegL_immI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _XORL__RSHIFTL_IREGL_IMMI_IREGL) && STATE__VALID_CHILD(_kids[1], IMML_M1) ) {
      unsigned int c = _kids[0]->_cost[_XORL__RSHIFTL_IREGL_IMMI_IREGL]+_kids[1]->_cost[IMML_M1]+1.9 * INSN_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, XorL_reg_RShift_not_reg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, XorL_reg_RShift_not_reg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R11) || _cost[IREGL_R11] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R11, XorL_reg_RShift_not_reg_1_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IMML_M1) && STATE__VALID_CHILD(_kids[1], _XORL__RSHIFTL_IREGL_IMMI_IREGL) ) {
      unsigned int c = _kids[0]->_cost[IMML_M1]+_kids[1]->_cost[_XORL__RSHIFTL_IREGL_IMMI_IREGL]+1.9 * INSN_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, XorL_reg_RShift_not_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, XorL_reg_RShift_not_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R11) || _cost[IREGL_R11] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R11, XorL_reg_RShift_not_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _RSHIFTL_IREGL_IMMI) && STATE__VALID_CHILD(_kids[1], IREGL) ) {
      unsigned int c = _kids[0]->_cost[_RSHIFTL_IREGL_IMMI]+_kids[1]->_cost[IREGL];
        DFA_PRODUCTION__SET_VALID(_XORL__RSHIFTL_IREGL_IMMI_IREGL, _XorL__RShiftL_iRegL_immI_iRegL_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _XORL_IREGL__URSHIFTL_IREGL_IMMI) && STATE__VALID_CHILD(_kids[1], IMML_M1) ) {
      unsigned int c = _kids[0]->_cost[_XORL_IREGL__URSHIFTL_IREGL_IMMI]+_kids[1]->_cost[IMML_M1]+1.9 * INSN_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, XorL_reg_URShift_not_reg_2_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, XorL_reg_URShift_not_reg_2_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R11) || _cost[IREGL_R11] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R11, XorL_reg_URShift_not_reg_2_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IMML_M1) && STATE__VALID_CHILD(_kids[1], _XORL_IREGL__URSHIFTL_IREGL_IMMI) ) {
      unsigned int c = _kids[0]->_cost[IMML_M1]+_kids[1]->_cost[_XORL_IREGL__URSHIFTL_IREGL_IMMI]+1.9 * INSN_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, XorL_reg_URShift_not_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, XorL_reg_URShift_not_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R11) || _cost[IREGL_R11] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R11, XorL_reg_URShift_not_reg_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], _URSHIFTL_IREGL_IMMI) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[_URSHIFTL_IREGL_IMMI];
        DFA_PRODUCTION__SET_VALID(_XORL_IREGL__URSHIFTL_IREGL_IMMI, _XorL_iRegL__URShiftL_iRegL_immI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _XORL__URSHIFTL_IREGL_IMMI_IREGL) && STATE__VALID_CHILD(_kids[1], IMML_M1) ) {
      unsigned int c = _kids[0]->_cost[_XORL__URSHIFTL_IREGL_IMMI_IREGL]+_kids[1]->_cost[IMML_M1]+1.9 * INSN_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, XorL_reg_URShift_not_reg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, XorL_reg_URShift_not_reg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R11) || _cost[IREGL_R11] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R11, XorL_reg_URShift_not_reg_1_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IMML_M1) && STATE__VALID_CHILD(_kids[1], _XORL__URSHIFTL_IREGL_IMMI_IREGL) ) {
      unsigned int c = _kids[0]->_cost[IMML_M1]+_kids[1]->_cost[_XORL__URSHIFTL_IREGL_IMMI_IREGL]+1.9 * INSN_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, XorL_reg_URShift_not_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, XorL_reg_URShift_not_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R11) || _cost[IREGL_R11] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R11, XorL_reg_URShift_not_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _URSHIFTL_IREGL_IMMI) && STATE__VALID_CHILD(_kids[1], IREGL) ) {
      unsigned int c = _kids[0]->_cost[_URSHIFTL_IREGL_IMMI]+_kids[1]->_cost[IREGL];
        DFA_PRODUCTION__SET_VALID(_XORL__URSHIFTL_IREGL_IMMI_IREGL, _XorL__URShiftL_iRegL_immI_iRegL_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LSHIFTL_IREGL_IMMI) && STATE__VALID_CHILD(_kids[1], IMML_M1) ) {
      unsigned int c = _kids[0]->_cost[_LSHIFTL_IREGL_IMMI]+_kids[1]->_cost[IMML_M1];
        DFA_PRODUCTION__SET_VALID(_XORL__LSHIFTL_IREGL_IMMI_IMML_M1, _XorL__LShiftL_iRegL_immI_immL_M1_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _RSHIFTL_IREGL_IMMI) && STATE__VALID_CHILD(_kids[1], IMML_M1) ) {
      unsigned int c = _kids[0]->_cost[_RSHIFTL_IREGL_IMMI]+_kids[1]->_cost[IMML_M1];
        DFA_PRODUCTION__SET_VALID(_XORL__RSHIFTL_IREGL_IMMI_IMML_M1, _XorL__RShiftL_iRegL_immI_immL_M1_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _URSHIFTL_IREGL_IMMI) && STATE__VALID_CHILD(_kids[1], IMML_M1) ) {
      unsigned int c = _kids[0]->_cost[_URSHIFTL_IREGL_IMMI]+_kids[1]->_cost[IMML_M1];
        DFA_PRODUCTION__SET_VALID(_XORL__URSHIFTL_IREGL_IMMI_IMML_M1, _XorL__URShiftL_iRegL_immI_immL_M1_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _XORL_IREGL_IREGL) && STATE__VALID_CHILD(_kids[1], IMML_M1) ) {
      unsigned int c = _kids[0]->_cost[_XORL_IREGL_IREGL]+_kids[1]->_cost[IMML_M1] + INSN_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, XorL_reg_not_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, XorL_reg_not_reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R11) || _cost[IREGL_R11] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R11, XorL_reg_not_reg_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IMML_M1) && STATE__VALID_CHILD(_kids[1], _XORL_IREGL_IREGL) ) {
      unsigned int c = _kids[0]->_cost[IMML_M1]+_kids[1]->_cost[_XORL_IREGL_IREGL] + INSN_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, XorL_reg_not_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, XorL_reg_not_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R11) || _cost[IREGL_R11] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R11, XorL_reg_not_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IREGL) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IREGL];
        DFA_PRODUCTION__SET_VALID(_XORL_IREGL_IREGL, _XorL_iRegL_iRegL_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IMML_M1) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IMML_M1];
        DFA_PRODUCTION__SET_VALID(_XORL_IREGL_IMML_M1, _XorL_iRegL_immL_M1_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IMML_M1) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IMML_M1] + INSN_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION__SET_VALID(IREGLNOSP, regL_not_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL, regL_not_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R11) || _cost[IREGL_R11] > c) {
        DFA_PRODUCTION__SET_VALID(IREGL_R11, regL_not_reg_rule, c)
      }
    }
}
void  State::_sub_Op_AddVB(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 14356 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
n->as_Vector()->length() == 16
#line 10056 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX] + INSN_COST;
        DFA_PRODUCTION__SET_VALID(VECX, vadd16B_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 14341 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
n->as_Vector()->length() == 4 ||
            n->as_Vector()->length() == 8
#line 10066 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD] + INSN_COST;
        DFA_PRODUCTION__SET_VALID(VECD, vadd8B_rule, c)
    }
}
void  State::_sub_Op_AddVS(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _MULVS_VECX_VECX) &&
        (
#line 14744 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
n->as_Vector()->length() == 8
#line 10077 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_MULVS_VECX_VECX] + INSN_COST;
        DFA_PRODUCTION__SET_VALID(VECX, vmla8S_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], _MULVS_VECD_VECD) &&
        (
#line 14729 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
n->as_Vector()->length() == 2 ||
            n->as_Vector()->length() == 4
#line 10087 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[_MULVS_VECD_VECD] + INSN_COST;
        DFA_PRODUCTION__SET_VALID(VECD, vmla4S_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 14385 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
n->as_Vector()->length() == 8
#line 10096 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX] + INSN_COST;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vadd8S_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 14370 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
n->as_Vector()->length() == 2 ||
            n->as_Vector()->length() == 4
#line 10108 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD] + INSN_COST;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vadd4S_rule, c)
      }
    }
}
void  State::_sub_Op_AddVI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _MULVI_VECX_VECX) &&
        (
#line 14772 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
n->as_Vector()->length() == 4
#line 10121 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_MULVI_VECX_VECX] + INSN_COST;
        DFA_PRODUCTION__SET_VALID(VECX, vmla4I_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], _MULVI_VECD_VECD) &&
        (
#line 14758 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
n->as_Vector()->length() == 2
#line 10130 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[_MULVI_VECD_VECD] + INSN_COST;
        DFA_PRODUCTION__SET_VALID(VECD, vmla2I_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 14413 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
n->as_Vector()->length() == 4
#line 10139 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX] + INSN_COST;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vadd4I_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 14399 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
n->as_Vector()->length() == 2
#line 10150 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD] + INSN_COST;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vadd2I_rule, c)
      }
    }
}
void  State::_sub_Op_AddVL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 14427 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
n->as_Vector()->length() == 2
#line 10163 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX] + INSN_COST;
        DFA_PRODUCTION__SET_VALID(VECX, vadd2L_rule, c)
    }
}
void  State::_sub_Op_AddVF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 14455 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
n->as_Vector()->length() == 4
#line 10174 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX] + INSN_COST;
        DFA_PRODUCTION__SET_VALID(VECX, vadd4F_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 14441 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
n->as_Vector()->length() == 2
#line 10183 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD] + INSN_COST;
        DFA_PRODUCTION__SET_VALID(VECD, vadd2F_rule, c)
    }
}
void  State::_sub_Op_AddVD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX] + INSN_COST;
        DFA_PRODUCTION__SET_VALID(VECX, vadd2D_rule, c)
    }
}
void  State::_sub_Op_SubVB(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 14499 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
n->as_Vector()->length() == 16
#line 10200 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX] + INSN_COST;
        DFA_PRODUCTION__SET_VALID(VECX, vsub16B_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 14484 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
n->as_Vector()->length() == 4 ||
            n->as_Vector()->length() == 8
#line 10210 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD] + INSN_COST;
        DFA_PRODUCTION__SET_VALID(VECD, vsub8B_rule, c)
    }
}
void  State::_sub_Op_SubVS(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _MULVS_VECX_VECX) &&
        (
#line 14803 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
n->as_Vector()->length() == 8
#line 10221 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_MULVS_VECX_VECX] + INSN_COST;
        DFA_PRODUCTION__SET_VALID(VECX, vmls8S_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], _MULVS_VECD_VECD) &&
        (
#line 14788 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
n->as_Vector()->length() == 2 ||
            n->as_Vector()->length() == 4
#line 10231 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[_MULVS_VECD_VECD] + INSN_COST;
        DFA_PRODUCTION__SET_VALID(VECD, vmls4S_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 14528 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
n->as_Vector()->length() == 8
#line 10240 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX] + INSN_COST;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsub8S_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 14513 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
n->as_Vector()->length() == 2 ||
            n->as_Vector()->length() == 4
#line 10252 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD] + INSN_COST;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vsub4S_rule, c)
      }
    }
}
void  State::_sub_Op_SubVI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _MULVI_VECX_VECX) &&
        (
#line 14831 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
n->as_Vector()->length() == 4
#line 10265 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_MULVI_VECX_VECX] + INSN_COST;
        DFA_PRODUCTION__SET_VALID(VECX, vmls4I_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], _MULVI_VECD_VECD) &&
        (
#line 14817 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
n->as_Vector()->length() == 2
#line 10274 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[_MULVI_VECD_VECD] + INSN_COST;
        DFA_PRODUCTION__SET_VALID(VECD, vmls2I_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 14556 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
n->as_Vector()->length() == 4
#line 10283 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX] + INSN_COST;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsub4I_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 14542 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
n->as_Vector()->length() == 2
#line 10294 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD] + INSN_COST;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vsub2I_rule, c)
      }
    }
}
void  State::_sub_Op_SubVL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 14570 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
n->as_Vector()->length() == 2
#line 10307 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX] + INSN_COST;
        DFA_PRODUCTION__SET_VALID(VECX, vsub2L_rule, c)
    }
}
void  State::_sub_Op_SubVF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 14598 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
n->as_Vector()->length() == 4
#line 10318 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX] + INSN_COST;
        DFA_PRODUCTION__SET_VALID(VECX, vsub4F_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 14584 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
n->as_Vector()->length() == 2
#line 10327 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD] + INSN_COST;
        DFA_PRODUCTION__SET_VALID(VECD, vsub2F_rule, c)
    }
}
void  State::_sub_Op_SubVD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 14612 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
n->as_Vector()->length() == 2
#line 10338 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX] + INSN_COST;
        DFA_PRODUCTION__SET_VALID(VECX, vsub2D_rule, c)
    }
}
void  State::_sub_Op_MulVS(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX];
        DFA_PRODUCTION__SET_VALID(_MULVS_VECX_VECX, _MulVS_vecX_vecX_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD];
        DFA_PRODUCTION__SET_VALID(_MULVS_VECD_VECD, _MulVS_vecD_vecD_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 14643 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
n->as_Vector()->length() == 8
#line 10357 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX] + INSN_COST;
        DFA_PRODUCTION__SET_VALID(VECX, vmul8S_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 14628 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
n->as_Vector()->length() == 2 ||
            n->as_Vector()->length() == 4
#line 10367 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD] + INSN_COST;
        DFA_PRODUCTION__SET_VALID(VECD, vmul4S_rule, c)
    }
}
void  State::_sub_Op_MulVI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX];
        DFA_PRODUCTION__SET_VALID(_MULVI_VECX_VECX, _MulVI_vecX_vecX_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD];
        DFA_PRODUCTION__SET_VALID(_MULVI_VECD_VECD, _MulVI_vecD_vecD_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 14671 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
n->as_Vector()->length() == 4
#line 10386 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX] + INSN_COST;
        DFA_PRODUCTION__SET_VALID(VECX, vmul4I_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 14657 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
n->as_Vector()->length() == 2
#line 10395 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD] + INSN_COST;
        DFA_PRODUCTION__SET_VALID(VECD, vmul2I_rule, c)
    }
}
void  State::_sub_Op_MulVF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 14699 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
n->as_Vector()->length() == 4
#line 10406 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX] + INSN_COST;
        DFA_PRODUCTION__SET_VALID(VECX, vmul4F_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 14685 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
n->as_Vector()->length() == 2
#line 10415 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD] + INSN_COST;
        DFA_PRODUCTION__SET_VALID(VECD, vmul2F_rule, c)
    }
}
void  State::_sub_Op_MulVD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 14713 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
n->as_Vector()->length() == 2
#line 10426 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX] + INSN_COST;
        DFA_PRODUCTION__SET_VALID(VECX, vmul2D_rule, c)
    }
}
void  State::_sub_Op_DivVF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 14861 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
n->as_Vector()->length() == 4
#line 10437 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX] + INSN_COST;
        DFA_PRODUCTION__SET_VALID(VECX, vdiv4F_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 14847 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
n->as_Vector()->length() == 2
#line 10446 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD] + INSN_COST;
        DFA_PRODUCTION__SET_VALID(VECD, vdiv2F_rule, c)
    }
}
void  State::_sub_Op_DivVD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 14875 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
n->as_Vector()->length() == 2
#line 10457 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX] + INSN_COST;
        DFA_PRODUCTION__SET_VALID(VECX, vdiv2D_rule, c)
    }
}
void  State::_sub_Op_LShiftCntV(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) &&
        (
#line 14993 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
n->as_Vector()->length_in_bytes() == 16
#line 10468 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I] + INSN_COST;
        DFA_PRODUCTION__SET_VALID(VECX, vshiftcnt16B_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) &&
        (
#line 14982 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
n->as_Vector()->length_in_bytes() == 8
#line 10477 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I] + INSN_COST;
        DFA_PRODUCTION__SET_VALID(VECD, vshiftcnt8B_rule, c)
    }
}
void  State::_sub_Op_RShiftCntV(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) &&
        (
#line 14993 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
n->as_Vector()->length_in_bytes() == 16
#line 10488 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I] + INSN_COST;
        DFA_PRODUCTION__SET_VALID(VECX, vshiftcnt16B_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) &&
        (
#line 14982 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
n->as_Vector()->length_in_bytes() == 8
#line 10497 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I] + INSN_COST;
        DFA_PRODUCTION__SET_VALID(VECD, vshiftcnt8B_0_rule, c)
    }
}
void  State::_sub_Op_LShiftVB(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], IMMI) &&
        (
#line 15142 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
n->as_Vector()->length() == 16
#line 10508 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[IMMI] + INSN_COST;
        DFA_PRODUCTION__SET_VALID(VECX, vsll16B_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], IMMI) &&
        (
#line 15122 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
n->as_Vector()->length() == 4 ||
            n->as_Vector()->length() == 8
#line 10518 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[IMMI] + INSN_COST;
        DFA_PRODUCTION__SET_VALID(VECD, vsll8B_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 15018 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
n->as_Vector()->length() == 16
#line 10527 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX] + INSN_COST;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsll16B_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 15004 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
n->as_Vector()->length() == 4 ||
            n->as_Vector()->length() == 8
#line 10539 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD] + INSN_COST;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vsll8B_rule, c)
      }
    }
}
void  State::_sub_Op_LShiftVS(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], IMMI) &&
        (
#line 15348 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
n->as_Vector()->length() == 8
#line 10552 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[IMMI] + INSN_COST;
        DFA_PRODUCTION__SET_VALID(VECX, vsll8S_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], IMMI) &&
        (
#line 15328 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
n->as_Vector()->length() == 2 ||
            n->as_Vector()->length() == 4
#line 10562 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[IMMI] + INSN_COST;
        DFA_PRODUCTION__SET_VALID(VECD, vsll4S_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 15245 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
n->as_Vector()->length() == 8
#line 10571 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX] + INSN_COST;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsll8S_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 15231 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
n->as_Vector()->length() == 2 ||
            n->as_Vector()->length() == 4
#line 10583 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD] + INSN_COST;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vsll4S_rule, c)
      }
    }
}
void  State::_sub_Op_LShiftVI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], IMMI) &&
        (
#line 15544 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
n->as_Vector()->length() == 4
#line 10596 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[IMMI] + INSN_COST;
        DFA_PRODUCTION__SET_VALID(VECX, vsll4I_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], IMMI) &&
        (
#line 15531 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
n->as_Vector()->length() == 2
#line 10605 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[IMMI] + INSN_COST;
        DFA_PRODUCTION__SET_VALID(VECD, vsll2I_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 15450 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
n->as_Vector()->length() == 4
#line 10614 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX] + INSN_COST;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsll4I_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 15437 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
n->as_Vector()->length() == 2
#line 10625 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD] + INSN_COST;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vsll2I_rule, c)
      }
    }
}
void  State::_sub_Op_LShiftVL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], IMMI) &&
        (
#line 15656 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
n->as_Vector()->length() == 2
#line 10638 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[IMMI] + INSN_COST;
        DFA_PRODUCTION__SET_VALID(VECX, vsll2L_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 15609 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
n->as_Vector()->length() == 2
#line 10647 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX] + INSN_COST;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsll2L_rule, c)
      }
    }
}
void  State::_sub_Op_RShiftVB(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], IMMI) &&
        (
#line 15177 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
n->as_Vector()->length() == 16
#line 10660 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[IMMI] + INSN_COST;
        DFA_PRODUCTION__SET_VALID(VECX, vsra16B_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], IMMI) &&
        (
#line 15161 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
n->as_Vector()->length() == 4 ||
            n->as_Vector()->length() == 8
#line 10670 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[IMMI] + INSN_COST;
        DFA_PRODUCTION__SET_VALID(VECD, vsra8B_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 15070 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
n->as_Vector()->length() == 16
#line 10679 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX] + INSN_COST;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsra16B_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 15052 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
n->as_Vector()->length() == 4 ||
            n->as_Vector()->length() == 8
#line 10691 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD] + INSN_COST;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vsra8B_rule, c)
      }
    }
}
void  State::_sub_Op_RShiftVS(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], IMMI) &&
        (
#line 15383 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
n->as_Vector()->length() == 8
#line 10704 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[IMMI] + INSN_COST;
        DFA_PRODUCTION__SET_VALID(VECX, vsra8S_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], IMMI) &&
        (
#line 15367 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
n->as_Vector()->length() == 2 ||
            n->as_Vector()->length() == 4
#line 10714 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[IMMI] + INSN_COST;
        DFA_PRODUCTION__SET_VALID(VECD, vsra4S_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 15276 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
n->as_Vector()->length() == 8
#line 10723 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX] + INSN_COST;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsra8S_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 15258 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
n->as_Vector()->length() == 2 ||
            n->as_Vector()->length() == 4
#line 10735 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD] + INSN_COST;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vsra4S_rule, c)
      }
    }
}
void  State::_sub_Op_RShiftVI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], IMMI) &&
        (
#line 15570 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
n->as_Vector()->length() == 4
#line 10748 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[IMMI] + INSN_COST;
        DFA_PRODUCTION__SET_VALID(VECX, vsra4I_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], IMMI) &&
        (
#line 15557 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
n->as_Vector()->length() == 2
#line 10757 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[IMMI] + INSN_COST;
        DFA_PRODUCTION__SET_VALID(VECD, vsra2I_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 15480 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
n->as_Vector()->length() == 4
#line 10766 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX] + INSN_COST;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsra4I_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 15463 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
n->as_Vector()->length() == 2
#line 10777 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD] + INSN_COST;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vsra2I_rule, c)
      }
    }
}
void  State::_sub_Op_RShiftVL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], IMMI) &&
        (
#line 15669 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
n->as_Vector()->length() == 2
#line 10790 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[IMMI] + INSN_COST;
        DFA_PRODUCTION__SET_VALID(VECX, vsra2L_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 15622 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
n->as_Vector()->length() == 2
#line 10799 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX] + INSN_COST;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsra2L_rule, c)
      }
    }
}
void  State::_sub_Op_URShiftVB(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], IMMI) &&
        (
#line 15212 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
n->as_Vector()->length() == 16
#line 10812 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[IMMI] + INSN_COST;
        DFA_PRODUCTION__SET_VALID(VECX, vsrl16B_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], IMMI) &&
        (
#line 15192 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
n->as_Vector()->length() == 4 ||
            n->as_Vector()->length() == 8
#line 10822 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[IMMI] + INSN_COST;
        DFA_PRODUCTION__SET_VALID(VECD, vsrl8B_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 15105 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
n->as_Vector()->length() == 16
#line 10831 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX] + INSN_COST;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsrl16B_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 15087 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
n->as_Vector()->length() == 4 ||
            n->as_Vector()->length() == 8
#line 10843 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD] + INSN_COST;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vsrl8B_rule, c)
      }
    }
}
void  State::_sub_Op_URShiftVS(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], IMMI) &&
        (
#line 15418 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
n->as_Vector()->length() == 8
#line 10856 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[IMMI] + INSN_COST;
        DFA_PRODUCTION__SET_VALID(VECX, vsrl8S_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], IMMI) &&
        (
#line 15398 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
n->as_Vector()->length() == 2 ||
            n->as_Vector()->length() == 4
#line 10866 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[IMMI] + INSN_COST;
        DFA_PRODUCTION__SET_VALID(VECD, vsrl4S_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 15311 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
n->as_Vector()->length() == 8
#line 10875 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX] + INSN_COST;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsrl8S_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 15293 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
n->as_Vector()->length() == 2 ||
            n->as_Vector()->length() == 4
#line 10887 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD] + INSN_COST;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vsrl4S_rule, c)
      }
    }
}
void  State::_sub_Op_URShiftVI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], IMMI) &&
        (
#line 15596 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
n->as_Vector()->length() == 4
#line 10900 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[IMMI] + INSN_COST;
        DFA_PRODUCTION__SET_VALID(VECX, vsrl4I_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], IMMI) &&
        (
#line 15583 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
n->as_Vector()->length() == 2
#line 10909 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[IMMI] + INSN_COST;
        DFA_PRODUCTION__SET_VALID(VECD, vsrl2I_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 15514 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
n->as_Vector()->length() == 4
#line 10918 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX] + INSN_COST;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsrl4I_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 15497 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
n->as_Vector()->length() == 2
#line 10929 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD] + INSN_COST;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vsrl2I_rule, c)
      }
    }
}
void  State::_sub_Op_URShiftVL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], IMMI) &&
        (
#line 15682 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
n->as_Vector()->length() == 2
#line 10942 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[IMMI] + INSN_COST;
        DFA_PRODUCTION__SET_VALID(VECX, vsrl2L_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 15639 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
n->as_Vector()->length() == 2
#line 10951 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX] + INSN_COST;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsrl2L_rule, c)
      }
    }
}
void  State::_sub_Op_AndV(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 14906 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
n->as_Vector()->length_in_bytes() == 16
#line 10964 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX] + INSN_COST;
        DFA_PRODUCTION__SET_VALID(VECX, vand16B_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 14891 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
n->as_Vector()->length_in_bytes() == 4 ||
            n->as_Vector()->length_in_bytes() == 8
#line 10974 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD] + INSN_COST;
        DFA_PRODUCTION__SET_VALID(VECD, vand8B_rule, c)
    }
}
void  State::_sub_Op_OrV(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 14937 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
n->as_Vector()->length_in_bytes() == 16
#line 10985 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX] + INSN_COST;
        DFA_PRODUCTION__SET_VALID(VECX, vor16B_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 14922 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
n->as_Vector()->length_in_bytes() == 4 ||
            n->as_Vector()->length_in_bytes() == 8
#line 10995 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD] + INSN_COST;
        DFA_PRODUCTION__SET_VALID(VECD, vor8B_rule, c)
    }
}
void  State::_sub_Op_XorV(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 14968 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
n->as_Vector()->length_in_bytes() == 16
#line 11006 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX] + INSN_COST;
        DFA_PRODUCTION__SET_VALID(VECX, vxor16B_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 14953 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
n->as_Vector()->length_in_bytes() == 4 ||
            n->as_Vector()->length_in_bytes() == 8
#line 11016 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD] + INSN_COST;
        DFA_PRODUCTION__SET_VALID(VECD, vxor8B_rule, c)
    }
}
void  State::_sub_Op_LoadVector(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VMEM16) &&
        (
#line 14081 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
n->as_LoadVector()->memory_size() == 16
#line 11027 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VMEM16]+4 * INSN_COST;
        DFA_PRODUCTION__SET_VALID(VECX, loadV16_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VMEM8) &&
        (
#line 14070 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
n->as_LoadVector()->memory_size() == 8
#line 11036 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VMEM8]+4 * INSN_COST;
        DFA_PRODUCTION__SET_VALID(VECD, loadV8_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VMEM4) &&
        (
#line 14059 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
n->as_LoadVector()->memory_size() == 4
#line 11045 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VMEM4]+4 * INSN_COST;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, loadV4_rule, c)
      }
    }
}
void  State::_sub_Op_StoreVector(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VMEM16) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 14114 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
n->as_StoreVector()->memory_size() == 16
#line 11058 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VMEM16]+_kids[1]->_cost[VECX]+4 * INSN_COST;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeV16_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VMEM8) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 14103 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
n->as_StoreVector()->memory_size() == 8
#line 11067 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VMEM8]+_kids[1]->_cost[VECD]+4 * INSN_COST;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeV8_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VMEM4) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 14092 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
n->as_StoreVector()->memory_size() == 4
#line 11078 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VMEM4]+_kids[1]->_cost[VECD]+4 * INSN_COST;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeV4_rule, c)
      }
    }
}
void  State::_sub_Op_ReplicateB(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IMMI) &&
        (
#line 14162 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
n->as_Vector()->length() == 16
#line 11091 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMI] + INSN_COST;
        DFA_PRODUCTION__SET_VALID(VECX, replicate16B_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI) &&
        (
#line 14149 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
n->as_Vector()->length() == 4 ||
            n->as_Vector()->length() == 8
#line 11101 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMI] + INSN_COST;
        DFA_PRODUCTION__SET_VALID(VECD, replicate8B_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) &&
        (
#line 14137 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
n->as_Vector()->length() == 16
#line 11110 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I] + INSN_COST;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, replicate16B_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) &&
        (
#line 14124 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
n->as_Vector()->length() == 4 ||
            n->as_Vector()->length() == 8
#line 11122 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I] + INSN_COST;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, replicate8B_rule, c)
      }
    }
}
void  State::_sub_Op_ReplicateS(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IMMI) &&
        (
#line 14212 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
n->as_Vector()->length() == 8
#line 11135 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMI] + INSN_COST;
        DFA_PRODUCTION__SET_VALID(VECX, replicate8S_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI) &&
        (
#line 14199 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
n->as_Vector()->length() == 2 ||
            n->as_Vector()->length() == 4
#line 11145 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMI] + INSN_COST;
        DFA_PRODUCTION__SET_VALID(VECD, replicate4S_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) &&
        (
#line 14187 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
n->as_Vector()->length() == 8
#line 11154 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I] + INSN_COST;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, replicate8S_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) &&
        (
#line 14174 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
n->as_Vector()->length() == 2 ||
            n->as_Vector()->length() == 4
#line 11166 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I] + INSN_COST;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, replicate4S_rule, c)
      }
    }
}
void  State::_sub_Op_ReplicateI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IMMI0) &&
        (
#line 14284 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
n->as_Vector()->length() == 2
#line 11179 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMI0] + INSN_COST;
        DFA_PRODUCTION__SET_VALID(VECX, replicate2L_zero_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI) &&
        (
#line 14260 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
n->as_Vector()->length() == 4
#line 11188 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMI] + INSN_COST;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, replicate4I_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI) &&
        (
#line 14248 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
n->as_Vector()->length() == 2
#line 11199 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMI] + INSN_COST;
        DFA_PRODUCTION__SET_VALID(VECD, replicate2I_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) &&
        (
#line 14236 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
n->as_Vector()->length() == 4
#line 11208 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I] + INSN_COST;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, replicate4I_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) &&
        (
#line 14224 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
n->as_Vector()->length() == 2
#line 11219 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I] + INSN_COST;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, replicate2I_rule, c)
      }
    }
}
void  State::_sub_Op_ReplicateL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGL) &&
        (
#line 14272 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
n->as_Vector()->length() == 2
#line 11232 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IREGL] + INSN_COST;
        DFA_PRODUCTION__SET_VALID(VECX, replicate2L_rule, c)
    }
}
void  State::_sub_Op_ReplicateF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VREGF) &&
        (
#line 14311 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
n->as_Vector()->length() == 4
#line 11243 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VREGF] + INSN_COST;
        DFA_PRODUCTION__SET_VALID(VECX, replicate4F_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VREGF) &&
        (
#line 14298 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
n->as_Vector()->length() == 2
#line 11252 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VREGF] + INSN_COST;
        DFA_PRODUCTION__SET_VALID(VECD, replicate2F_rule, c)
    }
}
void  State::_sub_Op_ReplicateD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VREGD) &&
        (
#line 14324 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08-5.eln110.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
n->as_Vector()->length() == 2
#line 11263 "../generated/adfiles/dfa_aarch64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VREGD] + INSN_COST;
        DFA_PRODUCTION__SET_VALID(VECX, replicate2D_rule, c)
    }
}
bool State::DFA(int opcode, const Node *n) {
  switch(opcode) {
  case Op_RegN: { _sub_Op_RegN(n);
    break;
  }
  case Op_RegI: { _sub_Op_RegI(n);
    break;
  }
  case Op_RegP: { _sub_Op_RegP(n);
    break;
  }
  case Op_RegF: { _sub_Op_RegF(n);
    break;
  }
  case Op_RegD: { _sub_Op_RegD(n);
    break;
  }
  case Op_RegL: { _sub_Op_RegL(n);
    break;
  }
  case Op_RegFlags: { _sub_Op_RegFlags(n);
    break;
  }
  case Op_VecD: { _sub_Op_VecD(n);
    break;
  }
  case Op_VecX: { _sub_Op_VecX(n);
    break;
  }
  case Op_AbsD: { _sub_Op_AbsD(n);
    break;
  }
  case Op_AbsF: { _sub_Op_AbsF(n);
    break;
  }
  case Op_AddD: { _sub_Op_AddD(n);
    break;
  }
  case Op_AddF: { _sub_Op_AddF(n);
    break;
  }
  case Op_AddI: { _sub_Op_AddI(n);
    break;
  }
  case Op_AddL: { _sub_Op_AddL(n);
    break;
  }
  case Op_AddP: { _sub_Op_AddP(n);
    break;
  }
  case Op_AndI: { _sub_Op_AndI(n);
    break;
  }
  case Op_AndL: { _sub_Op_AndL(n);
    break;
  }
  case Op_AryEq: { _sub_Op_AryEq(n);
    break;
  }
  case Op_Binary: { _sub_Op_Binary(n);
    break;
  }
  case Op_Bool: { _sub_Op_Bool(n);
    break;
  }
  case Op_ReverseBytesI: { _sub_Op_ReverseBytesI(n);
    break;
  }
  case Op_ReverseBytesL: { _sub_Op_ReverseBytesL(n);
    break;
  }
  case Op_ReverseBytesUS: { _sub_Op_ReverseBytesUS(n);
    break;
  }
  case Op_ReverseBytesS: { _sub_Op_ReverseBytesS(n);
    break;
  }
  case Op_CallDynamicJava: { _sub_Op_CallDynamicJava(n);
    break;
  }
  case Op_CallLeaf: { _sub_Op_CallLeaf(n);
    break;
  }
  case Op_CallLeafNoFP: { _sub_Op_CallLeafNoFP(n);
    break;
  }
  case Op_CallRuntime: { _sub_Op_CallRuntime(n);
    break;
  }
  case Op_CallStaticJava: { _sub_Op_CallStaticJava(n);
    break;
  }
  case Op_CastII: { _sub_Op_CastII(n);
    break;
  }
  case Op_CastX2P: { _sub_Op_CastX2P(n);
    break;
  }
  case Op_CastP2X: { _sub_Op_CastP2X(n);
    break;
  }
  case Op_CastPP: { _sub_Op_CastPP(n);
    break;
  }
  case Op_CheckCastPP: { _sub_Op_CheckCastPP(n);
    break;
  }
  case Op_ClearArray: { _sub_Op_ClearArray(n);
    break;
  }
  case Op_CMoveD: { _sub_Op_CMoveD(n);
    break;
  }
  case Op_CMoveF: { _sub_Op_CMoveF(n);
    break;
  }
  case Op_CMoveI: { _sub_Op_CMoveI(n);
    break;
  }
  case Op_CMoveL: { _sub_Op_CMoveL(n);
    break;
  }
  case Op_CMoveP: { _sub_Op_CMoveP(n);
    break;
  }
  case Op_CMoveN: { _sub_Op_CMoveN(n);
    break;
  }
  case Op_CmpN: { _sub_Op_CmpN(n);
    break;
  }
  case Op_CmpD: { _sub_Op_CmpD(n);
    break;
  }
  case Op_CmpD3: { _sub_Op_CmpD3(n);
    break;
  }
  case Op_CmpF: { _sub_Op_CmpF(n);
    break;
  }
  case Op_CmpF3: { _sub_Op_CmpF3(n);
    break;
  }
  case Op_CmpI: { _sub_Op_CmpI(n);
    break;
  }
  case Op_CmpL: { _sub_Op_CmpL(n);
    break;
  }
  case Op_CmpL3: { _sub_Op_CmpL3(n);
    break;
  }
  case Op_CmpLTMask: { _sub_Op_CmpLTMask(n);
    break;
  }
  case Op_CmpP: { _sub_Op_CmpP(n);
    break;
  }
  case Op_CmpU: { _sub_Op_CmpU(n);
    break;
  }
  case Op_CmpUL: { _sub_Op_CmpUL(n);
    break;
  }
  case Op_CompareAndSwapI: { _sub_Op_CompareAndSwapI(n);
    break;
  }
  case Op_CompareAndSwapL: { _sub_Op_CompareAndSwapL(n);
    break;
  }
  case Op_CompareAndSwapP: { _sub_Op_CompareAndSwapP(n);
    break;
  }
  case Op_CompareAndSwapN: { _sub_Op_CompareAndSwapN(n);
    break;
  }
  case Op_GetAndAddI: { _sub_Op_GetAndAddI(n);
    break;
  }
  case Op_GetAndAddL: { _sub_Op_GetAndAddL(n);
    break;
  }
  case Op_GetAndSetI: { _sub_Op_GetAndSetI(n);
    break;
  }
  case Op_GetAndSetL: { _sub_Op_GetAndSetL(n);
    break;
  }
  case Op_GetAndSetP: { _sub_Op_GetAndSetP(n);
    break;
  }
  case Op_GetAndSetN: { _sub_Op_GetAndSetN(n);
    break;
  }
  case Op_ConN: { _sub_Op_ConN(n);
    break;
  }
  case Op_ConNKlass: { _sub_Op_ConNKlass(n);
    break;
  }
  case Op_ConD: { _sub_Op_ConD(n);
    break;
  }
  case Op_ConF: { _sub_Op_ConF(n);
    break;
  }
  case Op_ConI: { _sub_Op_ConI(n);
    break;
  }
  case Op_ConL: { _sub_Op_ConL(n);
    break;
  }
  case Op_ConP: { _sub_Op_ConP(n);
    break;
  }
  case Op_Conv2B: { _sub_Op_Conv2B(n);
    break;
  }
  case Op_ConvD2F: { _sub_Op_ConvD2F(n);
    break;
  }
  case Op_ConvD2I: { _sub_Op_ConvD2I(n);
    break;
  }
  case Op_ConvD2L: { _sub_Op_ConvD2L(n);
    break;
  }
  case Op_ConvF2D: { _sub_Op_ConvF2D(n);
    break;
  }
  case Op_ConvF2I: { _sub_Op_ConvF2I(n);
    break;
  }
  case Op_ConvF2L: { _sub_Op_ConvF2L(n);
    break;
  }
  case Op_ConvI2D: { _sub_Op_ConvI2D(n);
    break;
  }
  case Op_ConvI2F: { _sub_Op_ConvI2F(n);
    break;
  }
  case Op_ConvI2L: { _sub_Op_ConvI2L(n);
    break;
  }
  case Op_ConvL2D: { _sub_Op_ConvL2D(n);
    break;
  }
  case Op_ConvL2F: { _sub_Op_ConvL2F(n);
    break;
  }
  case Op_ConvL2I: { _sub_Op_ConvL2I(n);
    break;
  }
  case Op_CountedLoopEnd: { _sub_Op_CountedLoopEnd(n);
    break;
  }
  case Op_CountLeadingZerosI: { _sub_Op_CountLeadingZerosI(n);
    break;
  }
  case Op_CountLeadingZerosL: { _sub_Op_CountLeadingZerosL(n);
    break;
  }
  case Op_CountTrailingZerosI: { _sub_Op_CountTrailingZerosI(n);
    break;
  }
  case Op_CountTrailingZerosL: { _sub_Op_CountTrailingZerosL(n);
    break;
  }
  case Op_CreateEx: { _sub_Op_CreateEx(n);
    break;
  }
  case Op_DecodeN: { _sub_Op_DecodeN(n);
    break;
  }
  case Op_DecodeNKlass: { _sub_Op_DecodeNKlass(n);
    break;
  }
  case Op_DivD: { _sub_Op_DivD(n);
    break;
  }
  case Op_DivF: { _sub_Op_DivF(n);
    break;
  }
  case Op_DivI: { _sub_Op_DivI(n);
    break;
  }
  case Op_DivL: { _sub_Op_DivL(n);
    break;
  }
  case Op_EncodeISOArray: { _sub_Op_EncodeISOArray(n);
    break;
  }
  case Op_EncodeP: { _sub_Op_EncodeP(n);
    break;
  }
  case Op_EncodePKlass: { _sub_Op_EncodePKlass(n);
    break;
  }
  case Op_FastLock: { _sub_Op_FastLock(n);
    break;
  }
  case Op_FastUnlock: { _sub_Op_FastUnlock(n);
    break;
  }
  case Op_Goto: { _sub_Op_Goto(n);
    break;
  }
  case Op_Halt: { _sub_Op_Halt(n);
    break;
  }
  case Op_If: { _sub_Op_If(n);
    break;
  }
  case Op_LShiftI: { _sub_Op_LShiftI(n);
    break;
  }
  case Op_LShiftL: { _sub_Op_LShiftL(n);
    break;
  }
  case Op_LoadB: { _sub_Op_LoadB(n);
    break;
  }
  case Op_LoadUB: { _sub_Op_LoadUB(n);
    break;
  }
  case Op_LoadUS: { _sub_Op_LoadUS(n);
    break;
  }
  case Op_LoadD: { _sub_Op_LoadD(n);
    break;
  }
  case Op_LoadF: { _sub_Op_LoadF(n);
    break;
  }
  case Op_LoadI: { _sub_Op_LoadI(n);
    break;
  }
  case Op_LoadKlass: { _sub_Op_LoadKlass(n);
    break;
  }
  case Op_LoadNKlass: { _sub_Op_LoadNKlass(n);
    break;
  }
  case Op_LoadL: { _sub_Op_LoadL(n);
    break;
  }
  case Op_LoadPLocked: { _sub_Op_LoadPLocked(n);
    break;
  }
  case Op_LoadP: { _sub_Op_LoadP(n);
    break;
  }
  case Op_LoadN: { _sub_Op_LoadN(n);
    break;
  }
  case Op_LoadRange: { _sub_Op_LoadRange(n);
    break;
  }
  case Op_LoadS: { _sub_Op_LoadS(n);
    break;
  }
  case Op_MaxI: { _sub_Op_MaxI(n);
    break;
  }
  case Op_MemBarAcquire: { _sub_Op_MemBarAcquire(n);
    break;
  }
  case Op_LoadFence: { _sub_Op_LoadFence(n);
    break;
  }
  case Op_MemBarAcquireLock: { _sub_Op_MemBarAcquireLock(n);
    break;
  }
  case Op_MemBarRelease: { _sub_Op_MemBarRelease(n);
    break;
  }
  case Op_StoreFence: { _sub_Op_StoreFence(n);
    break;
  }
  case Op_MemBarReleaseLock: { _sub_Op_MemBarReleaseLock(n);
    break;
  }
  case Op_MemBarVolatile: { _sub_Op_MemBarVolatile(n);
    break;
  }
  case Op_MemBarStoreStore: { _sub_Op_MemBarStoreStore(n);
    break;
  }
  case Op_MinI: { _sub_Op_MinI(n);
    break;
  }
  case Op_ModI: { _sub_Op_ModI(n);
    break;
  }
  case Op_ModL: { _sub_Op_ModL(n);
    break;
  }
  case Op_MoveI2F: { _sub_Op_MoveI2F(n);
    break;
  }
  case Op_MoveF2I: { _sub_Op_MoveF2I(n);
    break;
  }
  case Op_MoveL2D: { _sub_Op_MoveL2D(n);
    break;
  }
  case Op_MoveD2L: { _sub_Op_MoveD2L(n);
    break;
  }
  case Op_MulD: { _sub_Op_MulD(n);
    break;
  }
  case Op_MulF: { _sub_Op_MulF(n);
    break;
  }
  case Op_MulHiL: { _sub_Op_MulHiL(n);
    break;
  }
  case Op_MulI: { _sub_Op_MulI(n);
    break;
  }
  case Op_MulL: { _sub_Op_MulL(n);
    break;
  }
  case Op_NegD: { _sub_Op_NegD(n);
    break;
  }
  case Op_NegF: { _sub_Op_NegF(n);
    break;
  }
  case Op_OrI: { _sub_Op_OrI(n);
    break;
  }
  case Op_OrL: { _sub_Op_OrL(n);
    break;
  }
  case Op_OverflowAddI: { _sub_Op_OverflowAddI(n);
    break;
  }
  case Op_OverflowSubI: { _sub_Op_OverflowSubI(n);
    break;
  }
  case Op_OverflowMulI: { _sub_Op_OverflowMulI(n);
    break;
  }
  case Op_OverflowAddL: { _sub_Op_OverflowAddL(n);
    break;
  }
  case Op_OverflowSubL: { _sub_Op_OverflowSubL(n);
    break;
  }
  case Op_OverflowMulL: { _sub_Op_OverflowMulL(n);
    break;
  }
  case Op_PartialSubtypeCheck: { _sub_Op_PartialSubtypeCheck(n);
    break;
  }
  case Op_PopCountI: { _sub_Op_PopCountI(n);
    break;
  }
  case Op_PopCountL: { _sub_Op_PopCountL(n);
    break;
  }
  case Op_PrefetchAllocation: { _sub_Op_PrefetchAllocation(n);
    break;
  }
  case Op_PrefetchRead: { _sub_Op_PrefetchRead(n);
    break;
  }
  case Op_PrefetchWrite: { _sub_Op_PrefetchWrite(n);
    break;
  }
  case Op_RShiftI: { _sub_Op_RShiftI(n);
    break;
  }
  case Op_RShiftL: { _sub_Op_RShiftL(n);
    break;
  }
  case Op_Rethrow: { _sub_Op_Rethrow(n);
    break;
  }
  case Op_Return: { _sub_Op_Return(n);
    break;
  }
  case Op_SafePoint: { _sub_Op_SafePoint(n);
    break;
  }
  case Op_SqrtD: { _sub_Op_SqrtD(n);
    break;
  }
  case Op_StoreB: { _sub_Op_StoreB(n);
    break;
  }
  case Op_StoreC: { _sub_Op_StoreC(n);
    break;
  }
  case Op_StoreCM: { _sub_Op_StoreCM(n);
    break;
  }
  case Op_StorePConditional: { _sub_Op_StorePConditional(n);
    break;
  }
  case Op_StoreIConditional: { _sub_Op_StoreIConditional(n);
    break;
  }
  case Op_StoreLConditional: { _sub_Op_StoreLConditional(n);
    break;
  }
  case Op_StoreD: { _sub_Op_StoreD(n);
    break;
  }
  case Op_StoreF: { _sub_Op_StoreF(n);
    break;
  }
  case Op_StoreI: { _sub_Op_StoreI(n);
    break;
  }
  case Op_StoreL: { _sub_Op_StoreL(n);
    break;
  }
  case Op_StoreP: { _sub_Op_StoreP(n);
    break;
  }
  case Op_StoreN: { _sub_Op_StoreN(n);
    break;
  }
  case Op_StoreNKlass: { _sub_Op_StoreNKlass(n);
    break;
  }
  case Op_StrComp: { _sub_Op_StrComp(n);
    break;
  }
  case Op_StrEquals: { _sub_Op_StrEquals(n);
    break;
  }
  case Op_StrIndexOf: { _sub_Op_StrIndexOf(n);
    break;
  }
  case Op_SubD: { _sub_Op_SubD(n);
    break;
  }
  case Op_SubF: { _sub_Op_SubF(n);
    break;
  }
  case Op_SubI: { _sub_Op_SubI(n);
    break;
  }
  case Op_SubL: { _sub_Op_SubL(n);
    break;
  }
  case Op_TailCall: { _sub_Op_TailCall(n);
    break;
  }
  case Op_TailJump: { _sub_Op_TailJump(n);
    break;
  }
  case Op_ThreadLocal: { _sub_Op_ThreadLocal(n);
    break;
  }
  case Op_URShiftI: { _sub_Op_URShiftI(n);
    break;
  }
  case Op_URShiftL: { _sub_Op_URShiftL(n);
    break;
  }
  case Op_XorI: { _sub_Op_XorI(n);
    break;
  }
  case Op_XorL: { _sub_Op_XorL(n);
    break;
  }
  case Op_AddVB: { _sub_Op_AddVB(n);
    break;
  }
  case Op_AddVS: { _sub_Op_AddVS(n);
    break;
  }
  case Op_AddVI: { _sub_Op_AddVI(n);
    break;
  }
  case Op_AddVL: { _sub_Op_AddVL(n);
    break;
  }
  case Op_AddVF: { _sub_Op_AddVF(n);
    break;
  }
  case Op_AddVD: { _sub_Op_AddVD(n);
    break;
  }
  case Op_SubVB: { _sub_Op_SubVB(n);
    break;
  }
  case Op_SubVS: { _sub_Op_SubVS(n);
    break;
  }
  case Op_SubVI: { _sub_Op_SubVI(n);
    break;
  }
  case Op_SubVL: { _sub_Op_SubVL(n);
    break;
  }
  case Op_SubVF: { _sub_Op_SubVF(n);
    break;
  }
  case Op_SubVD: { _sub_Op_SubVD(n);
    break;
  }
  case Op_MulVS: { _sub_Op_MulVS(n);
    break;
  }
  case Op_MulVI: { _sub_Op_MulVI(n);
    break;
  }
  case Op_MulVF: { _sub_Op_MulVF(n);
    break;
  }
  case Op_MulVD: { _sub_Op_MulVD(n);
    break;
  }
  case Op_DivVF: { _sub_Op_DivVF(n);
    break;
  }
  case Op_DivVD: { _sub_Op_DivVD(n);
    break;
  }
  case Op_LShiftCntV: { _sub_Op_LShiftCntV(n);
    break;
  }
  case Op_RShiftCntV: { _sub_Op_RShiftCntV(n);
    break;
  }
  case Op_LShiftVB: { _sub_Op_LShiftVB(n);
    break;
  }
  case Op_LShiftVS: { _sub_Op_LShiftVS(n);
    break;
  }
  case Op_LShiftVI: { _sub_Op_LShiftVI(n);
    break;
  }
  case Op_LShiftVL: { _sub_Op_LShiftVL(n);
    break;
  }
  case Op_RShiftVB: { _sub_Op_RShiftVB(n);
    break;
  }
  case Op_RShiftVS: { _sub_Op_RShiftVS(n);
    break;
  }
  case Op_RShiftVI: { _sub_Op_RShiftVI(n);
    break;
  }
  case Op_RShiftVL: { _sub_Op_RShiftVL(n);
    break;
  }
  case Op_URShiftVB: { _sub_Op_URShiftVB(n);
    break;
  }
  case Op_URShiftVS: { _sub_Op_URShiftVS(n);
    break;
  }
  case Op_URShiftVI: { _sub_Op_URShiftVI(n);
    break;
  }
  case Op_URShiftVL: { _sub_Op_URShiftVL(n);
    break;
  }
  case Op_AndV: { _sub_Op_AndV(n);
    break;
  }
  case Op_OrV: { _sub_Op_OrV(n);
    break;
  }
  case Op_XorV: { _sub_Op_XorV(n);
    break;
  }
  case Op_LoadVector: { _sub_Op_LoadVector(n);
    break;
  }
  case Op_StoreVector: { _sub_Op_StoreVector(n);
    break;
  }
  case Op_ReplicateB: { _sub_Op_ReplicateB(n);
    break;
  }
  case Op_ReplicateS: { _sub_Op_ReplicateS(n);
    break;
  }
  case Op_ReplicateI: { _sub_Op_ReplicateI(n);
    break;
  }
  case Op_ReplicateL: { _sub_Op_ReplicateL(n);
    break;
  }
  case Op_ReplicateF: { _sub_Op_ReplicateF(n);
    break;
  }
  case Op_ReplicateD: { _sub_Op_ReplicateD(n);
    break;
  }
  
  default:
    tty->print("Default case invoked for: \n");
    tty->print("   opcode  = %d, \"%s\"\n", opcode, NodeClassNames[opcode]);
    return false;
  }
  return true;
}
